2009-12-09  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

       Fix 2.65 AC_TYPE_INT*_T macro body text regression.
       * lib/autoconf/types.m4 (_AC_TYPE_INT_BODY): Move helper enum
       definition to prologue section, to avoid syntax error.
       * NEWS, THANKS: Update.
       Report by Pierre Ynard.

2009-11-21  Eric Blake  <ebb9@byu.net>

	Release Version 2.65.
	* NEWS: Mention the release.

	Prepare for release.
	* build-aux/announce-gen: Sync from upstream.
	* build-aux/config.guess: Likewise.
	* build-aux/config.sub: Likewise.
	* cfg.mk (gnu_rel_host, url_dir_list): Move...
	* maint.mk: ...here, copying ideas from gnulib.
	(major): Rename...
	(stable): ...to this, copying gnulib.
	* HACKING (release): Document changes in process.

	Avoid spurious newline in traced macros.
	* bin/autoreconf.in (tracing): Drop newline before parsing traced
	arguments; regression from 2009-11-14.

2009-11-20  Eric Blake  <ebb9@byu.net>

	Allow absolute names in AT_TESTED.
	* lib/autotest/general.m4 (AT_INIT) <PREPARE_TESTS>: Check for
	absolute names before path walk.
	* THANKS: Update.
	Suggested by Allan Clark.

2009-11-14  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix AC_CONFIG_SUBDIRS tracing in autoreconf.
	* bin/autoreconf.in (autoreconf_current_directory): Collapse
	newlines in the autoconf trace output, similar to how automake
	invokes autoconf, so that newlines do not matter in the argument
	to AC_CONFIG_SUBDIRS.
	* tests/torture.at (Deep Package): Expose this issue in the
	test.
	* THANKS: Update.
	Report by Nathan Schulte.

2009-11-09  Eric Blake  <ebb9@byu.net>

	Fix AC_FUNC_MMAP for cygwin.
	* lib/autoconf/functions.m4 (AC_FUNC_MMAP): Make the test more
	portable: Actually check for <sys/param.h>, and only use MAP_FIXED
	on an address previously returned from mmap.
	* THANKS: Update.
	Reported by Corinna Vinschen.

2009-11-04  Eric Blake  <ebb9@byu.net>

	Redocument AS_DIRNAME, even with its flaws.
	* doc/autoconf.texi (Common Shell Constructs) <AS_DIRNAME>:
	Restore documenatation, since dirname mentions it.
	Reported by Peter Johansson.

	Update upstream files.
	* build-aux/announce-gen: Synchronize from upstream.
	* build-aux/config.guess: Likewise.
	* build-aux/config.sub: Likewise.
	* build-aux/gendocs.sh: Likewise.
	* build-aux/git-version-gen: Likewise.
	* build-aux/texinfo.tex: Likewise.
	* build-aux/update-copyright: Likewise.
	* doc/standards.texi: Likewise.
	* lib/Autom4te/Channels.pm: Likewise.
	* lib/Autom4te/Configure_ac.pm: Likewise.
	* lib/Autom4te/FileUtils.pm: Likewise.
	* lib/Autom4te/Struct.pm: Likewise.
	* lib/Autom4te/XFile.pm: Likewise.

2009-11-04  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Coverage for autom4te cache creation issues.
	* tests/tools.at (autom4te cache creation): New test.

2009-11-03  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix testsuite failures with SHELL=zsh.
	* tests/statesave.m4 (AC_STATE_SAVE): Ignore argv and ARGC when
	comparing configure variables.

2009-11-03  Eric Blake  <ebb9@byu.net>
	and Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Update NEWS for recent fixes.
	* NEWS: Add some entries.

2009-10-31  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Micro-optimization of config.status substitution.
	* lib/autoconf/status.m4 (_AC_OUTPUT_FILES_PREPARE): No need to
	concatenate an empty second string, when we have exactly 148
	characters to substitute.
	* tests/torture.at (Substitute a 2000-byte string): Add test
	exposure for runs of backslashes near the 148 character limit.

	Fix testsuite failure on AIX 4.3.3.
	* lib/autoconf/general.m4 (_AC_RUN_LOG_LIMIT): Remove conftest.err
	also if it is empty.

	Fix testsuite failure on IRIX and AIX.
	* tests/torture.at (Substitute and define special characters):
	Double the backslash before the double-quote in
	AC_DEFINE_UNQUOTED, as documented for here-documents.

2009-10-31  Eric Blake  <ebb9@byu.net>

	Fix cross-manual link to gcc.
	* doc/autoconf.texi (Portable C and C++): Provide uref rather than
	xref when building for html.
	Reported via Karl Berry.

	Update authors.
	* AUTHORS: Document recent copyright assignments.

2009-10-31  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix AC_OPENMP configure message for non-C compilers.
	* lib/autoconf/lang.m4 (AC_LANG_DEFINE): Accept as additional
	fourth arg the compiler variable name, defined in _AC_CC($1).
	(_AC_CC): New language dispatch macro.
	* lib/autoconf/erlang.m4 (AC_LANG(Erlang)): Adjust.
	* lib/autoconf/fortran.m4 (AC_LANG(Fortran 77), AC_LANG(Fortran)):
	Likewise.
	* lib/autoconf/c.m4 (AC_LANG(C), AC_LANG(C++))
	(AC_LANG(Objective C), AC_LANG(Objective C++)): Likewise.
	(AC_OPENMP): Use _AC_CC instead of $CC.

	Do not fail OpenMP tests on systems without aclocal.
	* tests/c.at (AC_OPENMP and C, AC_OPENMP and C++): Override
	`ACLOCAL=true' for autoreconf, the tests don't need aclocal.
	* tests/fortran.at (AC_OPENMP and Fortran 77)
	(AC_OPENMP and Fortran): Likewise.

2009-10-31  Bruno Haible  <bruno@clisp.org>
	    Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Improve cache variable documentation.
	* doc/autoconf.texi (AC_PROG_AWK, AC_PROG_GREP, AC_PROG_EGREP,
	AC_PROG_FGREP, AC_PROG_INSTALL, AC_PROG_MKDIR_P, AC_PROG_LEX,
	AC_PROG_YACC, AC_CHECK_PROG, AC_CHECK_PROGS, AC_PATH_PROG,
	AC_PATH_PROGS): Don't suggest to use the cache variable, only to
	override it, or preferably, a non-cache variable associated with
	the test.
	(AC_PROG_SED): Likewise. Fix name of cache variable.
	(AC_FUNC_GETMNTENT): Fix name cache variable.
	(AC_FUNC_LSTAT): Fix typo.

2009-10-31  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix AC_OPENMP for Fortran (F77 and FC).
	* lib/autoconf/fortran.m4 (AC_LANG_FUNC_LINK_TRY(Fortran): New.
	* tests/c.at (AC_C_RESTRICT and C++, AC_OPENMP and C)
	(AC_OPENMP and C++): New tests.
	* tests/fortran.at (AC_OPENMP and Fortran 77)
	(AC_OPENMP and Fortran): New tests.
	* THANKS: Update.
	Report by Bart Oldeman.

	Perl coverage convenience targets.
	* Makefile.am (PERL_COVERAGE_DB, PERL_COVERAGE_FLAGS)
	(PERL_COVER): New variables.
	(check-coverage, check-coverage-run, check-coverage-report)
	(clean-coverage): New phony targets.
	(clean-local): Depend on clean-coverage.

2009-10-28  Eric Blake  <ebb9@byu.net>

	Fix corner cases in AS_LITERAL_IF and AS_TR_SH.
	* lib/m4sugar/m4sh.m4 (AS_LITERAL_IF): Fix bug with unbalanced
	parens.  Move guts...
	(_AS_LITERAL_IF): into new helper.
	(AS_TR_SH, AS_TR_CPP): Fix bugs with expansion of wrong macro.
	Move guts...
	(_AS_TR_SH, _AS_TR_SH_LITERAL, _AS_TR_SH_INDIR, _AS_TR_CPP)
	(_AS_TR_CPP_LITERAL, _AS_TR_CPP_INDIR): ...into new helpers.
	(AS_VAR_PUSHDEF): Hoist m4_require, by moving guts...
	(_AS_VAR_PUSHDEF): ...into new helper.
	* tests/m4sh.at (AS@&t@_LITERAL_IF): Enhance test.

	Minor optimizations to m4sh.
	* lib/m4sugar/m4sh.m4 (AS_VAR_IF, AS_IDENTIFIER_IF)
	(AS_LITERAL_IF): Parse fewer bytes during expansion, by visiting
	if-true and if-false arguments only once.

	Optimize m4_escape for common case.
	* lib/m4sugar/m4sugar.m4 (m4_escape): Don't use regex if string is
	already sane, by copying from AS_LITERAL_IF.  Move guts...
	(_m4_escape): ...into new helper.

	Fix m4_text_wrap handling of quoted whitespace.
	* lib/m4sugar/m4sugar.m4 (m4_escape): New macro.
	(m4_text_wrap): Use it to avoid issues with embedded [ and ].
	* tests/m4sugar.at (m4@&t@_text_wrap): Test it.
	* NEWS: Document this.
	* doc/autoconf.texi (Text processing Macros) <m4_escape>:
	Likewise.
	Reported by Mike Frysinger.

2009-10-27  Eric Blake  <ebb9@byu.net>

	Mention another feature of AC_RUN_IFELSE.
	* doc/autoconf.texi (Runtime) <AC_RUN_IFELSE>: Mention that
	compiled test program still exists during if-true branch.
	* THANKS: Update.
	Reported by Stefano Lattarini, suggestion by Ralf Wildenhues.

2009-10-26  Paolo Bonzini  <bonzini@gnu.org>

	Pass Autom4te path down to programs that autoreconf invokes.
	* bin/autoreconf.in (autom4te): New variable.  Export its value
	as $ENV{'AUTOM4TE'}.  Suggested by Peter Johansson.
	* THANKS: Update.

2009-10-20  Eric Blake  <ebb9@byu.net>

	Fix AC_TYPE_UINT64_T on Tru64 with gcc 3.4.4.
	* lib/autoconf/types.m4 (_AC_TYPE_UNSIGNED_INT_BODY)
	(_AC_TYPE_INT_BODY): Avoid undefined behavior of attempting shift
	wider than type.
	* NEWS: Document this.
	Reported by Rainer Orth.

2009-10-17  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix a couple of index entries in the manual.
	* doc/autoconf.texi (Polymorphic Variables): Fix index entries
	for AS_VAR_APPEND, AS_VAR_ARITH.

2009-10-15  Eric Blake  <ebb9@byu.net>

	Fix typos in INSTALL.
	* doc/install.texi (Basic Installation, Installation Names): Fix
	typos in last patch.
	Repored by Ralf Wildenhues.

	Improve INSTALL wording.
	* doc/install.texi (Basic Installation): Clarify installcheck
	behavior.
	(Installation Names): Mention that --prefix only overrides
	directory locations not specified on the command line.  Prefer
	/alternate/directory over /path/to.  Remove a sentence targeted to
	the developer, not the user.
	* THANKS: Update.
	Suggested by Alfred M. Szmidt.

2009-10-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Fix typos in documentation.
	* doc/autoconf.texi (Cache Variable Index): Fix typo.
	(Libraries) <AC_SEARCH_LIBS>: Mention 'none required' result.

2009-10-09  Bruno Haible  <bruno@clisp.org>
	    Ralf Wildenhues <Ralf.Wildenhues@gmx.de>

	Recommend `sh -n' debugging, and public result variables for macros.
	* doc/autoconf.texi (Debugging): Recommend to use "bash -n
	configure".  Recommend the use of result variables as an
	alternative to run-if-true/run-if-false parameters.

2009-10-05  Bruno Haible  <bruno@clisp.org>

	* doc/autoconf.texi (Particular Functions): Swap sections about
	AC_FUNC_MBRTOWC and AC_FUNC_MEMCMP.

2009-10-01  Paolo Bonzini  <bonzini@gnu.org>

	Unconditionally check for junk ./--version after mkdir search loop.
	* lib/autoconf/programs.m4 (AC_PROG_MKDIR_P): Always check for
	presence of ./--version.  Reported by Eric Blake.

2009-09-22  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Clarify documentation about Solaris sed quantifier restriction.
	* doc/autoconf.texi (Limitations of Usual Tools) <sed>: '*' does
	not work after subexpressions, \{M,N\} only after one-character
	expressions.  From GCC PR 38923.

2009-09-21  Eric Blake  <ebb9@byu.net>

	Fit configure output in 80 columns.
	* lib/autoconf/functions.m4
	(AC_FUNC_LSTAT_FOLLOWS_SLASHED_SYMLINK): Shorten message.

2009-09-18  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Use consistent notation for cache variables.
	* doc/autoconf.texi (Generic Programs): Remove `$' before
	variable name.

	Documentation of specific and general cache variables.
	* doc/autoconf.texi (Default Includes, Alternative Programs)
	(Particular Programs, Generic Programs, Files, Libraries)
	(Function Portability, Particular Functions, Generic Functions)
	(Particular Headers, Generic Headers, Declarations)
	(Generic Declarations, Particular Structures, Particular Types)
	(Specific Compiler Characteristics)
	(Generic Compiler Characteristics, C Compiler, System Services):
	Document lots of cache variables.
	* NEWS: Update.
	Suggested by Bruno Haible.

	New cache variable index in the manual.
	* doc/autoconf.texi: Define new index `CA' for cache variables.
	(caindex): New macro.
	(Cache Variable Index): New appendix node.
	(Top, Indices): Adjust menus.
	(Cache Variable Names, Site Defaults): Adjust text.
	* doc/Makefile.am (CLEANFILES): Add files generated for CA index.

	New FAQ node: Debugging.
	* doc/autoconf.texi (Debugging): New node.
	(Top, FAQ): Adjust menus.
	Report by Bruno Haible.

	Document AM_MAKEFLAGS workaround to the macro override problem.
	* doc/autoconf.texi (Macros and Submakes): Automake makefiles
	provide AM_MAKEFLAGS to help with overriding macros in submake
	invocations.
	Prompted by bug report from Bruno Haible.

2009-09-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Implement and document Objective C++ support.
	* lib/autoconf/c.m4 (AC_LANG(Objective C++), AC_LANG_OBJCXX)
	(AC_LANG_PREPROC(Objective C++), AC_PROG_OBJCXXCPP)
	(AC_LANG_COMPILER(Objective C++), AC_PROG_OBJCXX)
	(_AC_PROG_OBJCXX_G): New macros.
	(_AC_ARG_VAR_CPPFLAGS, _AC_ARG_VAR_LDFLAGS)
	(_AC_ARG_VAR_LIBS): Adjusted.
	* doc/autoconf.texi (Objective C++ Compiler): New node.
	(Preset Output Variables): Document OBJCXXFLAGS.
	(Language Choice): Document `Objective C++' language.
	* NEWS: Updated.
	* tests/local.at (AT_CHECK_ENV): Ignore AC_SUBSTed Objective C++
	related variables.

2009-09-15  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Work around DJGPP shell function return bug with command substitutions.
	DJGPP bash 2.04 has a bug in that `return $ac_retval' done in a
	shell function which also contains a command substitution causes
	the shell to barf.  For more details and a fix see:
	<http://www.delorie.com/djgpp/mail-archives/browse.cgi?p=djgpp-workers/2009/09/09/03:35:08>
	Possible workaround include putting the `return' in a subshell
	or calling another function to set the status.
	* lib/autoconf/general.m4 (_AC_PREPROC_IFELSE_BODY)
	(_AC_COMPILE_IFELSE_BODY, _AC_LINK_IFELSE_BODY)
	(_AC_RUN_IFELSE_BODY, _AC_COMPUTE_INT_BODY): Use AS_SET_STATUS
	instead of `return'.
	* doc/autoconf.texi (Common Shell Constructs, Shell Functions):
	Document the issue.
	* THANKS: Update.
	Report by Rugxulo and Reuben Thomas.

	DJGPP fix: Do not redirect standard input in configure scripts.
	* lib/autoconf/general.m4 (_AC_INIT_DEFAULTS): If $DJGPP is
	nonempty, do not dup fd 0 to AS_ORIGINAL_STDIN_FD, do not close
	fd 0.

2009-09-14  Eric Blake  <ebb9@byu.net>

	Quote result of m4_toupper and m4_tolower.
	* lib/m4sugar/m4sugar.m4 (m4_tolower, m4_toupper): Quote result.
	* lib/autotest/general.m4 (AT_KEYWORDS): Adjust caller.
	* tests/m4sugar.at (m4@&t@_toupper and m4@&t@_tolower): New test.
	* NEWS: Document this.
	* THANKS: Update.
	Reported by Sam Steingold.

2009-09-14  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	DJGPP fix: remove both conftest and conftest.exe.
	The DJGPP compiler may create both `a.out' and `a.exe' without -o,
	and both `conftest' and `conftest.exe' with `-o conftest', but not
	with `-o conftest.exe'.
	* lib/autoconf/lang.m4 (_AC_COMPILER_EXEEXT_O): Also remove
	`conftest' without $ac_exeext suffix.

	DJGPP fix: do not try to source /dev/null as cache or site file.
	* lib/autoconf/general.m4 (AC_SITE_LOAD, AC_CACHE_LOAD): Do not
	load the cache or site file if it is `/dev/null', as DJGPP treats
	it as a regular file, but the shell then warns about it later.
	Fixes several test suite failures on DJGPP.

	testsuite: pass $configure_options to configure invocations.
	* tests/local.at (AT_CHECK_CONFIGURE): Add $configure_options
	to configure command line.
	* tests/autotest.at, tests/base.at, tests/c.at, tests/torture.at:
	Likewise for each configure invocation.
	* README-hacking: Document configure_options.

	testsuite: improve Erlang tests portability, overridability.
	* tests/autotest.at (Erlang Eunit unit tests): Use "no" as
	value-if-not-found for Erlang tools.
	* tests/erlang.at: Likewise.  Also, use AS_EXIT instead of plain
	exit.

2009-09-13  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* bin/autoupdate.in: Fix typos in comments.

	Improve autotest testsuite summary message.
	* lib/autotest/general.m4 (AT_INIT): Hint at the toplevel log
	only if not $at_debug_p.  Always hint at the per-test output.

	Four new autoupdate tests, expected failures.
	* tests/tools.at (autoupdating macros recursively)
	(autoupdating with m4@&t@_pushdef, autoupdating with AC_REQUIRE)
	(autoupdating with complex quoting): New tests.

	Fix description of AC_CHECK_LIB regarding other deplibs.
	* doc/autoconf.texi (Libraries): Library linking may not fail
	even without missing additional libs.

2009-09-12  Eric Blake  <ebb9@byu.net>

	Track recent copyright assignments.
	* AUTHORS: Update.

	Improve documentation on quoting.
	* doc/autoconf.texi (Autoconf Language): Clarify quoting example.
	* THANKS: Update.
	Reported by santilín.

2009-09-11  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	New config.status option --config.
	* lib/autoconf/status.m4 (_AC_OUTPUT_CONFIG_STATUS): Implement
	--config.
	* doc/autoconf.texi (config.status Invocation): Document it.
	* NEWS: Update.
	* tests/torture.at (configure invocation): Test it.
	Suggested several times, by several people, in the past.

2009-09-10  Eric Blake  <ebb9@byu.net>

	Document that AS_INIT is automatically used.
	* doc/autoconf.texi (Initialization Macros) <AS_INIT>: Add words
	to clarify that only bare-bones scripts need a direct AS_INIT.
	Suggested by Reuben Thomas.

	Clarify portability pitfall of test.
	* doc/autoconf.texi (Limitations of Builtins) <test>: Give more
	reasons why -a and -o are not portable.
	Reported by Reuben Thomas.

2009-09-10  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Document sed limitation with escaped metacharacters.
	* doc/autoconf.texi (Limitations of Usual Tools) <sed>: Use `%'
	rather than `/' as delimiter in an example `s' command.
	Document inconsistent treatment of escaped metacharacters.
	* THANKS: Update.
	Report by Dave Korn, with additional input from Paolo Bonzini
	and Eric Blake.

	Document temporary directory `$tmp' for use in config.status.
	* doc/autoconf.texi (Configuration Actions): Document `$tmp'.
	* NEWS: Update.

2009-09-09  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Update License to GPLv3+ including new Autoconf Exception.
	* NEWS, README: Update licensing information.
	* COPYING.EXCEPTION: New file.
	* Makefile.am (EXTRA_DIST): Distribute it.
	* cfg.mk (autom4te-update): Remove copyright change warning.
	* lib/autoconf/autoconf.m4, lib/autoconf/autoheader.m4,
	lib/autoconf/autoscan.m4, lib/autoconf/autotest.m4,
	lib/autoconf/autoupdate.m4, lib/autoconf/c.m4,
	lib/autoconf/erlang.m4, lib/autoconf/fortran.m4,
	lib/autoconf/functions.m4, lib/autoconf/general.m4,
	lib/autoconf/headers.m4, lib/autoconf/lang.m4,
	lib/autoconf/libs.m4, lib/autoconf/oldnames.m4,
	lib/autoconf/programs.m4, lib/autoconf/specific.m4,
	lib/autoconf/status.m4, lib/autoconf/types.m4,
	lib/autotest/autotest.m4, lib/autotest/general.m4,
	lib/autotest/specific.m4, lib/m4sugar/foreach.m4,
	lib/m4sugar/m4sh.m4, lib/m4sugar/m4sugar.m4: Update exception
	statement, bump to GPLv3.
	* bin/autoconf.as, bin/autoheader.in, bin/autom4te.in,
	bin/autoreconf.in, bin/autoscan.in, bin/autoupdate.in,
	bin/ifnames.in: Bump to GPLv3+, adjust --version output
	to reflect the GPLv3+ and the Autoconf Exception.
	* lib/Autom4te/C4che.pm, lib/Autom4te/ChannelDefs.pm,
	lib/Autom4te/General.pm, lib/Autom4te/Request.pm,
	lib/autom4te.in, lib/autoscan/autoscan.pre,
	lib/emacs/autoconf-mode.el, lib/emacs/autotest-mode.el,
	lib/freeze.mk, tests/atlocal.in, tests/autoscan.at,
	tests/autotest.at, tests/base.at, tests/c.at,
	tests/compile.at, tests/erlang.at, tests/foreign.at,
	tests/fortran.at, tests/local.at, tests/m4sh.at,
	tests/m4sugar.at, tests/mktests.sh, tests/semantics.at,
	tests/statesave.m4, tests/suite.at, tests/tools.at,
	tests/torture.at, tests/wrapper.as: Bump to GPLv3+.

	Allow to work on systems without Fcntl::flock implementation.
	* configure.ac (PERL_FLOCK): New substitution variable with test
	whether Fcntl::flock is implemented by the system.
	* bin/Makefile.am (edit): Substitute @PERL_FLOCK@.
	* bin/autom4te.in: Call XFile::lock only if flock is
	implemented.

2009-09-04  Reuben Thomas <rrt@sc3d.org>  (tiny change)

	Mention the Autoconf archive.
	* doc/autoconf.texi (Coding Style): Add a link.

2009-08-30  Bruno Haible  <bruno@clisp.org>

	Document another Solaris tr pitfall.
	* doc/autoconf.texi (Limitations of Usual Tools) <tr>: Mention
	that Solaris /usr/bin/tr does not only have problems with
	replacing NUL bytes but discards all NUL bytes from the input.

2009-09-04  Eric Blake  <ebb9@byu.net>

	Improve wording about what goes before AC_INIT.
	* doc/autoconf.texi (Initializing configure): Update wording.
	(Versioning) <AC_PREREQ>: Remove misleading text, to match
	autoscan's behavior.
	* THANKS: Update.
	Reported by NightStrike, with input from Ralf Wildenhues.

2009-09-04  Thomas Jahns  <jahns@dkrz.de>  (tiny change)

	Fix illegal tab character in Fortran source.
	* lib/autoconf/fortran.m4 (AC_FC_SRCEXT): Change TAB back to
	multiple spaces; regression introduced 2008-10-23.
	* NEWS: Mention this.
	* THANKS: Update.

2009-08-22  Romain Lenglet  <romain.lenglet@laposte.net>

	Fix AT_CHECK_EUNIT for versions of Erlang/OTP without init:stop/1.
	* lib/autotest/specific.m4 (AT_CHECK_EUNIT): Support older
	versions of Erlang/OTP with an erlang:stop() function that doesn't
	take arguments.

2009-08-22  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Drop unneeded line in Eunit test.
	* tests/autotest.at (Erlang Eunit unit tests): Do not copy
	install-sh.

	Fix build dependencies for Erlang macro files.
	* lib/freeze.mk (autotest_m4f_dependencies): Add
	$(src_libdir)/autotest/specific.m4.
	* tests/Makefile.am (AUTOCONF_FILES): Add erlang.m4.

2009-09-19  Paolo Bonzini  <bonzini@gnu.org>

	Use a separate program to test whether the compiler works.
	* lib/autoconf/erlang.m4 (_AC_LANG_NULL_PROGRAM(Erlang)): New.
	* lib/autoconf/lang.m4 (AC_LANG_DEFINE): Copy _AC_LANG_NULL_PROGRAM.
	(_AC_LANG_NULL_PROGRAM(), _AC_LANG_NULL_PROGRAM): New.
	(_AC_COMPILER_EXEEXT_DEFAULT): Print here "whether the xyz compiler
	works", before exiting.
	(_AC_COMPILER_EXEEXT_WORKS): Merge into _AC_COMPILER_EXEEXT_CROSS,
	remove the "whether the xyz compiler works" message, use
	conftest$ac_cv_exeext instead of $ac_file.
	(_AC_COMPILER_EXEEXT): Try _AC_COMPILER_EXEEXT_DEFAULT using
	the null program, and clean conftest.out only after
	_AC_COMPILER_EXEEXT_CROSS.
	(AC_NO_EXECUTABLES): Use _AC_LANG_NULL_PROGRAM.
	(_AC_COMPILER_OBJEXT): Use _AC_LANG_NULL_PROGRAM.

2009-08-18  Bruno Haible  <bruno@clisp.org>

	Document Solaris tr range and NUL limitations.
	* doc/autoconf.texi (Limitations of Usual Tools): Mention that
	Solaris /usr/bin/tr does not support ranges, nor the '\0' octal
	escape.

2009-08-14  Eric Blake  <ebb9@byu.net>

	Simplify version control metadata.
	* .cvsignore: Delete.
	* bin/.cvsignore: Likewise.
	* config/.cvsignore: Likewise.
	* doc/.cvsignore: Likewise.
	* lib/.cvsignore: Likewise.
	* lib/autoconf/.cvsignore: Likewise.
	* lib/Autom4te/.cvsignore: Likewise.
	* lib/autoscan/.cvsignore: Likewise.
	* lib/autotest/.cvsignore: Likewise.
	* lib/emacs/.cvsignore: Likewise.
	* lib/m4sugar/.cvsignore: Likewise.
	* man/.cvsignore: Likewise.
	* tests/.cvsignore: Likewise.
	* bin/.gitignore: Likewise.
	* build-aux/.gitignore: Likewise.
	* config/.gitignore: Likewise.
	* doc/.gitignore: Likewise.
	* lib/.gitignore: Likewise.
	* lib/autoconf/.gitignore: Likewise.
	* lib/Autom4te/.gitignore: Likewise.
	* lib/autoscan/.gitignore: Likewise.
	* lib/autotest/.gitignore: Likewise.
	* lib/emacs/.gitignore: Likewise.
	* lib/m4sugar/.gitignore: Likewise.
	* man/.gitignore: Likewise.
	* tests/.gitignore: Likewise.
	* .gitignore: Consolidate all rules into one file.

	Normalize remaining copyright lines.
	* BUGS: Reformat copyright line, using UPDATE_COPYRIGHT_FORCE.
	* NEWS: Likewise.
	* README-hacking: Likewise.
	* TODO: Likewise.
	* lib/Autom4te/ChannelDefs.pm: Likewise.
	* lib/autoconf/fortran.m4: Likewise.
	* lib/autoconf/general.m4: Likewise.
	* lib/autoconf/lang.m4: Likewise.
	* lib/autotest/general.m4: Likewise.
	* maint.mk: Likewise.
	* tests/compile.at: Likewise.

	Improve copyright updating.
	* build-aux/update-copyright: Resynchronize from upstream.
	* maint.mk (update-copyright): Simplify based on gnulib.
	(update-copyright-env): New variable.
	* cfg.mk (update-copyright-exclude-regexp): Delete.
	(update-copyright-env): New override.
	* .x-update-copyright: New file.
	* lib/Autom4te/Makefile.am: Add copyright.
	* lib/Autom4te/Channels.pm: Revert copyright update to upstream
	file.
	* lib/Autom4te/Configure_ac.pm: Likewise.
	* lib/Autom4te/FileUtils.pm: Likewise.
	* lib/Autom4te/Struct.pm: Likewise.
	* lib/Autom4te/XFile.pm: Likewise.

	Update copyright.
	* AUTHORS: Include 2009 in copyright.
	* lib/Autom4te/C4che.pm: Likewise.
	* lib/Autom4te/Channels.pm: Likewise.
	* lib/Autom4te/Configure_ac.pm: Likewise.
	* lib/Autom4te/FileUtils.pm: Likewise.
	* lib/Autom4te/General.pm: Likewise.
	* lib/Autom4te/Request.pm: Likewise.
	* lib/Autom4te/Struct.pm: Likewise.
	* lib/autoconf/Makefile.am: Likewise.
	* lib/autoconf/autoconf.m4: Likewise.
	* lib/autoconf/autoscan.m4: Likewise.
	* lib/autoconf/autoupdate.m4: Likewise.
	* lib/autoconf/functions.m4: Likewise.
	* lib/autoconf/libs.m4: Likewise.
	* lib/autoconf/oldnames.m4: Likewise.
	* lib/autoconf/types.m4: Likewise.
	* lib/autoscan/Makefile.am: Likewise.
	* lib/autoscan/autoscan.pre: Likewise.
	* lib/autotest/Makefile.am: Likewise.
	* lib/autotest/autotest.m4: Likewise.
	* lib/emacs/autoconf-mode.el: Likewise.
	* lib/emacs/autotest-mode.el: Likewise.
	* lib/freeze.mk: Likewise.
	* lib/m4sugar/foreach.m4: Likewise.
	* man/Makefile.am: Likewise.
	* tests/atlocal.in: Likewise.
	* tests/autoscan.at: Likewise.
	* tests/foreign.at: Likewise.
	* tests/fortran.at: Likewise.
	* tests/mktests.sh: Likewise.
	* tests/semantics.at: Likewise.
	* tests/suite.at: Likewise.
	* tests/wrapper.as: Likewise.

	Prepare to bulk update copyright years.
	* build-aux/update-copyright: New file.
	* cfg.mk (gnulib-update): Sync it from gnulib.
	(update-copyright-exclude-regexp): New variable.
	(web-manual): Move...
	* maint.mk (web-manual): ...here, to match gnulib.
	(update-copyright): New target, copied from gnulib's
	maint.mk (it would be nice to sync this file...).
	(build_aux): New macro.
	(VC_LIST, emit_upload_commands): Use it.
	* build-aux/texinfo.tex: Resynchronize from upstream.
	* lib/autoconf/general.m4 (_AC_COPYRIGHT_YEARS): Reformat to meet
	expected pattern.
	* lib/autotest/general.m4 (_AT_COPYRIGHT_YEARS): Likewise.

2009-08-12  Paolo Bonzini  <bonzini@gnu.org>

	Fix testsuite log capturing for tests 183 and 186.
	* tests/autotest.at (AT_CHECK_AT_PREP): Prepend AT_dir to
	testsuite log file for AT_CAPTURE_FILE.

2009-08-10  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Ensure we do not regress with AC_CHECK_MEMBERS.
	* tests/semantics.at (AC_CHECK_MEMBERS): Expose the recent
	AC_CHECK_MEMBERS fix.
	(AC_CHECK_MEMBER): New test group.

2009-08-10  Jeff Squyres  <jsquyres@cisco.com>  (tiny change)

	Fix typo in AC_REQUIRE description.
	* doc/autoconf.texi (Prerequisite macros): Fix typo.

2009-08-10  Paolo Bonzini  <bonzini@gnu.org>

	Fix description of the macro generated by AC_CHECK_MEMBERS.
	* lib/autoconf/types.m4 (_AC_CHECK_MEMBERS): Fix regex
	replacement.  Reported by Bruno Haible.

2009-08-07  Romain Lenglet  <romain.lenglet@laposte.net>

	* lib/autoconf/erlang.m4 (AC_LANG(Erlang)): Make AC_RUN_IFELSE
	fail if the test module doesn't compile.

2009-08-02  Paolo Bonzini  <bonzini@gnu.org>

	Use exit code to detect no occurrences with grep.
	* tests/autotest.at (Erlang Eunit unit tests): Fix grep invocation.

2009-08-01  Romain Lenglet  <romain.lenglet@laposte.net>
	    Paolo Bonzini  <bonzini@gnu.org>

	* lib/autotest/specific.m4 (AT_CHECK_EUNIT): New file.
	* lib/autotest/Makefile.am (dist_autotestlib_DATA): Add specific.m4.
	* lib/autoconf/autotest.m4 (AC_CONFIG_TESTDIR): Add definitions of
	variables used by AT_CHECK_EUNIT macro: ERL, ERLC, ERLCFLAGS.
	* tests/autotest.at (Erlang Eunit unit tests): Add test for macro
	AT_CHECK_EUNIT.
	* doc/autoconf.texi (Writing Testsuites): Document macro
	AT_CHECK_EUNIT.
	* NEWS: Mention macro AT_CHECK_EUNIT.

2009-07-30  Paolo Bonzini  <bonzini@gnu.org>
	    Joel E. Denny  <jdenny@clemson.edu>

	Clarify comparison of echo, printf, and AS_ECHO*.
	* doc/autoconf.texi (Limitations of Builtins): In echo's entry,
	give a reason why printf is better than echo.  In printf's
	entry, cross-reference echo's entry.

2009-07-30  Paolo Bonzini  <bonzini@gnu.org>

	Add back AH_CHECK_HEADERS.
	* lib/autoconf/general.m4 (AH_CHECK_HEADERS): New.
	* NEWS: Create new section.

2009-07-29  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	testsuite: avoid bogus hostname match from inner test logs.
	* tests/autotest.at (Hard fail): Check more restrictively for
	passed tests, so that hostnames recorded in the log file do not
	wrongly match.
	Report by Ludovic Courtès.

2009-07-26  Eric Blake  <ebb9@byu.net>

	Release Version 2.64.
	* NEWS: Mention the release.
	* README: This release is stable.
	* HACKING (release): Use dist-xz, not dist-lzma.

	Document some optional features in INSTALL.
	* doc/install.texi (Basic Installation): Mention that INSTALL is
	generic, and that not all packages implement all features.
	Mention 'make distcheck' for maintainers, and 'make installcheck'
	for users.  Mention the GNU Coding Standards.
	(Installation Names): Mention DESTDIR vs. 'make prefix= install'
	as ways to alter the configuration, with caveats of each.  Move
	--program-prefix discussion...
	(Optional Features): ...here.  Mention --enable-silent-rules and
	use of make V=0.

	Basic improvements to INSTALL.
	* doc/install.texi (Basic Installation): Use better markup.
	(Multiple Architectures): Introduce the term VPATH.
	(Installation Names): Mention that --prefix must be absolute.
	* doc/autoconf.texi (Preset Output Variables)
	(Installation Directory Variables): Consistently refer to GNU
	Coding Standards.

	Update some upstream files.
	* build-aux/config.guess: Resynchronize from upstream.
	* build-aux/config.sub: Likewise.
	* build-aux/texinfo.tex: Likewise.
	* build-aux/vc-list-files: Likewise.
	* doc/standards.texi: Likewise.

2009-07-25  Eric Blake  <ebb9@byu.net>

	Recognize new m4sugar keywords.
	* lib/emacs/autoconf-mode.el (autoconf-current-defun): Recognize
	m4_define_default, m4_defun_init, m4_defun_once.
	(autoconf-font-lock-keywords):  Likewise.

	Require m4 1.4.6, and fix testsuite to support this version.
	* m4/m4.m4 (AC_PROG_GNU_M4): Reject m4 1.4.5, now that we use
	regexp it can't handle.
	* NEWS: Mention minimum version bump.
	* README: Likewise.
	* README-hacking: Likewise.
	* doc/autoconf.texi (Introduction, Why GNU M4): Likewise.
	* tests/tools.at (autom4te --trace and whitespace): Update test so
	still work with older m4 line numbers.
	* tests/m4sugar.at (m4@&t@_require: nested): Likewise.
	Reported by Ralf Wildenhues.

2009-07-25  Bruno Haible  <bruno@clisp.org>

	Clarify autom4te debugging tips.
	* doc/autoconf.texi (Debugging via autom4te): Fix example from
	previous commit, and add clarification.

2009-07-25  Eric Blake  <ebb9@byu.net>

	Document some autom4te debugging tips.
	* doc/autoconf.texi (Debugging via autom4te): New node.
	Suggested by Bruno Haible.

	Fix font-lock.
	* configure.ac (ac_cv_unsupported_fs_chars): Make editing easier.

	Let autoheader see through m4 macros in AC_DEFINE.
	* lib/autoconf/general.m4 (AC_DEFINE_TRACE): Expand macro before
	tracing its name.
	* lib/autoconf/autoheader.m4 (AH_VERBATIM, AH_TEMPLATE): Likewise,
	for using the macro in a template file.
	* tests/tools.at (autoheader and macros): New test.
	* NEWS: Mention this.
	Reported by Bruno Haible.

	Improve NEWS wording.
	* NEWS: Use more accurate statement.
	Suggestedy by Ralf Wildenhues.

2009-07-24  Eric Blake  <ebb9@byu.net>

	Fix AS_EXIT for FreeBSD sh.
	* lib/m4sugar/m4sh.m4 (AS_EXIT): Always supply an argument to the
	shell function, since $? is not reliable on function entry.
	(_AS_EXIT_PREPARE): Simplify to assume argument.
	Reported by Ralf Wildenhues.

2009-07-23  Eric Blake  <ebb9@byu.net>

	Run more tests under Solaris.
	* tests/local.at (AT_CHECK_AUTOCONF): Don't skip entire test
	group when passing over syntax checks.

2009-07-23  Romain Lenglet  <romain.lenglet@laposte.net>

	Clean up temporary files generated by Erlang macros.
	* lib/autoconf/erlang.m4 (AC_ERLANG_CHECK_LIB)
	(AC_ERLANG_SUBST_ROOT_DIR, AC_ERLANG_SUBST_LIB_DIR)
	(AC_ERLANG_SUBST_ERTS_VER): Delete conftest.out; renamed
	erlang_cv_* cache variables into ac_cv_erlang_*.
	* lib/autoconf/general.m4 (AC_RUN_IFELSE): Delete conftest.beam
	files generated by Erlang compiler.
	* tests/local.at (AT_CHECK_ENV): Ignore variables defined by
	Erlang macros.
	* tests/erlang.at (AT_SETUP_ERLANG): Delete; replace all uses by
	AT_CHECK_MACRO.
	* tests/Makefile.am (AUTOCONF_FILES): Revert previous addition of
	generated Erlang tests; they are all hand-tested.

	Add autotests for Erlang macros.
	* tests/erlang.at: Added tests for all macros in erlang.m4.
	* tests/Makefile.am (TESTSUITE_HAND_AT, AUTOCONF_FILES): Added
	erlang.at.
	* tests/suite.at: Likewise.
	* tests/compile.at (AC_LANG, AC_LANG_PUSH & AC_LANG_POP): Added
	test for extension of Erlang files.
	(Multiple languages): Use correct m4 quoting.
	* NEWS: Mention this.

2009-07-22  Eric Blake  <ebb9@byu.net>

	Fix test of autom4te from stdin.
	* tests/tools.at (autom4te cache locking): Make stdin request
	explicit, so that --force is properly used.

2009-07-16  Eric Blake  <ebb9@byu.net>

	Don't hide leading space in autom4te --trace output.
	* bin/autom4te.in (handle_traces): Don't flatten leading and
	trailing space, since tracing spacing bugs can be useful.
	* tests/tools.at (autom4te --trace and whitespace): New test.

2009-07-13  Eric Blake  <ebb9@byu.net>

	Document that $srcdir can be used during configure.
	* doc/autoconf.texi (Preset Output Variables): Add a paragraph.
	* THANKS: Update.
	Reported by Monty Taylor.

2009-07-13  Eric Blake  <ebb9@byu.net>

	Disable asynchronous job notification for parallel tests.
	* lib/autotest/general.m4 (AT_INIT) <Driver loop>: Turn off notify
	mode, since zsh leaves it on after 'emulate sh'.
	* doc/autoconf.texi (Limitations of Builtins) <set>: Document that
	job control options are not portable.

	Guarantee that exit status trumps output matching.
	* doc/autoconf.texi (Writing Testsuites) <AT_CHECK>: Document this
	better.
	* tests/autotest.at (Skip, parallel skip): Enhance tests.

	Fix nits in recent patches.
	* configure.ac (ac_cv_dir_trailing_space): Avoid $status, for
	zsh.
	* doc/autoconf.texi (Writing Testsuites) <AT_FAIL_IF, AT_SKIP_IF>:
	Tweak wording.
	(Introduction): Recommend m4 1.4.13.
	* README: Likewise.
	* m4/m4.m4 (AC_PROG_GNU_M4): Likewise.  Use long option --gnu
	rather than -g.

2009-07-13  Paolo Bonzini  <bonzini@gnu.org>

	Introduce AT_SKIP_IF and AT_FAIL_IF
	* NEWS: Mention AT_SKIP_IF and AT_FAIL_IF.
	* doc/autoconf.texi (Autotest): Document them.
	* lib/autotest/general.m4 (_AT_LINE_ESCAPED, AT_SKIP_IF,
	AT_FAIL_IF, _AT_CHECK_EXIT): New.
	(AT_CHECK): Use _AT_LINE_ESCAPED.
	* tests/autotest.at: Add tests for AT_SKIP_IF and AT_FAIL_IF.
	Use AT_SKIP_IF.
	* tests/local.at: Use AT_SKIP_IF.

2009-07-13  Paolo Bonzini  <bonzini@gnu.org>

	Use m4 -g when available.
	* m4/m4.m4: Unset POSIXLY_CORRECT during first test.  Test for -g.
	Warn user if he has POSIXLY_CORRECT set but -g is not supported.
	* bin/Makefile.am: Substitute @M4_GNU@ into generated files.
	* bin/autom4te.in: Pass @M4_GNU@ to m4.

2009-07-13  Eric Blake  <ebb9@byu.net>

	Fix previous patch.
	* lib/autotest/general.m4 (at_fn_check_prepare_notrace): Use
	proper m4 quoting.
	(_AT_DECIDE_TRACEABLE): Likewise.

2009-07-13  Paolo Bonzini  <bonzini@gnu.org>

	* lib/autotest/general.m4 (at_fn_check_prepare_notrace): Use
	$at_trace_echo.  Add new REASON argument.
	(at_fn_check_prepare_trace): Do not call at_fn_check_prepare_notrace.
	Use $at_check_filter_trace.
	(at_fn_check_prepare_dynamic): Use at_fn_check_prepare_notrace.
	(at_traceon): Initialize to ':'.
	(at_traceoff): Remove, use 'set +x' instead throughout.
	(at_check_filter_trace, at_trace_echo): New shell variables.
	Initialize them if tracing is requested.
	(_AT_DECIDE_TRACEABLE): Adjust call to at_fn_check_prepare_notrace.

2009-07-12  Paolo Bonzini  <bonzini@gnu.org>

	Move atlocal feature tests to configure
	* configure.ac: Test for unsupported characters in files and
	directories here...
	* tests/atlocal.in: ... and not here.

2009-07-09  Eric Blake  <ebb9@byu.net>

	Fix test typo.
	* tests/m4sh.at (AS@&t@_INIT_GENERATED): Close fd, rather than
	creating file named -.

	Fix testsuite under dash.
	* tests/m4sh.at (LINENO stack, AS@&t@_BASENAME, AS@&t@_DIRNAME)
	(AS@&t@_ECHO and AS@&t@_ECHO_N, AS@&t@_EXIT, AS@&t@_MKDIR_P)
	(AS@&t@_VERSION_COMPARE, as_me, Negated classes in globbing)
	(Functions Support, Functions and return Support)
	(Nested AS@&t@_REQUIRE_SHELL_FN, Nested AS@&t@_REQUIRE)
	(AS@&t@_REQUIRE_SHELL_FN and m4@&t@_require, AS@&t@_HELP_STRING)
	(AS@&t@_IF and AS@&t@_CASE, AS@&t@_FOR, AS@&t@_LITERAL_IF)
	(AS@&t@_VAR basics, AS@&t@_VAR_APPEND, AS@&t@_VAR_ARITH)
	(AS@&t@_INIT cleanup, AS@&t@_INIT_GENERATED, AS@&t@_MESSAGE_FD)
	(_AS@&t@_CLEAN_DIR, ECHO_C): Allow testing different CONFIG_SHELL
	options during the testsuite run.
	Reported by Ralf Wildenhues.

2009-07-09  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Ignore messages on stderr when testing for the zsh issue.
	* tests/autotest.at (AT_SKIP_PARALLEL_TESTS): Ignore stderr.

2009-07-07  Eric Blake  <ebb9@byu.net>

	Skip parallel tests when zsh 'set -m' fails.
	* tests/autotest.at (AT_SKIP_PARALLEL_TESTS): Skip test if set -m
	is not supported.
	Reported by Ralf Wildenhues.

	Make parallel testsuite more portable.
	* lib/autotest/general.m4 (AT_INIT) <AT_JOB_FIFO_FD>: Avoid <>;
	instead open write descriptor in each group and read descriptor in
	main driver.
	* tests/autotest.at (AT_SKIP_PARALLEL_TESTS): Relax condition.

2009-07-03  Eric Blake  <ebb9@byu.net>

	Avoid syntax error in ash.
	* lib/autotest/general.m4 (AT_INIT) <driver loop>: Avoid syntax
	errors on shells that don't recognize <>.
	* tests/autotest.at (AT_SKIP_PARALLEL_TESTS): Also skip parallel
	tests for this reason.   Skip based on the shell to be tested,
	not the shell driving the testsuite.
	(parallel syntax error): Rearrange similar to previous patch.
	(parallel test execution): Defer skip until after serial tests.

2009-07-02  Eric Blake  <ebb9@byu.net>

	Skip test on shells that can't catch syntax failure.
	* tests/autotest.at (Syntax error): Skip test if shell aborts on
	syntax error (AIX ksh88) or doesn't detect it (zsh).
	* doc/autoconf.texi (Limitations of Builtins) <.>: Mention these
	limitations.
	Reported by Ralf Wildenhues.

2009-06-30  Jan Madzik  <jmadzik@gmail.com>  (tiny change)
	    Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Avoid AIX 6.1 ksh88 ECHO_C command substitution bug.
	* lib/m4sugar/m4sh.m4 (_AS_ECHO_N_PREPARE): Ensure more than
	one character is output with `\c'; reset echo output state
	if buggy ksh was detected, and set ECHO_T instead of ECHO_C.
	* doc/autoconf.texi (Limitations of Builtins): Document it.
	* tests/m4sh.at (ECHO_C): New test.
	* THANKS: Update.

2009-06-27  William Pursell  <bill.pursell@gmail.com>  (tiny change)

	Fix grammaro in documenation.
	* doc/autoconf.texi (Guidelines): Fix grammaro.

2009-06-17  Eric Blake  <ebb9@byu.net>

	Fix AC_CHECK_HEADER infloop for gcc.
	* lib/autoconf/headers.m4 (_AC_CHECK_HEADER_NEW)
	(_AC_CHECK_HEADER_OLD): Give up on AU_DEFUN, and manually warn
	about obsoletion, to avoid infinite loop in gcc.
	Reported by Ralf Wildenhues.

2009-06-15  Eric Blake  <ebb9@byu.net>

	Add m4_copy_force, m4_rename_force.
	* lib/m4sugar/m4sugar.m4 (m4_copy_force, m4_rename_force): New
	macros.
	* tests/m4sugar.at (m4@&t@_defn): Test them.
	* doc/autoconf.texi (Redefined M4 Macros) <m4_copy>: Document
	them.
	* NEWS: Likewise.
	Suggested by Ralf Wildenhues.

	Reinstate _AC_CHECK_HEADER_OLD for gcc.
	* lib/autoconf/headers.m4 (_AC_CHECK_HEADER_NEW)
	(_AC_CHECK_HEADER_OLD): Provide autoupdate versions, since gcc and
	others used these undocumented macros.
	Reported by Ralf Wildenhues.

2009-06-12  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix concurrent autom4te.cache directory creation race.
	* bin/autom4te.in: Do not error out if another `autom4te'
	instance created the cache directory before we could.

2009-06-11  Steven G. Johnson  <stevenj@alum.mit.edu>
	and Eric Blake  <ebb9@byu.net>

	Create a file in test program when detecting cross-compilation.
	* lib/autoconf/lang.m4 (_AC_LANG_IO_PROGRAM): New macro, returns
	program that creates a file.
	(_AC_COMPILER_EXEEXT,_AC_COMPILER_EXEEXT_WORKS): Call new macro
	and document why it's needed to robustly detect cross-compiling.
	(AC_LANG_DEFINE): Copy implementation across similar languages.
	* lib/autoconf/c.m4 (_AC_LANG_IO_PROGRAM(C)): Implement new macro.
	* lib/autoconf/fortran.m4 (_AC_LANG_IO_PROGRAM(Fortran 77)):
	Likewise.
	* lib/autoconf/erlang.m4 (_AC_LANG_IO_PROGRAM(Erlang)): Likewise.

2009-06-11  Eric Blake  <ebb9@byu.net>

	Simplify AC_LANG(Fortran).
	* lib/autoconf/fortran.m4 (AC_LANG(Fortran)): Borrow from Fortran
	77, which requires reordering portions of the file.
	(AC_LANG_PROGRAM(Fortran), AC_LANG_CALL(Fortran)): Now defined
	automatically.

	Clarify m4_copy semantics.
	* doc/autoconf.texi (Redefined M4 Macros) <m4_copy>: Update
	documentation.
	* tests/m4sugar.at (m4@&t@_defn): Enhance test.

2009-06-06  Eric Blake  <ebb9@byu.net>

	Improve documentation on trap pitfalls.
	* doc/autoconf.texi (Limitations of Builtins) <trap>: Mention new
	Posix 2008 requirement on trap, and dash bug in implementing it.
	Mention various shell bugs with traps defined inside subshells.
	Mention older bash limitation with single-command exit trap.
	<set>: Mention another 'set -e' limitation.
	Reported by Jens Schmidt.

2009-06-06  Jim Meyering  <meyering@redhat.com>

	Improve testsuite --help
	* lib/autotest/general.m4: Correct the example in ./testsuite --help.
	Improve wording.

2009-06-06  Eric Blake  <ebb9@byu.net>

	Document fallback behavior of AC_PROG_LEX.
	* doc/autoconf.texi (Particular Programs) <AC_PROG_LEX>: Mention
	why fallback is :, and that a --version check must be used to
	determine whether flex was found.
	Reported by Patrick Welche.

2009-05-28  Jim Meyering  <meyering@redhat.com>

	Fix syntax errors in autoconf.texi.
	* doc/autoconf.texi (Erlang Libraries): @-escape curly braces
	in example code.

2009-05-28  Romain Lenglet  <romain.lenglet@laposte.net>

	New AC_ERLANG_SUBST_ERTS_VER macro.
	* lib/autoconf/erlang.m4: Add macro AC_ERLANG_SUBST_ERTS_VER.
	* doc/autoconf.texi (Erlang Libraries): Document
	AC_ERLANG_SUBST_ERTS_VER.
	* NEWS: Likewise.
	* AUTHORS: Update Romain Lenglet's email address.
	* THANKS: Update.
	Suggested by Ruslan Babayev.

2009-05-26  Eric Blake  <ebb9@byu.net>

	Sanitize more problematic environment variables.
	* doc/autoconf.texi (Environment Variable Index): Add more
	entries, particularly for precious variables and known culprit
	variables.  Needed to avoid overfull vbox.
	(Special Shell Variables) <CLICOLOR_FORCE, GREP_OPTIONS>: Add
	variables known to cause misbehavior.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_BETTER_SHELL): Unset variables
	known to cause problems.
	* THANKS: Update.
	Based on reports from Ilya Bobir and Joey Mingrone.

2009-05-21  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Document VPATH = $(variable) issue in VPATH chapter.
	* doc/autoconf.texi (Variables listed in VPATH): New node.
	(Top, VPATH and Make): Adjust menus.
	(Build Directories): Refer to it.
	Prompted by report from Bruno Haible.

2009-05-19  Eric Blake  <ebb9@byu.net>

	Update uses of all-permissive license.
	* ChangeLog: Relicense under GPL.
	* ChangeLog.0: Likewise.
	* ChangeLog.1: Likewise.
	* ChangeLog.2: Likewise.
	* THANKS: Likewise.
	* m4/m4.m4: Use latest wording of FSF all-permissive license.
	* m4/make-case.m4: Likewise.
	* doc/install.texi: Likewise.
	* tests/statesave.m4: Relicense to match rest of testsuite; this
	file does not need all-permissive license since it is not designed
	for reuse by other packages.
	* BUGS: Relicense under all-permissive license.
	* HACKING: Likewise.
	* NEWS: Likewise.
	* README: Likewise.
	* README-alpha: Likewise.
	* README-hacking: Likewise.
	* TODO: Likewise.

	Update some upstream files.
	* build-aux/config.guess: Resynchronize from upstream.
	* build-aux/gnupload: Likewise.
	* build-aux/vc-list-files: Likewise.
	* build-aux/texinfo.tex: Likewise.
	* doc/gendocs_template: Likewise.

	Don't mention undocumented interface in NEWS.
	* NEWS: Correct earlier entry about AS_FOR.

2009-05-17  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	New manual section `Parallel Make'.
	* doc/autoconf.texi (Parallel Make): New node, document NetBSD
	`make -jN' quirks.
	(Top, Portable Make): Adjust menus.

2009-05-14  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	testsuite: skip `Multiple languages' test without C++ compiler.
	* tests/compile.at (Multiple languages): Skip test on systems
	without a C++ compiler.
	Report by Jim Meyering.

2009-05-13  Eric Blake  <ebb9@byu.net>

	Document zsh bug with empty commands.
	* doc/autoconf.texi (Special Shell Variables) <?>: Add mention of
	more problems with $?.

2009-05-11  Patrick Welche  <prlw1@cam.ac.uk>  (tiny change)

	Also try X11R7 when looking for X11 files, for NetBSD.
	* lib/autoconf/libs.m4 (_AC_PATH_X_DIRECT): Also try directories
	with X11R7 in the name.

2009-05-01  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Limit stderr logging for C compiler version.
	* lib/autoconf/general.m4 (_AC_RUN_LOG_LIMIT, _AC_DO_LIMIT): New
	internal macros, equivalent to _AC_RUN_LOG and _AC_DO, but with
	an optional additional argument to limit the number of lines of
	stderr output logged, defaulting to 10.
	* lib/autoconf/c.m4 (AC_PROG_CC, AC_PROG_CXX, AC_PROG_OBJC): Use
	_AC_DO_LIMIT for capturing compiler version output.  Also test
	-qversion, for the IBM xlc compiler.
	* lib/autoconf/fortran.m4 (_AC_PROG_FC): Likewise.
	* THANKS: Update.
	Report by Christian Rössel and John R. Cary against Libtool.

2009-04-24  Eric Blake  <ebb9@byu.net>

	Fix quoting of m4 macros in AT_CHECK.
	* lib/autotest/general.m4 (AT_CHECK): Expand prior to adding
	escapes, to avoid shell syntax errors caused by late macro
	expansion.
	* NEWS: Document this change.
	* tests/autotest.at (Metacharacters in command from M4 expansion):
	New test.

	manual: Use consistent spelling of here-document.
	* doc/autoconf.texi (Defining Symbols, Programming in M4sh)
	(Common Shell Constructs, Macro Names, Writing Testsuites): Fix
	spelling.
	Reported by Ralf Wildenhues.

	Make AT_CHECK_UNQUOTED more like AC_DEFINE_UNQUOTED.
	* lib/autotest/general.m4 (AT_CHECK_NOESCAPE): Keep older,
	undocumented semantics, where unbalanced " cannot be used in the
	stdout/stderr argument.
	(AT_CHECK_UNQUOTED): Treat " in stdout/stderr as a literal, since
	the text is used in double-quoted context.
	* tests/autotest.at (unquoted output): New test.
	* doc/autoconf.texi (Writing Testsuites) <AT_CHECK>: Mention which
	shell expansions are handled.

	Rename AT_CHECK_NOESCAPE to AT_CHECK_UNQUOTED.
	* lib/autotest/general.m4 (AT_CHECK_NOESCAPE): Deprecate, in favor
	of new spelling...
	(AT_CHECK_UNQUOTED): ...for consistency with AC_DEFINE_UNQUOTED.
	* doc/autoconf.texi (Writing Testsuites) <AT_CHECK>: Document the
	rename.
	* NEWS: Likewise.
	* tests/autotest.at (Binary output, Cleanup): Adjust tests.
	* tests/torture.at (AC_CONFIG_FILES, HEADERS, LINKS and COMMANDS):
	Likewise.
	Reported by Ralf Wildenhues.

2009-04-22  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	New test to ensure autom4te cache file locking works.
	* tests/tools.at (autom4te cache locking): New test.
	Report by Eric Blake.

2009-04-22  Paolo Bonzini  <bonzini@gnu.org>

	manual: another grammar improvement.
	* doc/autoconf.texi (Fortran Compiler): Avoid dependency on
	pronunciation of `FCFLAGS_f90'.

2009-04-23  Eric Blake  <ebb9@byu.net>

	Change FOO placeholder to use @var{text} instead.
	* doc/autoconf.texi (Configuration Actions): Rename AC_CONFIG_FOOS
	to AC_CONFIG_@var{ITEMS}.
	* doc/autoconf.texi (config.status Invocation): Likewise.
	(AC_FOO_IFELSE vs AC_TRY_FOO): Rename node...
	(AC_ACT_IFELSE vs AC_TRY_ACT): ...to this.

2009-04-22  Eric Blake  <ebb9@byu.net>

	Add m4_argn.
	* lib/m4sugar/m4sugar.m4 (m4_argn): New macro.
	* NEWS: Document it.
	* doc/autoconf.texi (Looping constructs) <m4_argn>: Likewise.
	<m4_car, m4_cdr>: Improve documentation.
	* tests/m4sugar.at (m4 lists): New test.

2009-04-22  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Improve description of AC_PROG_CC_C89 and AC_PROG_CC_C99.
	* doc/autoconf.texi (C Compiler): Document that AC_PROG_CC_C89
	and AC_PROG_CC_C99 prefer extended over strict conformance modes.
	Report by Vincent Lefèvre.

2009-04-21  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Revert bogus change in last commit.
	* doc/autoconf.texi (Initialization Macros): Revert change.
	Spotted by Eric Blake.

	manual: fix trivial grammar errors.
	* doc/autoconf.texi (Fortran Compiler, Initialization Macros)
	(Limitations of Usual Tools, Pretty Help Strings)
	(config.status Invocation): Fix `a' vs. `an' errors.
	Report by Eric Blake.

2009-04-21  Eric Blake  <ebb9@byu.net>

	Shuffle maintainer-specific rules.
	* Makefile.am (maintainer-check-tests): Delete.
	(autom4te-update): Move...
	* cfg.mk (autom4te-update): ...here.
	(fetch): Depend on autom4te-update.  Split...
	(gnulib-update): ...into new rule.  Import move-if-change from
	gnulib.
	* maint.mk (maintainer-distcheck): Absorb former maintainer-check
	rule.
	* build-aux/move-if-change: New file, undistributed.
	* .gitattributes: Handle new upstream file.
	* .gitignore: Ignore maintainer cruft.
	* HACKING: Update maintainer instructions.
	* build-aux/config.guess: Update from upstream.
	* build-aux/config.sub: Likewise.
	* build-aux/gendocs.sh: Likewise.
	* build-aux/texinfo.tex: Likewise.
	* doc/gendocs_template: Likewise.
	* doc/standards.texi: Likewise.

2009-04-19  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Sync autom4te perl modules from Automake.
	* lib/Autom4te/Channels.pm: Sync from Automake.
	* lib/Autom4te/FileUtils.pm: Likewise.
	* lib/Autom4te/XFile.pm: Likewise.

	Adjust channel definitions for new Automake `ordered' flag.
	* lib/Autom4te/ChannelDefs.pm (Autom4te::ChannelDefs): Set
	`ordered' flag to zero for channels `fatal', `automake', and
	`verb'.  This has currently no effect on actual semantics but
	avoids a consistency check needed for Automake's usage of the
	Channels.pm code.

	manual: clarify m4_if synopsis.
	* doc/autoconf.texi (Redefined M4 Macros): Rewrite synopsis of
	m4_if in the presence of more than three arguments.

	Improve and clarify `config.status' usage documentation.
	* doc/autoconf.texi (config.status Invocation): Fix markup in
	synopsis.  Use `tag' instead of `file' notation for the
	non-option arguments, to be consistent with the documentation
	of the AC_CONFIG_* macros.
	* lib/autoconf/status.m4 (_AC_OUTPUT_CONFIG_STATUS): Likewise,
	use `tag' notation for non-option arguments.
	Report by John Calcote.

2009-04-15  Eric Blake  <ebb9@byu.net>

	Test that autotest handles binary output.
	* tests/autotest.at (Binary output): New test.
	Suggested by Ralf Wildenhues.

	Add stdout-nolog and ignore-nolog to AT_CHECK.
	* lib/autotest/general.m4 (AT_DIFF_STDERR(stderr-nolog))
	(AT_DIFF_STDERR(ignore-nolog), AT_DIFF_STDOUT(stdout-nolog))
	(AT_DIFF_STDOUT(ignore-nolog)): New macros.
	* tests/autotest.at (Logging): New test.
	* doc/autoconf.texi (Writing Testsuites) <AT_CHECK>: Document the
	new logging actions.
	* NEWS: Likewise.
	Reported by Ralf Wildenhues.

	Teach AT_CHECK about hard failures.
	* lib/autotest/general.m4 (AT_INIT) <at_fn_check_skip>
	<at_fn_check_status, at_fn_group_postprocess>: Handle hard
	failures.
	* doc/autoconf.texi (Writing Testsuites) <AT_CHECK>: Document
	AT_CHECK_NOESCAPE and exit status 99.
	* NEWS: Likewise.
	* tests/autotest.at (Hard fail, Cleanup): New tests.

2009-04-14  Eric Blake  <ebb9@byu.net>

	Fix yesterday's regression in AS_IF.
	* lib/m4sugar/m4sh.m4 (_AS_IF_ELSE): Don't corrupt $? in else
	branch; it is up to the user to avoid syntax errors.
	* tests/m4sh.at (AS@&t@_IF and AS@&t@_CASE): Adjust test.

2009-04-14  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Add traces for AM_SILENT_RULES.
	* lib/autom4te.in (Automake-preselections): Trace
	AM_SILENT_RULES.

2009-04-13  Eric Blake  <ebb9@byu.net>

	Improve documentation related to expanded-before-required.
	* doc/autoconf.texi (Expanded Before Required): Add a case study.
	(Running the Compiler) <AC_COMPILE_IFELSE>: Remind users that
	running a compile test will AC_REQUIRE the compiler check.
	(Macro Definitions) <AC_DEFUN>: Contrast AC_DEFUN and m4_define.
	(C Compiler) <AC_PROG_CC>: Mention the fact that only first
	invocation of this macro checks for $EXEEXT, and that many other
	macros use it via AC_REQUIRE.
	Reported by Andreas Schwab.

	Mention latest rules about make and set -e.
	* doc/autoconf.texi (Failure in Make Rules): Posix is now clear
	that make must use set -e.
	(Limitations of Builtins) <set>: Clarify more about set -e
	behavior.

	Improve documentation about if exit status.
	* doc/autoconf.texi (Limitations of Builtins) <if>: Mention that
	exit status bugs don't affect modern targets.
	Reported by Andreas Schwab.

	Add cross-reference to new macros.
	* doc/autoconf.texi (Text processing Macros) <m4_normalize>
	<m4_strip>: Reference the new m4_ifblank.
	Suggested by Mike Frysinger.

	Make AS_IF, AS_CASE, and AS_FOR more robust to blank arguments.
	* lib/m4sugar/m4sh.m4 (_AS_CASE, _AS_CASE_DEFAULT, AS_FOR, _AS_IF)
	(_AS_IF_ELSE, AS_IF): Avoid syntax error on blank argument,
	including a macro with an empty expansion.
	* NEWS: Mention this.
	* tests/m4sh.at (AS@&t@_IF and AS@&t@_CASE, AS@&t@_FOR): Update
	tests.
	Reported by Mike Frysinger.

	Add m4_blank and friends.
	* lib/m4sugar/m4sugar.m4 (m4_blank, m4_nblank, m4_default_nblank)
	(m4_default_nblank_quoted): New macros.
	* NEWS: Document them.
	* doc/autoconf.texi (Conditional constructs): Likewise.
	* tests/m4sugar.at (m4sugar shorthand conditionals): New test.
	Suggested by Mike Frysinger.

2009-04-13  Eric Blake  <ebb9@byu.net>

	Finish upgrade to GFDL 1.3.
	* doc/autoconf.texi (copying): Use correct license; comment change
	was missed on 2008-11-04.

2009-04-10  Eric Blake  <ebb9@byu.net>

	Test parallel handling of syntax error.
	* tests/autotest.at (parallel syntax error): New test.
	Suggested by Ralf Wildenhues.

2009-04-10  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Document awk and config.status line length limitations.
	* doc/autoconf.texi (Configuration Actions): The input to
	config.status should have reasonable line length.
	(Limitations of Usual Tools): Document IRIX, HP-UX awk input
	line length limit.
	Report by Bruno Haible.

	Skip `Multiple languages' test if CC is a C++ compiler.
	* tests/compile.at (Multiple languages): Before starting the
	test proper, build and run a configure script that tests the
	C compiler only, and skips the test if this is found to be a
	C++ compiler.
	Report by Eric Blake.

	Note that AC_DEFUN is needed for aclocal.
	* doc/autoconf.texi (Coding Style): Public third-party macros
	should be AC_DEFUN'ed.
	Report by John Calcote.

2009-04-10  Eric Blake  <ebb9@byu.net>

	Add undocumented _AS_CLEAN_DIR.
	* lib/m4sugar/m4sh.m4 (_AS_CLEAN_DIR): New macro; fixes m4 quoting
	in previous patch.
	* lib/autotest/general.m4 (AT_INIT) <at_fn_group_prepare>: Use new
	macro.
	* tests/m4sh.at (_AS@&t@_CLEAN_DIR): New test.
	Reported by Ralf Wildenhues.

2009-04-09  Eric Blake  <ebb9@byu.net>

	Avoid problems caused by deleting in-use directory.
	* lib/autotest/general.m4 (AT_INIT) <at_fn_group_prepare>: Only
	remove the contents of $at_group_dir, not the directory itself.

	Fix regression in empty test.
	* lib/autotest/general.m4 (AT_SETUP): Prep AT_ingroup for fallback
	use in empty test.  Fixes regression introduced 2009-04-06.
	(_AT_CHECK): Undo fallback when a test is not empty.
	(AT_CLEANUP): Expand AT_ingroup before deleting.

2009-04-09  Paolo Bonzini  <bonzini@gnu.org>

	Make a less conservative cross-compilation guess for AC_FUNC_UTIME_NULL.
	* lib/autoconf/functions.m4 (AC_FUNC_UTIME_NULL): Assume
	not crosscompiling to an obsolete system.

2009-04-08  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Automake relies on the undocumented `_AC_COMPILER_EXEEXT' macro.
	* lib/autoconf/lang.m4 (_AC_COMPILER_EXEEXT): Document that
	Automake relies on this macro.

2009-04-06  Eric Blake  <ebb9@byu.net>

	Reduce testsuite size.
	* tests/statesave.m4: New file.
	* tests/Makefile.am (EXTRA_DIST): Distribute it.
	* tests/local.at (AT_CONFIGURE_AC): Reuse file, rather than
	repeating inline definition of AC_STATE_SAVE.
	(AT_CHECK_ENV): Factor code...
	(_AT_CHECK_ENV): ...into shell function.
	* tests/m4sh.at (AT_DATA_LINENO): Avoid churn in testsuite.

	Handle shell comments in AT_CHECK.
	* lib/autotest/general.m4 (_AT_DECIDE_TRACEABLE): Handle # in
	test correctly.  Latent bug in handling shell comment was first
	fixed 2008-11-20, but regressed two patches later.
	* tests/autotest.at (Shell comment in command): New test.
	* NEWS: Document the fix.

	Hard fail any test with syntax errors.
	* lib/autotest/general.m4 (AT_INIT) <at_fn_group_postprocess>:
	Guarantee test failure on syntax error, rather than inheriting
	status from previous test.
	* tests/autotest.at (Syntax error): New test.

2009-03-31  Eric Blake  <ebb9@byu.net>

	Beta Release Version 2.63b.
	* NEWS: Mention the release.
	* README: Clarify that this is a beta release.
	* build-aux/texinfo.tex: Synchronize from upstream.
	* .x-sc_trailing_blank: Exempt more upstream files.

2009-03-30  Eric Blake  <ebb9@byu.net>

	Fix testsuite failures under zsh.
	* tests/local.at (AT_CHECK_ENV): Exempt $argv and $ARGC, which are
	set by zsh -c 'emulate sh'.
	Reported by Ralf Wildenhues.

	For now, skip parallel tests under less-tested shells.
	* tests/autotest.at (AT_CHECK_AT): Add pre-test argument.
	(Tested programs, Startup error messages, AT_CHECK_AT_TITLE)
	(Fallacy, Skip, errexit, Long test source lines)
	(Debugging a successful test, Debugging script and environment)
	(Debugging a failed test, Using atlocal)
	(Choosing where testsuite is run): Adjust callers.
	(AT_SKIP_PARALLEL_TESTS): New macro, to skip parallel tests except
	under zsh, bash, or when TEST_PARALLEL_AUTOTEST is defined.  Makes
	it easier to avoid testsuite hangs for users with dash or other
	less-tested shell.
	(parallel test execution, parallel truth, parallel fallacy)
	(parallel skip, parallel errexit)
	(parallel autotest and signal handling): Use it.
	* BUGS: Mention this.

2009-03-24  Andris Pavenis  <andris.pavenis@iki.fi>  (tiny change)

	Fix awk substitution of carriage returns on DJGPP.
	* lib/autoconf/status.m4 (_AC_OUTPUT_FILES_PREPARE): Fix typo in
	generation of ac_cs_awk_cr.
	* THANKS: Update.

2009-03-24  Aaron W. LaFramboise  <aaronenvelope277@aaronwl.com>  (tiny change)

	Work around cygwin bash igncr mode.
	* lib/autoconf/status.m4 (_AC_OUTPUT_FILES_PREPARE): Fall back to
	bash carriage returns if ac_cr lost \r from ``.
	* THANKS: Update.
	Suggested by Eric Blake.

2009-03-24  Eric Blake  <ebb9@byu.net>

	Fix underquoted example in manual.
	* doc/autoconf.texi (Common Shell Constructs) <AS_TR_CPP>:
	Properly m4-quote #.
	* THANKS: Update spelling.
	Reported by Matěj Týč.

2009-03-18  Eric Blake  <ebb9@byu.net>

	Manual: mention more expr pitfalls.
	* doc/autoconf.texi (Limitations of Usual Tools) <expr (:)>:
	Mention HP-UX limitation, and $ ambiguity.
	* THANKS: Update.
	Reported by Jens Schmidt, in http://bugs.debian.org/466990.

2009-03-17  Jim Meyering  <meyering@redhat.com>

	Manual: fix a typo.
	* lib/m4sugar/m4sh.m4: s/are/is/ => "there is no indirection"

2009-03-17  Eric Blake  <ebb9@byu.net>

	Use test consistently in examples.
	* doc/autoconf.texi (Subdirectories, Caching Results)
	(Common Shell Constructs, Prerequisite Macros, Coding Style)
	(Changed Results, Particular Programs, Defining Symbols):
	Protect against arbitrary user strings.
	(Multiple Cases): Mention why $fstype does not need protection.
	Reported by Reuben Thomas.

	Improve confusing section names.
	* doc/autoconf.texi (Specifying Names): Rename node...
	(Specifying Target Triplets): ...to this.
	(Generic Programs): Adjust references.
	* doc/install.texi (System Type): Touch up formatting.
	* THANKS: Update.
	Reported by Tim Freeman, in http://bugs.debian.org/312873.

	Remove historical inaccuracy.
	* doc/autoconf.texi (Portable Shell): Don't perpetuate myth about
	#!/bin/sh needing a space.
	Reported by Reuben Thomas.

	Recommend AS_HELP_STRING more prominently.
	* doc/autoconf.texi (External Software): Reduce mention of
	hand-written help strings.
	Reported by Reuben Thomas.

2009-03-16  Eric Blake  <ebb9@byu.net>

	Fix 'make pdf'.
	* doc/autoconf.texi (Balancing Parentheses): Fix usage of
	@itemize.
	Reported by Ralf Wildenhues, fix suggested by Karl Berry.

2009-03-14  Eric Blake  <ebb9@byu.net>

	Resync upstream files.
	* GNUmakefile: Run 'make fetch'.
	* build-aux/announce-gen: Likewise.
	* build-aux/config.guess: Likewise.
	* build-aux/config.sub: Likewise.
	* build-aux/gnupload: Likewise.
	* build-aux/texinfo.tex: Likewise.
	* build-aux/vc-list-files: Likewise.
	* doc/gnu-oids.texi: Likewise.
	* doc/standards.texi: Likewise.

2009-03-09  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	New test for SunStudio `restrict' handling.
	* tests/c.at (AC_C_RESTRICT and C++): New test.
	Prompted by bug report from Rolf Vandevaart.

2009-03-08  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Manual: testsuite depends on package.m4.
	* doc/autoconf.texi (Making testsuite Scripts): In the example
	makefile snippet, $(TESTSUITE) depends on $(srcdir)/package.m4.

2009-03-02  Allan Caffee  <allan.caffee@gmail.com>  (tiny change)

	Fix a typo in comment for AS_LITERAL_IF.
	* lib/m4sugar/m4sh.m4 (AS_LITERAL_IF): Update a comment that fell
	out of date when this function was moved/renamed in 59ecd766.
	* THANKS: Update.

2009-03-02  Eric Blake  <ebb9@byu.net>

	Improve wording for AS_ESCAPE.
	* doc/autoconf.texi (Common Shell Constructs) <AS_ESCAPE>: Touch
	up documentation.
	* lib/m4sugar/m4sh.m4 (_AS_ESCAPE): Fix comment typos.
	Reported by Ralf Wildenhues.

2009-02-24  Eric Blake  <ebb9@byu.net>

	Use pkgdatadir consistently.
	* bin/Makefile.am (edit): Substitute pkgdatadir, not datadir.
	* lib/Makefile.am (edit): Likewise.
	* lib/autom4te.in (Autoconf-without-aclocal-m4, Autotest, M4sh)
	(M4sugar): Use @pkgdatadir@, not @datadir@.
	* bin/autoheader.in ($datadir): Likewise.
	* bin/autom4te.in ($datadir): Likewise.
	* bin/autoreconf.in ($datadir): Likewise.
	* bin/autoscan.in ($datadir): Likewise.
	* bin/autoupdate.in ($datadir): Likewise.
	* bin/ifnames.in ($datadir): Likewise.
	* doc/autoconf.texi (Installation Directory Variables): Update
	example to be consistent; focus on $(bindir) as an autoconf
	variable, and mention that $(pkgdatadir) comes from automake.
	Reported by Reuben Thomas.

2009-02-19  Eric Blake  <ebb9@byu.net>

	Use m4_translit more efficiently in AS_ESCAPE.
	* lib/m4sugar/m4sh.m4 (_AS_ESCAPE): Alter API to take first byte
	of set separately from rest.
	(AS_ESCAPE, _AS_QUOTE_MODERN, AS_TR_SH, AS_VAR_GET): Adjust
	callers.
	* lib/autoconf/autoheader.m4 (AH_VERBATIM): Avoid duplicate
	characters in translit request.
	* doc/autoconf.texi (Common Shell Constructs) <AS_ESCAPE>:
	Document the macro.
	* NEWS: Likewise.

	Mention recently documented macros.
	* NEWS: Update list of new documentation.

2009-02-14  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Add index for config.site.
	* doc/autoconf.texi (Site Defaults): Add index for config.site.
	* THANKS: Update.
	Report by Stephen P. Schaefer.

2009-02-12  Eric Blake  <ebb9@byu.net>

	Fix m4_set speed regression introduced 2008-12-18.
	* lib/m4sugar/m4sugar.m4 (_m4_stack_reverse): Alter API to avoid
	creating larger argument on each iteration.
	(m4_stack_foreach_sep, m4_stack_foreach_sep_lifo)
	(_m4_set_contents_2): Adjust all four-argument callers.

2009-02-05  Eric Blake  <ebb9@byu.net>

	Mention new AC_DEFUN_ONCE clients.
	* NEWS: Mention recent semantic changes.
	Reported by Ralf Wildenhues.

2009-02-03  Eric Blake  <ebb9@byu.net>

	Use AC_DEFUN_ONCE for some one-shot AC_PROG macros.
	* lib/autoconf/programs.m4 (AC_PROG_MKDIR_P): Switch to
	AC_DEFUN_ONCE, since this is a one-shot macro.
	(AC_PROG_INSTALL): Likewise.

2009-02-03  Eric Blake  <ebb9@byu.net>

	Mention that packagers should not pre-set CFLAGS.
	* doc/autoconf.texi (Preset Output Variables) <CFLAGS>: Copy
	advice given by automake on handling variables reserved by GNU
	Coding Standards.
	Reported by Karl Berry.

	Document lib64 in config.site.
	* doc/autoconf.texi (Site Defaults): Fix typo in FHS sample file.
	Mention use of lib64.
	* THANKS: Update.
	Reported by Tom Browder, with help from Peter Breitenlohner.

2009-01-28  Eric Blake  <ebb9@byu.net>

	Use AC_DEFUN_ONCE for uncontroversial one-shot macros.
	* lib/autoconf/headers.m4 (AC_HEADER_ASSERT): Switch to
	AC_DEFUN_ONCE, since this is a one-shot macro.
	* lib/autoconf/specific.m4 (AC_USE_SYSTEM_EXTENSIONS): Likewise.
	* lib/autoconf/general.m4 (AC_CANONICAL_BUILD)
	(AC_CANONICAL_HOST, AC_CANONICAL_TARGET): Likewise.

2009-01-28  Eric Blake  <ebb9@byu.net>

	Reduce blank lines in AC_DEFUN_ONCE macros.
	* lib/m4sugar/m4sugar.m4 (m4_defun_once): Avoid redundant blank
	line when a defun_once macro is required.
	(_m4_defun_once): New helper macro, for less memory use.
	* tests/m4sugar.at (m4@&t@_require: nested): Adjust test.

	Silence another false positive expand-before-require.
	* lib/m4sugar/m4sugar.m4 (_m4_defun_pro_outer)
	(_m4_defun_epi_outer, _m4_require_call, m4_provide): Track name
	that caused a diversion change, not just diversion number.
	(m4_require): Factor...
	(_m4_require_check): ...into new macro, which also checks whether
	diversion that performed the expansion has been collected.
	* tests/m4sugar.at (m4@&t@_require: nested): Enhance test.
	Reported by Ralf Wildenhues.

2009-01-28  Eric Blake  <ebb9@byu.net>

	Fix AC_C_RESTRICT for Sun Studio 12 C++.
	* lib/autoconf/c.m4 (AC_C_RESTRICT): Newer Sun Studio C provides
	__restrict__ rather than _Restrict, which still trips up Sun
	Studio 12 C++.
	* THANKS: Update.
	Reported by Rolf Vandevaart.

2009-01-28  Eric Blake  <ebb9@byu.net>

	Fix years in copyright notices.
	* lib/m4sugar/m4sugar.m4 (m4_copyright_condense): New macro,
	undocumented for now.
	* lib/m4sugar/Makefile.am (version.m4): Add m4_PACKAGE_YEAR,
	m4_PACKAGE_URL.
	(RELEASE_YEAR): New macro, copied from bin/Makefile.am.
	* lib/autoconf/general.m4 (_AC_COPYRIGHT_YEARS): New macro.
	(AC_COPYRIGHT): Add undocumented third parameter.
	(_AC_INIT_COPYRIGHT): Avoid need to bump copyright years.
	* lib/autoconf/status.m4 (_AC_OUTPUT_CONFIG_STATUS): Likewise.
	* lib/autotest/general.m4 (AT_INIT): Likewise.
	* lib/autoconf/autotest.m4 (AC_CONFIG_TESTDIR): Likewise.
	(AT_COPYRIGHT): Add undocumented third parameter.
	* tests/local.at (AT_COPYRIGHT): Don't add an extra copyright
	parameter; the generic copyright given by autotest is sufficient
	since we are the package that owns autotest.

2009-01-27  Eric Blake  <ebb9@byu.net>

	Use URLs in --help output, part 3: testsuite.
	* doc/autoconf.texi (Writing Testsuites): Mention autotest
	namespace.
	(Writing Testsuites) <AT_INIT>: Mention mandatory macros.
	(Making testsuite Scripts): Document AT_PACKAGE_URL.
	* tests/Makefile.am (package.m4): Follow our own advice.
	* lib/autotest/general.m4 (AT_INIT): Give the user a hint about
	package.m4.  Enhance --help output.
	(_AT_COPYRIGHT_YEARS): New macro, to make copyright bump easier.

	Use URLs in --help output, part 2: configure.
	* lib/autoconf/general.m4 (_AC_INIT_COPYRIGHT): Bump copyright
	date.
	(_AC_INIT_PACKAGE): Support optional URL parameter, mapped to
	AC_PACKAGE_URL.
	(_AC_INIT_DEFAULTS, _AC_INIT_PREPARE): Substitute it.
	(_AC_INIT_HELP): Use it in './configure --help' output.
	* lib/autoconf/status.m4 (_AC_OUTPUT_CONFIG_STATUS): Likewise, for
	'./config.status --help'.  Bump copyright date.
	* doc/autoconf.texi (Initializing configure) <AC_INIT>: Document
	new parameter.
	* NEWS: Likewise.
	* tests/tools.at (autoheader): Adjust test.
	* tests/torture.at (@%:@define header templates)
	(Torturing config.status): Likewise.

	Use URLs in --help output, part 1: autoconf executables.
	* bin/autoconf.as (usage): Make output consistent with recent
	change in gnulib version-etc module.
	* bin/autoheader.in ($help): Likewise.
	* bin/autom4te.in ($help): Likewise.
	* bin/autoreconf.in ($help): Likewise.
	* bin/autoscan.in ($help): Likewise.
	* bin/autoupdate.in ($help): Likewise.
	* bin/ifnames.in ($help): Likewise.

2009-01-27  Peter Breitenlohner  <peb@mppmu.mpg.de>  (tiny change)

	Quote traced macros passed from autom4te to M4.
	* bin/autom4te (handle_m4): Apply shell_quote to macro names.
	* tests/tools.at (autom4te --trace and unusual macro names): New
	test.
	* THANKS: Update.

2009-01-26  Eric Blake  <ebb9@byu.net>

	Improve AC_DEFUN_ONCE semantics.
	* lib/m4sugar/m4sugar.m4 (m4_defun_once): Rewrite to be no-op,
	rather than warning, on second use, and make sure first use never
	occurs out of order.
	* tests/m4sugar.at (m4@&t@_require: one-shot initialization):
	Enhance test.
	* tests/base.at (AC_REQUIRE & AC_DEFUN_ONCE: [Require, expand],
	(AC_REQUIRE & AC_DEFUN_ONCE: [Expand, require]): Adjust tests.
	* NEWS: Document this.
	* doc/autoconf.texi (Macro Definitions) <AC_DEFUN>: Mention
	AC_DEFUN_ONCE.
	(Prerequisite Macros) <AC_REQUIRE>: Likewise.
	(Expanded Before Required): Likewise.
	(One-Shot Macros) <AC_DEFUN_ONCE>: Document new semantics.
	Reported by Bruno Haible, with suggestion by Paolo Bonzini.

2009-01-24  Eric Blake  <ebb9@byu.net>

	Fix typos in recent patches.
	* lib/m4sugar/m4sugar.m4: Improve m4_defun comments.
	* doc/autoconf.texi (Expanded Before Required): Fix typos.
	Reported by Ralf Wildenhues.

	Revert change to AC_DIR_HEADER.
	* lib/autoconf/headers.m4 (AC_DIR_HEADER): Explicitly expanding
	AC_HEADER_DIRENT no longer triggers a warning, and helps the user
	who decides they don't need the obsolete AC_FUNC_CLOSEDIR_VOID.
	Reported by Paolo Bonzini.

2009-01-22  Eric Blake  <ebb9@byu.net>

	Silence a false positive expand-before-require case.
	* lib/m4sugar/m4sugar.m4 (m4_provide): Track the diversion in
	which a macro was provided.
	(m4_require): Compare diversion numbers, rather than m4_require
	nesting, when determining direct requires.
	* tests/m4sugar.at (m4@&t@_require: nested): Test it.
	Reported by Ralf Wildenhues, affecting Libtool.

2009-01-21  Eric Blake  <ebb9@byu.net>

	Fix out-of-order expansion with expand-before-require.
	* lib/m4sugar/m4sugar.m4 (m4_require): Redundantly expand a
	required macro when issuing expand-before-require warning.
	* doc/autoconf.texi (Prerequisite Macros): Adjust documentation.
	(Expanded Before Required): New node.
	* tests/m4sugar.at (m4@&t@_require: nested): Adjust test.
	* NEWS: Mention this fix.
	Suggested by Bruno Haible.

	Warn if macro is provided before indirectly required.
	* lib/m4sugar/m4sugar.m4 (m4_provide): Track the set of all macros
	provided since last outermost defun.
	(_m4_defun_pro_outer): Empty the set.
	(_m4_require_call): Distinguish between direct and indirect
	requires, and remove required macros from the set.
	(m4_require): Check the set, in order to warn.
	* tests/m4sugar.at (m4@&t@_require: nested): Remove xfail, and add
	test case for direct requires.

2009-01-20  Eric Blake  <ebb9@byu.net>

	Clean up some bugs caught by preliminary dependency validation.
	* lib/autoconf/headers.m4 (AC_DIR_HEADER): Don't invoke
	AC_HEADER_DIRENT, since AC_FUNC_CLOSEDIR_VOID requires it.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_BETTER_SHELL)
	(_AS_SHELL_SANITIZE): Fix quoting bugs.

2009-01-19  Eric Blake  <ebb9@byu.net>

	Improve AC_REQUIRE documentation.
	* doc/autoconf.texi (Macro Definitions) <AC_DEFUN>: Add @defmac,
	and mention interaction with AC_REQUIRE.
	(Prerequisite Macros) <AC_REQUIRE>: Give more detail on user
	ordering constraint bug, and how to fix it.
	* tests/m4sugar.at (m4@&t@_require: nested): New test.

	Speed up m4_require.
	* lib/m4sugar/m4sugar.m4 (_m4_divert_dump): Change semantics to
	always be defined, as either empty or a number.
	(_m4_defun_pro_outer, _m4_defun_epi_outer): Treat _m4_divert_dump
	as a stack, rather than a one-shot macro.
	(_m4_require_call): Expect third argument to be pre-expanded.
	(m4_divert_require, m4_require): Adjust clients accordingly.
	* lib/m4sugar/m4sh.m4 (AS_REQUIRE): Likewise.

2009-01-17  Eric Blake  <ebb9@byu.net>

	Avoid underfull hbox.
	* doc/autoconf.texi (Installation Directory Variables): Reword to
	fit on line.

2009-01-14  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Ignore `set -e'-related failure of NetBSD sh.
	* tests/m4sh.at (AS@&t@_EXIT): Skip test if (NetBSD) shell
	fails to finish EXIT trap after set -e.

2009-01-06  Eric Blake  <ebb9@byu.net>

	Maintainer cleanups.
	* cfg.mk (web-manual): Use new feature of gendocs.
	(fetch): Fetch gendocs.
	* Makefile.am (EXTRA_DIST): Distribute new file.
	* doc/Makefile.am (EXTRA_DIST): Likewise.
	* .gitattributes: Ignore whitespace in upstream files.
	* HACKING (Other web updates): Update Free Software Directory
	instructions.
	(Upload): No longer mention xdelta.
	* maint.mk (xd-delta): Likewise.
	* build-aux/gendocs.sh: New upstream file.
	* doc/gendocs_template: Likewise.
	* build-aux/announce-gen: Resync from upstream.
	* build-aux/config.guess: Likewise.
	* build-aux/config.sub: Likewise.
	* build-aux/gnupload: Likewise.
	* build-aux/texinfo.tex: Likewise.

2008-12-30  Eric Blake  <ebb9@byu.net>

	Make it easier to track diversion bugs.
	* lib/m4sugar/m4sugar.m4 (_m4_divert_raw, _m4_undivert): New
	internal macros, which are easier to trace than m4_builtin.
	(m4_cleardivert, m4_divert, m4_divert_push, m4_divert_pop)
	(m4_undivert): Use them.
	(_m4_require_call): Likewise.  Use fewer macros.
	* lib/autotest/general.m4 (_AT_DECIDE_TRACEABLE): Fix typo.

2008-12-26  Bruno Haible  <bruno@clisp.org>

	Improve multiarch detection.
	* lib/autoconf/c.m4 (AC_C_BIGENDIAN): Make detection of options
	indicating a universal build more reliable.

2008-12-28  William Pursell  <bill.pursell@gmail.com>  (tiny change)

	Use AS_CASE in documented example.
	* doc/autoconf.texi (Using the System Type): Use AS_CASE in
	example instead of raw case.

2008-12-23  Eric Blake  <ebb9@byu.net>

	Make m4_dumpdef more useful with M4 1.6.
	* lib/m4sugar/m4sugar.m4 (_m4_dumpdef): New macro.
	(m4_init): Install it for new enough m4.
	* tests/m4sugar.at (m4@&t@_dumpdef): Enhance test.
	* doc/autoconf.texi (Redefined M4 Macros) <m4_dumpdef>: Mention
	lack of sorting.

2008-12-24  Bruno Haible  <bruno@clisp.org>

	Improve INSTALL for HP-UX.
	* doc/install.texi (Particular Systems): For HP-UX, also recommend
	-D_XOPEN_SOURCE=500. Needed for the declaration of mbstate_t on
	HP-UX 11.11.

2008-12-22  Bruno Haible  <bruno@clisp.org>

	Improve INSTALL for Haiku.
	* doc/install.texi (Particular Systems): Add a recommendation
	which prefix to use on Haiku.

2008-12-19  Eric Blake  <ebb9@byu.net>

	Fix typo in previous commit.
	* doc/autoconf.texi (Set manipulation Macros) <m4_set_map_sep>:
	Fix typo.

	Document some recently added macros.
	* lib/m4sugar/m4sugar.m4 (m4_map_args_w): Add optional sep
	parameter.
	* doc/autoconf.texi (Looping constructs) <m4_map_args_sep>
	<m4_map_args_w, m4_stack_foreach, m4_stack_foreach_sep>: Document
	new macros.
	(Set manipulation Macros) <m4_set_map_sep>: Likewise.
	* tests/m4sugar.at (m4@&t@_stack, M4 loops): Enhance tests.
	* NEWS: Document new macros.

2008-12-18  Eric Blake  <ebb9@byu.net>

	Fix separator in m4_stack_foreach_sep.
	* lib/m4sugar/m4sugar.m4 (_m4_stack_reverse): Separate separator
	from prefix.
	* tests/m4sugar.at (m4@&t@_stack): Enhance test.

2008-12-18  Eric Blake  <ebb9@byu.net>

	Mention limitation of M4 1.4.x on builtin tokens.
	* doc/autoconf.texi (Redefined M4 Macros) <m4_dumpdef>: Document
	ramification of M4 1.4.x's inability to pass builtin tokens
	through text macros.
	(Evaluation Macros) <m4_curry>: Likewise.
	* tests/m4sugar.at (m4@&t@_defn): Enhance test.
	* NEWS: Mention subtle change in m4_dumpdef semantics.

	Document m4_version_prereq.
	* doc/autoconf.texi (Number processing Macros)
	<m4_version_prereq>: Add documentation.
	* NEWS: Mention it.
	Reported by Bruno Haible.

2008-12-10  Jim Meyering  <meyering@redhat.com>

	AC_HEADER_ASSERT: don't say assertions are disabled when they're not
	* lib/autoconf/headers.m4 (AC_HEADER_ASSERT): Do not make configure
	report "checking whether to enable assertions... no", when they are
	in fact enabled.  This is solely a bug in the output of configure.
	In spite of saying "no", NDEBUG was not defined in that case.
	Also, as noted by Eric Blake, leave assertions enabled upon
	--enable-assert=INVALID.

2008-12-09  Eric Blake  <ebb9@byu.net>

	Fix m4_location inside m4_wrap with m4 1.4.5.
	* lib/m4sugar/m4sugar.m4 (m4_undefine): Redefine m4_location
	inside wrapped text if older m4 is detected.
	Reported by William Pursell.

2008-12-08  William Pursell  <bill.pursell@gmail.com>  (tiny change)
	and Eric Blake  <ebb9@byu.net>

	Fix AC_HEADER_ASSERT w.r.t. --enable-assert.
	* lib/autoconf/headers.m4 (AC_HEADER_ASSERT): Honor --enable-assert,
	rather than treating it as a synonym for --disable-assert.
	* NEWS: Document the fix.

2008-12-06  William Pursell  <bill.pursell@gmail.com>  (tiny change)

	Fix AC_HEADER_ASSERT to honor --enable-assert, rather than
	treat --enable-assert and --disable-assert equivalently.
	* lib/autoconf/headers.m4 (AC_HEADER_ASSERT): Check value of $enableval.

2008-12-05  William Pursell  <bill.pursell@gmail.com>  (tiny change)

	Fix some typos and grammatical errors in documentation.
	* doc/autoconf.texi: Clean up some bad use of English.

2008-12-03  Eric Blake  <ebb9@byu.net>

	Improve AC_STATE_SAVE.
	* tests/local.at (AC_STATE_SAVE): Avoid ls -1, and use one less
	process by hoisting the uniqueness check into sed.
	* doc/autoconf.texi (Limitations of Usual Tools) <ls>: Mention
	MacOS bug.

2008-12-02  Eric Blake  <ebb9@byu.net>

	Avoid MacOS readdir bug in testsuite.
	* tests/local.at (AC_STATE_SAVE): Avoid spurious failures due to
	duplicated ls entries.
	* THANKS: Update.
	Reported by Bruce Dugan and others.

2008-11-29  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autotest/general.m4 (AT_JOB_FIFO_FD): Hide zsh 4.3.4
	error messages about `set -m'.

2008-11-27  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix a couple of test failures with dash.
	* tests/autotest.at (AT_CHECK_AT_TITLE_CHAR): Normalize
	exit status of `cd'.
	* tests/m4sh.at (AS_MESSAGE_LOG_FD): Remove script before
	regeneration, to avoid timing effects.

2008-11-25  Eric Blake  <ebb9@byu.net>

	Add m4_cleardivert.
	* lib/m4sugar/m4sugar.m4 (m4_cleardivert): New macro.
	* lib/autotest/general.m4 (AT_INIT): Use it.
	* lib/autoconf/general.m4 (_AC_INIT_NOTICE): Likewise.
	* tests/m4sugar.at (m4@&t@_divert_stack): Test it.
	* doc/autoconf.texi (Diversion support) <m4_cleardivert>: Document
	it.
	* NEWS: Likewise.
	Suggested by Paolo Bonzini.

	Add safety check for m4_expand vs. diversions.
	* lib/m4sugar/m4sugar.m4 (m4_expand): Make more robust against
	diverted text.
	* doc/autoconf.texi (Evaluation Macros) <m4_expand>: Document new
	safety check.

2008-11-24  Eric Blake  <ebb9@byu.net>

	Fix typo in AS_MESSAGE_LOG_FD patch.
	* lib/m4sugar/m4sh.m4 (AS_ERROR): Check correct condition.

2008-11-23  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	More reliable signal handling in Autotest.
	* lib/autotest/general.m4 (Driver loop): Rewrite signal handler.
	Start parallel jobs in their own process group, enabling job
	control in the shell if possible, for better signal handling.
	Deal with INT, TERM, and HUP in the testsuite driver.  In the
	parallel driver, propagate TSTP to jobs either as TSTP or as
	STOP (to avoid fork bombs with ksh).
	Inside the job processes, add PIPE handler to write back the
	job token, so the master process does not hang.
	Disable the parallel driver if job control is not provided or if
	trap does not understand signal names.
	* tests/autotest.at (parallel autotest and signals): New test,
	exercises INT, TERM, and PIPE, serial and parallel, with and
	without `make' in the loop.
	Kudos to Richard Stevens for writing APUE.

2008-11-22  Eric Blake  <ebb9@byu.net>

	Fix testsuite failure on Solaris.
	* tests/torture.at (AT_CHECK_CONFIG_CREATION_NOWRITE): Normalize
	failure status to 1.

2008-11-21  Eric Blake  <ebb9@byu.net>

	Clean up AS_MESSAGE_LOG_FD usage.
	* lib/m4sugar/m4sh.m4 (AS_MESSAGE_FD, AS_MESSAGE_LOG_FD)
	(AS_ORIGINAL_STDIN_FD): Provide default M4sh values.
	(_AS_ECHO_LOG, AS_MESSAGE, _AS_ERROR_PREPARE, AS_ERROR): Simplify
	usage.
	(AS_INIT_GENERATED): Don't shuffle an unchanged AS_MESSAGE_FD.
	* tests/m4sh.at (AS@&t@_INIT_GENERATED): Update test.
	(AS@&t@_MESSAGE_FD): New test.
	* doc/autoconf.texi (Initialization Macros) <AS_INIT_GENERATED>:
	Give more details about fd manipulation.
	(File Descriptor Macros): Describe M4sh defaults for the fds.

2008-11-21  Eric Blake  <ebb9@byu.net>

	Use shell function for AS_ERROR.
	* lib/m4sugar/m4sh.m4 (_AS_ERROR_PREPARE): New macro, defining a
	new shell function.
	(AS_ERROR): Use it.
	(_AS_LINENO_PREPARE): Break circular dependency.
	(AS_PREPARE, _AS_PREPARE): Initialize for child scripts.

2008-11-21  Eric Blake  <ebb9@byu.net>

	Fix typos in recent testsuite improvements.
	* lib/autotest/general.m4 (AT_INIT) <at_fn_check_prepare_dynamic>:
	Fix typo.
	* NEWS: Clarify the potential impact to users.
	* tests/autotest.at (AT_DATA_AUTOTEST): New macro, patterned after
	AT_DATA_M4SUGAR.
	(AT_CHECK_AT_PREP, AT_CHECK_AT_TITLE): Use it.
	(unusual file names): Test that the recent echo fix does not
	regress.  Fix quoting bug that made the test a no-op.
	Reported by Paolo Bonzini and Ralf Wildenhues.

2008-11-21  Eric Blake  <ebb9@byu.net>

	Use modern m4sh constructs in autoconf.
	* bin/autoconf.as (exit_missing_arg, getopt): Use AS_ERROR, rather
	than AS_EXIT.

	Change the semantics of AS_EXIT without argument.
	* lib/m4sugar/m4sh.m4 (_AS_EXIT_PREPARE): When defaulting, use $?
	even if it is 0.
	(AS_ERROR): Guarantee non-zero status.
	* bin/autoconf.as (exit_missing_arg, getopt): Revert prior change;
	we want non-zero status.
	* tests/m4sh.at (AS@&t@_EXIT): Update test accordingly.
	* doc/autoconf.texi (Common Shell Constructs) <AS_EXIT>: Update
	the documentation.
	<AS_SET_STATUS>: Don't overly restrict implementation.
	(Printing Messages) <AC_MSG_ERROR>: Describe better default.
	Suggestions by Paolo Bonzini and Ralf Wildenhues.

2008-11-21  Eric Blake  <ebb9@byu.net>

	Add @anchors within Builtins and Usual Tools lists.
	* doc/autoconf.texi (Limitations of Builtins)
	(Limitatations of Usual Tools): Add anchors for tools called out
	by name.  Adjust callers to narrow in on tool of interest.

	Move case statement style discussion to m4 quoting section.
	* doc/autoconf.texi (Limitations of Builtins): Move comparison of
	quoting styles...
	(Balancing Parentheses): ...to this new node.
	Suggested by Ralf Wildenhues.

2008-11-20  Eric Blake  <ebb9@byu.net>

	Factor more common code out of AT_CHECK into shell function.
	* lib/autotest/general.m4 (_AT_CHECK): Avoid echo bug if AT_LINE
	starts with -.  Move preparations...
	(AT_INIT) <at_fn_check_prepare_trace>
	<at_fn_check_prepare_notrace, at_fn_check_prepare_dynamic>:
	...into these new shell functions.
	<at_fn_check_newline>: Inline into only caller.
	(_AT_DECIDE_TRACEABLE): Use them to condense testsuite size.

2008-11-20  Eric Blake  <ebb9@byu.net>

	Handle version numbers as decimal, even if they start with 0.
	* lib/m4sugar/m4sugar.m4 (_m4_version_unletter): Avoid
	interpreting leading zeros as octal.

2008-11-20  Eric Blake  <ebb9@byu.net>

	Speed up AT_CHECK.
	* lib/autotest/general.m4 (AT_CHECK, AT_CHECK_UNQUOTED): Expand
	third and fourth arguments once.
	(_AT_CHECK): Don't re-expand expected output.  Rearrange code for
	fewer scans of arguments.
	(AT_CHECK): Update caller.
	(AT_INIT) <at_fn_filter_trace>: Drop parameter.
	* tests/m4sugar.at (m4@&t@_split): Protect test with
	quadrigraphs.

	Fix XFAIL related to AT_CHECK.
	* lib/autotest/general.m4 (AT_CHECK, AT_CHECK_UNQUOTED): Expand
	first argument once.
	(_AT_CHECK): Don't re-expand commands.
	* tests/autotest.at (Multiline command from M4 expansion): Remove
	XFAIL.
	* tests/tools.at (autoupdating AU_ALIAS): Quote unbalanced paren.
	* NEWS: Document the fallout.

2008-11-20  Eric Blake  <ebb9@byu.net>

	Reduce forks in AC_DEFINE.
	* lib/autoconf/general.m4 (_AC_DEFINE_Q_PRINT): New macro.
	(_AC_DEFINE_Q): Use it to avoid forks for all AC_DEFINE and most
	AC_DEFINE_UNQUOTED.
	* lib/autoconf/fortran.m4 (_AC_FC_WRAPPERS): Properly quote #.
	* tests/torture.at (Substitute and define special characters):
	(Define to a 2000-byte string): Enhance tests to cover
	AC_DEFINE_UNQUOTED.
	(@%:@define header templates): Enhance test to cover #.

2008-11-20  Eric Blake  <ebb9@byu.net>

	Improve m4_expand robustness, part 2.
	* lib/m4sugar/m4sugar.m4 (m4_expand): Support unterminated
	comments, by wrapping old implementation...
	(_m4_expand): ...as this, and renaming old core...
	(_m4_expand_): ...to this.
	(m4_text_box): Use lighter-weight _m4_expand.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_EXPAND)
	(_AS_DETECT_BETTER_SHELL, AS_FUNCTION_DESCRIBE): Likewise.
	* lib/autotest/general.m4 (AT_KEYWORDS): Likewise.
	* tests/m4sugar.at (m4@&t@_expand): Enhance test.
	* tests/autotest.at (AT_CHECK_AT_TITLE_CHAR): Likewise.
	* doc/autoconf.texi (Evaluation Macros) <m4_expand>: Mention new
	functionality.

	Improve m4_expand robustness, part 1.
	* lib/m4sugar/m4sugar.m4 (_m4_expand): Tolerate unquoted
	unbalanced `)'.
	* tests/m4sugar.at (m4@&t@_expand): New test.

2008-11-20  Eric Blake  <ebb9@byu.net>

	Add m4_chomp, m4_esyscmd_s.
	* lib/m4sugar/m4sugar.m4 (m4_esyscmd_e, m4_chomp, m4_chomp_all):
	New macros.
	* doc/autoconf.texi (Redefined M4 Macros) <m4_esyscmd_s>: Document
	them.
	(Text processing Macros) <m4_chomp>: Likewise.
	* NEWS: Likewise.
	* tests/m4sugar.at (m4@&t@_esyscmd_s): New test.

	Remove _m4_index.
	* lib/m4sugar/m4sugar.m4 (_m4_index): Delete; it is more efficient
	to make callers guarantee a match.
	(m4_init): Adjust caller.
	* lib/autoconf/status.m4 (_AC_CONFIG_COMPUTE_DEST): Likewise.
	* lib/autoconf/general.m4 (_AC_DEFINE_Q): Likewise.

	Describe different hacks for balancing ')' in case statements.
	* doc/autoconf.texi (Limitations of Builtins) <case>: Add an
	exposition on various quoting styles.

2008-11-20  Eric Blake  <ebb9@byu.net>

	Speed up _AS_QUOTE.
	* lib/m4sugar/m4sh.m4 (_AS_QUOTE_IFELSE): Inline into...
	(_AS_QUOTE): ...here, delete unused second paramenter, and factor
	choice into...
	(_AS_QUOTE_MODERN, _AS_QUOTE_OLD): ...new helpers.

2008-11-20  Alfred G. de Wijn  <dwijn@iluvatar.eu.org>  (tiny change)

	For consistency, make temporary variable match language name.
	* lib/autoconf/fortran.m4 (_AC_PROG_FC_G, _AC_PROG_FC_V_OUTPUT):
	Match the save/test variables' names to the FFLAGS/FCFLAGS being
	saved.
	* THANKS: Update.

2008-11-19  Eric Blake  <ebb9@byu.net>

	Improve testsuite generation.
	* tests/local.at (AT_DATA_M4SUGAR, AT_DATA_M4SH)
	(AT_DATA_AUTOCONF): Escape all quadrigraphs, not just @&t@.  Use
	fewer macros.

2008-11-18  Eric Blake  <ebb9@byu.net>

	Use fn for shell functions, func for autoconf CHECK_FUNCS.
	* lib/autoconf/functions.m4 (AC_CHECK_FUNC): Abbreviate shell
	function names.
	* lib/autoconf/general.m4 (_AC_PREPROC_IFELSE)
	(_AC_COMPILE_IFELSE, _AC_LINK_IFELSE, _AC_RUN_IFELSE)
	(AC_CHECK_DECL, AC_COMPUTE_INT): Likewise.
	* lib/autoconf/headers.m4 (_AC_CHECK_HEADER_MONGREL)
	(_AC_CHECK_HEADER_COMPILE, _AC_CHECK_HEADER_PREPROC): Likewise.
	* lib/autoconf/types.m4 (_AC_CHECK_TYPE_NEW, _AC_TYPE_INT)
	(_AC_TYPE_UNSIGNED_INT, AC_CHECK_MEMBER): Likewise.
	* lib/autotest/general.m4 (AT_INIT): Likewise.
	* lib/m4sugar/m4sh.m4 (_AS_SHELL_FN_WORK, _AS_EXIT_PREPARE)
	(AS_EXIT, AS_SET_STATUS, _AS_UNSET_PREPARE, _AS_MKDIR_P)
	(_AS_MKDIR_P_PREPARE, _AS_VAR_APPEND_PREPARE, AS_VAR_APPEND)
	(_AS_VAR_ARITH_PREPARE, AS_VAR_ARITH): Likewise.
	* doc/autoconf.texi (Shell Functions): Likewise.

2008-11-18  Eric Blake  <ebb9@byu.net>

	Alter default value of AS_EXIT.
	* lib/m4sugar/m4sh.m4 (_AS_EXIT_PREPARE): Let as_func_exit
	parameter be optional.
	(AS_EXIT): Use it to make better default.
	(_AS_DETECT_BETTER_SHELL): Use new default.
	* bin/autoconf.as (exit_missing_arg, getopt): Likewise.
	* lib/autoconf/status.m4 (AC_OUTPUT): Likewise.
	* tests/m4sh.at (AS@&t@_EXIT): Update test.
	* doc/autoconf.texi (Common Shell Constructs) <AS_EXIT>: Mention
	new default behavior.
	(Limitations of Builtins) <trap>: Adjust to use new default.
	* NEWS: Mention the semantic change.
	Suggested by Ralf Wildenhues.

	Update example to match actual Tru64 behavior.
	* doc/autoconf.texi (Limitations of Builtins) <trap>: Correct
	the example.
	Reported by Ralf Wildenhues.

	Add AS_SET_STATUS, make AS_EXIT more efficient.
	* lib/m4sugar/m4sh.m4 (_AS_EXIT_PREPARE, AS_SET_STATUS): New
	macros.
	(AS_EXIT): Rewrite to avoid forks.
	(_AS_SHELL_SANITIZE): Avoid AS_EXIT prior to shell functions.
	(AS_PREPARE, _AS_PREPARE): Add new preparation.
	* doc/autoconf.texi (Common Shell Constructs) <AS_SET_STATUS>:
	Document.
	* NEWS: Mention new macro.
	* tests/m4sh.at (AS@&t@_EXIT): New test.
	(BASENAME_TEST): Sort.

	Document Tru64 bug with 'set -e'.
	* doc/autoconf.texi (Limitations of Builtins) <trap>: Mention a
	bug in mixing 'set -e' with 'trap .. 0'.
	Reported by Ralf Wildenhues.

	Document a Solaris /bin/sh bug with 'set -e'.
	* doc/autoconf.texi (Shell Functions): Mention the bug.

2008-11-17  Eric Blake  <ebb9@byu.net>

	Detect empty list in AS_FOR.
	* lib/m4sugar/m4sh.m4 (AS_FOR): Handle iteration over $@
	properly.
	* tests/m4sh.at (AS@&t@_FOR): Enhance test to catch it.
	Reported by Paolo Bonzini.

2008-11-16  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Use a different workaround for an automake quirk.
	* tests/Makefile.am (AUTOMAKE_OPTIONS): Remove.
	(distclean_generic): New helper variable, to fool automake.
	($(distclean_generic)): Depend on clean-local, to prevent
	the race in the two rules with accessing and removing
	$(TESTSUITE).
	Report by Eric Blake.

	* lib/m4sugar/m4sh.m4 (_AS_VAR_ARITH_PREPARE): Simplify, avoid
	unbalanced parentheses from last change.
	Spotted by Eric Blake, fix suggested by Paolo Bonzini.

	Fix exit status of expr version of as_func_arith.
	* lib/m4sugar/m4sh.m4 (_AS_VAR_ARITH_PREPARE): Count an exit
	status of 1 of expr also as success, to avoid failure if the
	computation result is zero.  Fixes test failures with IRIX sh,
	where the expr variant of as_func_arith is used.

	Do not use read-only variable $status.
	* tests/compile.at (AC_RUN_IFELSE): Use $estatus instead of
	$status, for zsh.

2008-11-15  Eric Blake  <ebb9@byu.net>

	Use the new AS_FOR function.
	* lib/autoconf/functions.m4 (AC_CHECK_FUNCS): Use new
	abstraction for cleaner code.
	* lib/autoconf/headers.m4 (AC_CHECK_HEADERS): Likewise.

	Add AS_FOR, undocumented for now.
	* lib/m4sugar/m4sh.m4 (AS_FOR): New macro.
	* tests/m4sh.at (AS@&t@_FOR): New test.
	Suggested by Paolo Bonzini.

2008-11-13  Eric Blake  <ebb9@byu.net>

	Optimize single-argument loop.
	* lib/autoconf/functions.m4 (AC_CHECK_FUNCS): Avoid forks when
	loop only has one argument.
	* lib/autoconf/headers.m4 (AC_CHECK_HEADERS): Likewise.

2008-11-13  Eric Blake  <ebb9@byu.net>

	Fix AS_ESCAPE usage bugs.
	* lib/m4sugar/m4sh.m4 (_AS_VAR_APPEND_PREPARE)
	(_AS_VAR_ARITH_PREPARE): Expand macros prior to adding shell
	escapes.
	(AS_TR_SH, AS_VAR_GET): Use _AS_ESCAPE for speed.
	* doc/autoconf.texi (Polymorphic Variables) <AS_VAR_SET>: Document
	caveat due to conditional AS_ESCAPE.
	* tests/m4sh.at (AS@&t@_VAR basics): Enhance test.

2008-11-12  Eric Blake  <ebb9@byu.net>

	Whitespace reduction in configure.
	* lib/autoconf/autoheader.m4 (AH_VERBATIM): Avoid empty lines.
	* lib/autoconf/general.m4 (_AC_INIT_PREPARE, AC_CHECK_FILES):
	Likewise.
	(_AC_DEFINE_Q): Restore empty line, since some clients in the wild
	depend on it.

2008-11-12  Eric Blake  <ebb9@byu.net>

	Make M4sh, not autoconf, guarantee sane $SHELL.
	* lib/autoconf/general.m4 (_AC_INIT_DEFAULTS): Move setting of
	SHELL...
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_BETTER_SHELL): ...to here.
	* doc/autoconf.texi (Initialization Macros): Document the effect
	on SHELL.
	* tests/m4sh.at (AS@&t@_INIT_GENERATED): New test.
	Reported by Ralf Wildenhues.

2008-11-12  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Wrap keywords in `testsuite --list' output.
	* lib/autotest/general.m4 (AT_INIT): Rewrite --list awk script,
	avoid lint warnings from gawk, wrap keyword lists to stay below
	80 characters per line if possible.
	* tests/autotest.at (Keyword wrapping): New test.

	* tests/local.at (AT_COPYRIGHT): Bump copyright years.

	* doc/autoconf.texi (Conditional constructs, Macro Names): Fix
	typos.

2008-11-10  Eric Blake  <ebb9@byu.net>

	Work around <=m4-1.4.9 bug in m4_format.
	* lib/m4sugar/m4sugar.m4 (_m4_index): New internal macro.
	(m4_init): Only use it in older m4.
	* lib/autoconf/general.m4 (_AC_DEFINE_Q): Use it to avoid
	m4_format bug in older m4.
	* lib/autoconf/status.m4 (_AC_CONFIG_COMPUTE_DEST): Likewise.
	Reported by Bob Proulx.

2008-11-10  Eric Blake  <ebb9@byu.net>

	Match upstream standards.texi.
	* doc/standards.texi: Resync from upstream.
	* doc/fdl-1.3.texi: Rename...
	* doc/fdl.texi: ...to this.
	* doc/Makefile.am (autoconf_TEXINFOS, standards_TEXINFOS): Update
	users.
	* doc/autoconf.texi (GNU Free Documentation License): Likewise.
	* cfg.mk (fetch): Likewise.

	Yet more FDL 1.3 fallout.
	* NEWS: Mention manual license change.

2008-11-10  Eric Blake  <ebb9@byu.net>

	Avoid some regex uses.
	* lib/autoconf/general.m4 (_AC_DEFINE_Q): Use m4_format rather
	than m4_bpatsubst to grab string prefix.
	* lib/autoconf/status.m4 (_AC_CONFIG_REGISTER)
	(_AC_CONFIG_REGISTER_DEST, AC_CONFIG_SUBDIRS): Likewise.
	(_AC_FILE_DEPENDENCY_TRACE_COLON): Use m4_translit instead of
	m4_bpatsubst to change bytes.
	(_AC_CONFIG_DEPENDENCY_DEFAULT): Use m4_index rather than
	m4_bmatch to find byte.
	(_AC_CONFIG_COMPUTE_DEST): New helper macro.

	Use more efficient macros in AC_CONFIG_SUBDIRS.
	* lib/autoconf/status.m4 (_AC_CONFIG_FOOS, AC_CONFIG_SUBDIRS): Use
	m4_map_args_w.
	(_AC_OUTPUT_FILE): Use m4_map_args_sep and m4_map_args.
	(_AC_OUTPUT_FILE_ADJUST_DIR): New helper macro.

	Use more efficient macros in AC_CHECK_FILES and AC_CHECK_DECLS.
	* lib/autoconf/general.m4 (AC_CHECK_FILES): Use m4_map_args_w,
	and avoid typo.
	(AC_CHECK_DECLS, AC_CHECK_DECLS_ONCE): Use m4_map_args_sep.
	(_AC_CHECK_FILES, _AC_CHECK_DECLS, _AC_CHECK_DECL_ONCE): New
	helper macros.
	(AC_LIBSOURCES): Use m4_map_args.

	Use more efficient macros in AC_CHECK_TYPES.
	* lib/autoconf/types.m4 (AC_CHECK_TYPES, AC_CHECK_MEMBERS): Use
	m4_map_args_sep.
	(_AC_CHECK_TYPES, _AC_CHECK_MEMBERS): New helper macros.

	Use more efficient macros in AC_CHECK_HEADERS.
	* lib/autoconf/headers.m4 (AH_CHECK_HEADERS)
	(AH_CHECK_HEADERS_DIRENT): Rename...
	(_AH_CHECK_HEADER, _AH_CHECK_HEADER_DIRENT): ...and take only one
	argument, rather than a list.
	(AC_CHECK_HEADERS, AC_CHECK_HEADERS_ONCE):
	Adjust callers to use m4_map_args_w.
	(AC_HEADER_DIRENT): Adjust caller to use m4_map_args.
	(_AC_CHECK_HEADER_ONCE): New helper macro.

	Use more efficient macros in AC_CHECK_FUNCS.
	* lib/autoconf/functions.m4 (_AH_CHECK_FUNCS): Rename...
	(_AH_CHECK_FUNC): ...and take only one argument, rather than a
	list.
	(AC_CHECK_FUNCS, AC_CHECK_FUNCS_ONCE): Adjust callers to use
	m4_map_args_w.
	(_AC_CHECK_FUNC_ONCE): New helper macro.
	(AC_REPLACE_FUNCS): Use m4_map_args_w.

	Use more efficient macro in AT_INIT.
	* lib/autotest/general.m4 (AT_INIT): Use m4_map_args.

2008-11-10  Eric Blake  <ebb9@byu.net>

	More FDL 1.3 fallout.
	* cfg.mk (fetch): Add gnu-oids.texi, drop fdl.texi.
	* doc/Makefile.am (standards_TEXINFOS): Reflect upstream
	dependency changes.
	* doc/fdl.texi: Delete.
	* doc/gnu-oids.texi: New upstream file.
	* doc/standards.texi: Resync from upstream.
	* doc/make-stds.texi: Likewise.
	* build-aux/announce-gen: Likewise.
	* build-aux/texinfo.tex: Likewise.

2008-11-10  Clinton Roy  <clinton.roy@gmail.com>  (tiny change)

	Pass autoreconf -I to aclocal -I
	* bin/autoreconf.in (parse_args): Pass --include to aclocal.
	* doc/autoconf.texi (autoreconf Invocation): Updates for above.
	* NEWS: Document it.
	* THANKS: Update.

2008-11-10  Eric Blake  <ebb9@byu.net>

	Try 'print -r --' as a non-forking variant of 'printf %s\\n'.
	* lib/m4sugar/m4sh.m4 (_AS_ECHO_PREPARE): Cater to Solaris ksh.
	* doc/autoconf.texi (Limitations of Builtins) <printf>: Document
	the print workaround.
	Idea by Paolo Bonzini.

2008-11-10  Eric Blake  <ebb9@byu.net>

	Provide a section on all tools allowed in GNU Coding Standards.
	* doc/autoconf.texi (Limitations of Builtins) <read>: Sort.
	<wait>: Add section.
	(Limitations of Usual Tools) <awk>: Make table entry consistent.
	<chgrp, mkfifo, rmdir, sleep, sort, tar> Add sections.

2008-11-09  Paolo Bonzini  <bonzini@gnu.org>

	Balance parentheses in _AC_CACHE_DUMP.
	* lib/autoconf/general.m4 (_AC_CACHE_DUMP): Balance parentheses
	without introducing \).

2008-11-07  Eric Blake  <ebb9@byu.net>

	Further doc updates for AC_CHECK_HEADER change.
	* doc/autoconf.texi (Generic Headers) <AC_CHECK_HEADER>: Mention
	new default, and make it more obvious that using [-] is generally
	broken.

2008-11-07  Eric Blake  <ebb9@byu.net>

	* ChangeLog: Enforce UTF-8 encoding.

2008-11-06  Eric Blake  <ebb9@byu.net>

	Skip preprocessor check in AC_CHECK_HEADERS_ONCE.
	* lib/autoconf/headers.m4 (_AC_HEADERS_EXPANSION): Provide fourth
	argument to speed up check.

2008-11-06  Eric Blake  <ebb9@byu.net>

	Speed up AC_CHECK_TYPE.
	* lib/autoconf/types.m4 (AC_CHECK_TYPE): Factor out $@, and avoid
	regex when enough arguments are present.

2008-11-06  Paolo Bonzini  <bonzini@gnu.org>

	Remove three forks per _AC_RUN_LOG_STDERR in the common case.
	* lib/autoconf/general.m4 (_AC_RUN_LOG_STDERR): Avoid grep/rm/cat
	sequence when the program's stderr was empty, while providing a
	conftest.err file even in that case.
	(_AC_CACHE_DUMP): Fix mismatched parenthesis.

2008-11-06  Paolo Bonzini  <bonzini@gnu.org>

	Change `present but cannot be compiled' behavior to use compiler result.
	* NEWS: Document it.
	* doc/autoconf.texi (Present But Cannot Be Compiled): Document it.
	* lib/autoconf/headers.m4 (_AC_CHECK_HEADER_MONGREL): Implement it
	and adjust warning.
	* tests/semantics.at (AC_CHECK_HEADERS): Test new semantics.

2008-11-05  Eric Blake  <ebb9@byu.net>

	Add m4_map_args_w.
	* lib/m4sugar/m4sugar.m4 (m4_map_args_w): New macro, undocumented
	for now.
	(_m4_split): Allow user control over separator.
	(m4_split): Adjust caller.
	(m4_foreach_w, m4_append_uniq_w, _m4_text_wrap): Rewrite to use
	m4_map_args_w.
	* tests/m4sugar.at (m4@&t@_append): Augment test keywords.
	(M4 loops): Test new interface.

	Use m4_set_map_sep in more places.
	* lib/m4sugar/m4sugar.m4 (m4_set_difference, m4_set_intersection)
	(m4_set_union): Use m4_set_map_sep rather than m4_set_foreach.
	* doc/autoconf.texi (Set manipulation Macros) <m4_set_map>:
	Enhance documentation.
	<m4_set_foreach>: Mention faster alternative.
	(Looping constructs) <m4_foreach>: Likewise.

	Unify m4_set_foreach and m4_set_map.
	* lib/m4sugar/m4sugar.m4 (m4_set_map_sep): New macro, undocumented
	for now.
	(m4_set_contents, m4_set_foreach, m4_set_list, m4_set_listc)
	(m4_set_map): Adjust callers.

	Use _m4_foreach in more places.
	* lib/m4sugar/foreach.m4 (m4_dquote_elt, m4_join, m4_joinall)
	(_m4_minmax, m4_set_add_all): Use _m4_foreach instead of
	m4_foreach.
	* lib/m4sugar/m4sugar.m4 (_m4_joinall): Use m4_map_args_sep
	instead of m4_foreach or m4_map_args.

	Unify _m4_foreach and _m4_map.
	* lib/m4sugar/m4sugar.m4 (_m4_map): Delete, merged with...
	(_m4_foreach): ...this.
	(m4_foreach, m4_map, m4_mapall, m4_map_sep, _m4_mapall_sep)
	(m4_map_args, m4_map_args_sep): Adjust callers.
	* lib/m4sugar/foreach.m4 (_m4_map): Rename...
	(_m4_foreach): ...to this, overwriting old definition.

2008-11-04  Eric Blake  <ebb9@byu.net>

	Add m4_map_args_sep, undocumented for now.
	* lib/m4sugar/m4sugar.m4 (m4_map_args_sep): New macro.
	(_m4_map): Change API to cover more of m4_map*.
	* lib/m4sugar/foreach.m4 (_m4_map): Adjust to new API.
	(m4_map_args): Delete.
	* tests/m4sugar.at (m4@&t@_map_args and m4@&t@_curry): Enhance
	test.

	Improve m4_for performance.
	* lib/m4sugar/m4sugar.m4 (_m4_for): Alter API to make it easier to
	avoid m4_define by some clients.
	(m4_for): Adjust caller.
	* lib/m4sugar/foreach.m4 (_m4_foreach, m4_case, m4_bmatch)
	(_m4_cond, _m4_bpatsubsts, _m4_shiftn, m4_do, m4_reverse)
	(_m4_map, m4_map_args, m4_map_args_pair, _m4_list_pad)
	(_m4_list_cmp): Likewise.

2008-11-04  Eric Blake  <ebb9@byu.net>

	Adjust expected output.
	* tests/torture.at (Missing templates): Reflect added quoting.
	Detected by Bob Proulx's buildbot.

	Reject arguments with leading =.
	* lib/autoconf/general.m4 (_AC_INIT_PARSE_ARGS): Detect case of
	missing variable name, with fewer forks.  Quote invalid arguments
	in message, in case they include spaces.
	* lib/autoconf/status.m4 (_AC_OUTPUT_CONFIG_STATUS)
	(_AC_OUTPUT_MAIN_LOOP): Quote invalid arguments.
	* lib/autotest/general.m4 (AT_INIT): Likewise.
	* tests/base.at (configure arguments): Test this.
	Reported by Jeff Squyres.

2008-11-04  Eric Blake  <ebb9@byu.net>

	Upgrade to FDL 1.3.
	* cfg.mk (fetch): Add fdl-1.3.texi.
	* .gitattributes: Likewise.
	* doc/autoconf.texi (GNU Free Documentation License): Point to new
	upstream version.
	* doc/Makefile.am (autoconf_TEXINFOS): Likewise.
	(standards_TEXINFOS): Mention current dependence on older license.
	* doc/fdl-1.3.texi: New upstream file.
	* GNUmakefile: Resync from upstream.
	* build-aux/announce-gen: Likewise.
	* build-aux/texinfo.tex: Likewise.

2008-11-03  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Point at AM_SUBST_NOTMAKE.
	* doc/autoconf.texi (Setting Output Variables): Add cross
	reference to new Automake macro AM_SUBST_NOTMAKE.

2008-11-03  Paolo Bonzini  <bonzini@gnu.org>

	Eliminate a fork per invocation of AC_LANG_CONFTEST.
	* lib/autoconf/c.m4 (AC_LANG_CONFTEST(C)): Define instead of
	AC_LANG_SOURCE(C).
	* lib/autoconf/general.m4 (_AC_INIT_PREPARE): Add a comment at the
	top of confdefs.h, which also works around cpp deficiencies.
	* lib/autoconf/lang.m4 (AC_LANG_DEFINE): Define AC_LANG_CONFTEST(xyz)
	(AC_LANG_CONFTEST): Dispatch based on _AC_LANG.
	(AC_LANG_CONFTEST()): New.

2008-11-03  Paolo Bonzini  <bonzini@gnu.org>

	Reorganize definition of languages.
	* lib/autoconf/c.m4 (AC_LANG(C), AC_LANG(C++), AC_LANG(Objective C),
	_AC_LANG_ABBREV(C), _AC_LANG_ABBREV(C++), _AC_LANG_ABBREV(Objective C),
	_AC_LANG_PREFIX(C), _AC_LANG_PREFIX(C++), _AC_LANG_PREFIX(Objective C)):
	Replace definitions with usage of AC_LANG_DEFINE.
	(Sections 2b, 2c): Delete.
	(Sections 1b, 1c): Move after section 2a.
	* lib/autoconf/erlang.m4 (AC_LANG(Erlang), _AC_LANG_ABBREV(Erlang),
	_AC_LANG_PREFIX(Erlang), AC_LANG_SOURCE(Erlang)): Replace definitions
	with usage of AC_LANG_DEFINE.
	(AC_LANG_ERLANG): Define using AU_DEFUN.
	* lib/autoconf/fortran.m4 (AC_LANG(Fortran), AC_LANG(Fortran 77),
	_AC_LANG_ABBREV(Fortran), _AC_LANG_ABBREV(Fortran 77),
	_AC_LANG_PREFIX(Fortran), _AC_LANG_PREFIX(Fortran 77),
	_AC_LANG_SOURCE(Fortran), AC_LANG_SOURCE(Fortran 77)): Replace
	definitions with usage of AC_LANG_DEFINE.
	* lib/autoconf/lang.m4 (AC_LANG_DEFINE, AC_LANG_SOURCE()): New.

2008-11-03  Paolo Bonzini  <bonzini@gnu.org>

	Use preprocessor in cpp tests.
	* tests/c.at (CPP tests): Use AC_CHECK_HEADERS(..., [-]).

2008-10-31  Paolo Bonzini  <bonzini@gnu.org>

	Rename _AC_CHECK_HEADER_OLD and _AC_CHECK_HEADER_NEW.
	* lib/autoconf/headers.m4 (AC_CHECK_HEADER): Adjust naming.
	(_AC_CHECK_HEADER_PREPROC_BODY): New name of _AC_CHECK_HEADER_OLD_BODY.
	(_AC_CHECK_HEADER_COMPILE_BODY): New name of _AC_CHECK_HEADER_NEW_BODY.
	(_AC_CHECK_HEADER_PREPROC): New name of _AC_CHECK_HEADER_OLD.
	(_AC_CHECK_HEADER_COMPILE): New name of _AC_CHECK_HEADER_NEW.
	* tests/semantics.at (AC_CHECK_HEADERS_OLD, AC_CHECK_HEADER_NEW):
	Give better name.

2008-10-31  Eric Blake  <ebb9@byu.net>

	Support multiple undiverts and dumpdefs at once.
	* lib/m4sugar/m4sugar.m4 (m4_dumpdefs, m4_undivert): Allow extra
	arguments.
	* doc/autoconf.texi (Redefined M4 Macros) <m4_dumpdef>,
	<m4_undivert>: Document argument list change.
	* tests/m4sugar.at (m4@&t@_divert_stack, m4@&t@_dumpdef): Test
	them.

	Simplify diversion stack handling.
	* lib/m4sugar/m4sugar.m4 (m4_divert_stack): Use fewer macros, and
	avoid extra newlines.
	(m4_divert_stack_push): Compute location here, rather than caller.
	(m4_divert_push): Update caller.
	(m4_divert): Likewise, and also adjust current diversion name.
	(m4_divert_pop): Simplify rule that diversion stack must never go
	empty.
	(_m4_require_call): Bypass diversion stack when collecting
	required macro text.
	(m4_init): Set current diversion without requiring m4_init.
	* lib/m4sugar/m4sh.m4 (AS_INIT): Avoid too many pops.
	* lib/autotest/general.m4 (AT_INIT): Likewise.
	* lib/autoconf/general.m4 (_AC_INIT_DEFAULTS): Schedule wrapped
	text to run prior to m4sugar cleanup.
	* doc/autoconf.texi (Text processing Macros) <m4_newline>: Mention
	optional argument.
	(Conditional constructs) <m4_ifvaln, m4_n>: Mention use of dnl.
	* NEWS: Undo blurb about m4_divert.
	* tests/m4sugar.at (m4@&t@_divert_stack): New test.

	Simplify expansion stack handling.
	* lib/m4sugar/m4sugar.m4 (m4_expansion_stack): Use fewer macros;
	always output 'top level'.
	(_m4_expansion_stack_entry): New macro, to format the string only
	when needed.
	(m4_expansion_stack_push): Only push a macro name.
	(m4_warn, _m4_defun_pro): Update callers.
	(m4_expansion_stack_pop, m4_expansion_stack_dump): Delete.
	(_m4_defun_epi, m4_fatal): Inline the calls.
	* tests/m4sugar.at (m4@&t@_expansion_stack): New test.

2008-10-30  Eric Blake  <ebb9@byu.net>

	Better documentation of AC_CHECK_HEADER's fourth argument.
	* doc/autoconf.texi (Generic Headers) <AC_CHECK_HEADER>: Mention
	how to suppress compiler or preprocessor header check.
	Reported by Jeff Squyres.

2008-10-30  Eric Blake  <ebb9@byu.net>

	Fix LINENO testsuite failure.
	* tests/m4sh.at (AT_DATA_LINENO): Use AS_LINENO_PREPARE, not
	undocumented _AS_PREPARE, and move unset earlier in script.

	Update LINENO documentation.
	* doc/autoconf.texi (Initialization Macros) <AS_INIT_GENERATED>:
	(Special Shell Variables) <LINENO>: Mention that LINENO support in
	child scripts may be broken.  Modernize example.

2008-10-30  Paolo Bonzini  <bonzini@gnu.org>

	Do not check for $LINENO in generated scripts.
	* lib/m4sugar/m4sh.m4 (_AS_PREPARE): Do not call _AS_LINENO_PREPARE,
	and explain why.

2008-10-30  Eric Blake  <ebb9@byu.net>

	Don't check for non-POSIX extensions in suggested tests.
	* lib/m4sugar/m4sh.m4 (_AS_VAR_APPEND_WORKS): Remove suggestion;
	we still use += if available, but should not reject shells (like
	dash) that don't provide it.
	(_AS_DETECT_SUGGESTED): Document a policy for m4sh.
	Reported by Paolo Bonzini.

2008-10-30  Paolo Bonzini  <bonzini@gnu.org>

	Pass CONFIG_SHELL down to generated scripts, and re-export SHELL.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_BETTER_SHELL): If proceeding
	with a given CONFIG_SHELL, move it to SHELL.
	(AS_INIT_GENERATED): Re-export SHELL.

2008-10-30  Eric Blake  <ebb9@byu.net>

	Work around Solaris /bin/sh case bug.
	* lib/m4sugar/m4sh.m4 (_AS_CASE, _AS_CASE_DEFAULT): Always provide
	a non-empty command list.
	(AS_CASE): Always guarantee that a case will match.
	* doc/autoconf.texi (Limitations of Builtins) <case>: Document the
	Solaris bug, and mention AS_CASE.

2008-10-30  Paolo Bonzini  <bonzini@gnu.org>

	Require _AS_CR_PREPARE where appropriate.
	* lib/m4sugar/m4sh.m4 (_AS_PREPARE): Call _AS_CR_PREPARE.
	(AS_PREPARE): Require _AS_CR_PREPARE.

	Avoid walking the entire PATH when looking for a better shell.
	* lib/m4sugar/m4sh.m4 (_AS_SHELL_SANITIZE): Test shell characteristics
	as the PATH is walked.

	Add third argument to _AS_PATH_WALK
	* lib/m4sugar/m4sh.m4 (_AS_SHELL_SANITIZE): Do not call _AS_CR_PREPARE.
	(_AS_PATH_WALK): Add third optional argument.

	Trim down the length of the shell function test.
	* lib/m4sugar/m4sh.m4 (_AS_SHELL_FN_WORK): Condense.

2008-10-29  Eric Blake  <ebb9@byu.net>

	Fix LINENO detection to work around bash and pdksh limitations.
	* lib/m4sugar/m4sh.m4 (_AS_LINENO_WORKS): Enhance the test, so
	that we can choose which of two tests to trust.
	(_AS_RUN): Set flag when alternate shell is running.
	(_AS_DETECT_EXPAND): New macro.
	(_AS_DETECT_BETTER_SHELL): Use it to massage LINENO tests.

2008-10-29  Eric Blake  <ebb9@byu.net>

	Mention proper fix for zsh users.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_BETTER_SHELL): Recommend zsh
	version known to work.
	Suggested by Paolo Bonzini.

	Document current beta-quality status.
	* configure.ac: Reflect fact that change to git-version-gen
	produces -, but not always a letter, on non-release builds.
	* BUGS: Mention known issues.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_BETTER_SHELL): Ask for help in
	debugging platforms with deficient shells.

2008-10-29  Eric Blake  <ebb9@byu.net>

	Alter signature of AS_INIT_GENERATED.
	* lib/m4sugar/m4sh.m4 (AS_INIT_GENERATED): Add parameters, and
	manage here-doc and chmod in place.  This also allows future
	changes for optimizing the child via diversion/m4_wrap magic.
	* lib/autoconf/status.m4 (_AC_OUTPUT_CONFIG_STATUS): Update
	caller.
	* doc/autoconf.texi (Initialization Macros) <AS_INIT_GENERATED>:
	Update the documentation.

2008-10-29  Eric Blake  <ebb9@byu.net>

	Use _m4_stack_reverse in m4_set.
	* lib/m4sugar/m4sugar.m4 (_m4_set_contents_1)
	(_m4_set_contents_2): Rewrite to share _m4_stack_reverse
	implementation.
	(m4_set_contents, m4_set_foreach, m4_set_list, m4_set_listc)
	(m4_set_map): Adjust callers to new API.

	Add m4_stack_foreach_sep.
	* lib/m4sugar/m4sugar.m4 (m4_stack_foreach_sep)
	(m4_stack_foreach_sep_lifo): New macros.
	(_m4_stack_reverse): Adjust prototype, to support it.
	(m4_copy): Use fewer macros.
	* tests/m4sugar.at (m4@&t@_stack_foreach): Rename...
	(m4@&t@_stack): ...and add m4_stack_foreach_sep tests.

2008-10-29  Bruno Haible  <bruno@clisp.org>

	Mention Sun WorkShop 6.2 OpenMP bug.
	* doc/autoconf.texi (AC_OPENMP): Document portability pitfall.

2008-10-29  Paolo Bonzini  <bonzini@gnu.org>

	Rewrite handling of diversion and expansion stack.
	* NEWS: Document stricter requirement on m4_init.
	* lib/m4sugar/m4sugar.m4 (m4_divert_stack): New, replacing
	_m4_divert_n_stack.
	(_m4_divert_stack_push): New.
	(m4_divert): Use _m4_divert_stack_push and replace m4_define with
	m4_popdef.
	(m4_divert_push): Use _m4_divert_stack_push.
	(m4_divert_pop): Use m4_divert_stack instead of _m4_divert_n_stack,
	pop _m4_divert_stack instead of m4_divert_stack.
	(m4_expansion_stack): New.  Update comment above it.
	(m4_expansion_stack_push, m4_expansion_stack_pop): Work on
	_m4_expansion_stack instead of m4_expansion_stack.
	(m4_expansion_stack_dump): Check presence of _m4_expansion_stack
	instead of m4_expansion_stack.  Use m4_expansion_stack's expansion
	instead of the definition, and compensate for the trailing newline
	in the expansion.
	(m4_warn, _m4_defun_pro, _m4_defun_epi): Check presence of
	_m4_expansion_stack instead of m4_expansion_stack.
	(m4_newline): Expand first argument after the newline.
	(m4_init): Use m4_divert_stack instead of _m4_divert_n_stack,
	* tests/m4sugar.at (m4_append, m4_text_wrap): Invoke m4_init.
	* tests/tools.at (whitespace in file names, the empty token): Likewise.

2008-10-28  Eric Blake  <ebb9@byu.net>

	Reduce forks while searching for better shell.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_REQUIRED)
	(_AS_DETECT_SUGGESTED): No need to provide extra subshell; _AS_RUN
	already does the job.
	(_AS_DETECT_BETTER_SHELL): Simplify AS_EXIT when not run in a trap
	0 context.

	Undo needless efforts to protect $2 in $2_t.
	* lib/autoconf/types.m4 (_AC_TYPE_INT_BODY)
	(_AC_TYPE_UNSIGNED_INT_BODY): Reduce extra quoting.

2008-10-28  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix parallel test execution output lossage.
	* lib/autotest/general.m4 (_AT_CHECK): Truncate files to hold
	standard output and standard error before the test, use append
	mode for writing.
	* THANKS: Update.
	Caught by Bob Proulx' build daemons, analysis and suggested fix
	by Stéphane Chazelas.

2008-10-28  Eric Blake  <ebb9@byu.net>

	Use m4_map_args in more places.
	* lib/m4sugar/m4sugar.m4 (m4_defn, m4_dumpdef, m4_popdef)
	(m4_undefine, m4_combine): Use m4_map_args, rather than
	m4_foreach.

2008-10-28  Eric Blake  <ebb9@byu.net>

	Override m4 1.4.x dumpdef, as it breaks autom4te.
	* lib/m4sugar/m4sugar.m4 (m4_dumpdef): New implementation.
	(m4_copy): Formatting touchup.
	* doc/autoconf.texi (Redefined M4 Macros) <m4_dumpdef>: Mention
	semantic differences as well as m4_dumpdefs.
	* NEWS: Likewise.
	* tests/m4sugar.at (m4@&t@_dumpdef): New test.

2008-10-28  Eric Blake  <ebb9@byu.net>

	Allow m4sugar to be used without autom4te, such as in bison.
	* lib/m4sugar/m4sugar.m4 (m4_text_wrap, m4_qlen): Document that
	alternate escape sequences can be used.
	(m4_text_box): Likewise.  Don't output quadrigraphs.
	(m4_qdelta): Delete unused macro.

2008-10-28  Paolo Bonzini  <bonzini@gnu.org>

	Add m4_stack_foreach and m4_stack_foreach_lifo.
	* lib/m4sugar/m4sugar.m4 (_m4_stack_reverse): New from _m4_copy.
	(m4_stack_foreach, m4_stack_foreach_lifo): New.
	(m4_copy): Use m4_stack_foreach and m4_curry.
	(_m4_dumpdefs_down, _m4_dumpdefs_up): Remove.
	(m4_dumpdefs): Rewrite using m4_stack_foreach_lifo.
	* tests/m4sugar.at (m4_stack_foreach): New test.

2008-10-28  Paolo Bonzini  <bonzini@gnu.org>

	use a shell function for AC_TYPE_INTx_T
	* lib/autoconf/types.m4 (_AC_TYPE_INT_BODY, _AC_TYPE_UNSIGNED_INT_BODY):
	New.
	(_AC_TYPE_INT, _AC_TYPE_UNSIGNED_INT): Define and use a shell function.

2008-10-28  Paolo Bonzini  <bonzini@gnu.org>

	* lib/autoconf/general.m4 (AC_CHECK_DECL): Fix AS_ESCAPE usage.
	* lib/autoconf/headers.m4 (_AC_CHECK_HEADER_MONGREL,
	_AC_CHECK_HEADER_NEW): Likewise.
	* lib/autoconf/types.m4 (_AC_CHECK_TYPE_NEW, AC_CHECK_MEMBER): Likewise.

2008-10-28  Paolo Bonzini  <bonzini@gnu.org>

	* lib/autoconf/types.m4 (_AC_CHECK_MEMBER_BODY): New.
	(AC_CHECK_MEMBER): Define and use a shell function.

2008-10-27  Eric Blake  <ebb9@byu.net>

	Prefer m4_fatal over AC_FATAL.
	* lib/autoconf/types.m4 (AC_CHECK_SIZEOF, AC_CHECK_ALIGNOF)
	(AC_CHECK_MEMBER): Use non-obsolete macro name.
	* lib/autoconf/fortran.m4 (_AC_LIST_MEMBER_IF): Likewise.
	* lib/autoconf/general.m4 (AC_REQUIRE_AUX_FILE, AC_SUBST):
	Likewise.
	* lib/autoconf/lang.m4 (_AC_LANG_DISPATCH): Likewise.
	* lib/autoconf/status.m4 (_AC_CONFIG_DEPENDENCY_DEFAULT)
	(_AC_CONFIG_UNIQUE, _AC_CONFIG_REGISTER_DEST): Likewise.

2008-10-27  Eric Blake  <ebb9@byu.net>

	Avoid raw carriage return in scripts.
	* lib/autoconf/status.m4 (_AC_OUTPUT_FILES_PREPARE): Generate CR
	via tr, rather than with literal byte.
	* THANKS: Update.
	Reported by Steven R. Loomis; patch suggested by Thomas Dickey.

2008-10-27  Eric Blake  <ebb9@byu.net>

	Use AS_VAR_ARITH.
	* lib/autotest/general.m4 (at_func_arith): Delete; replace all
	clients with AS_VAR_ARITH instead.
	* lib/autoconf/general.m4 (_AC_COMPUTE_INT_COMPILE): Use new
	macro.
	* lib/autoconf/programs.m4 (_AC_FEATURE_CHECK_LENGTH): Likewise.
	* tests/torture.at (Torturing config.status): Likewise.
	* tests/tools.at (autom4te --force): Likewise.

	Add AS_VAR_ARITH.
	* lib/m4sugar/m4sh.m4 (_AS_VAR_ARITH_PREPARE, _AS_VAR_ARITH_WORKS)
	(AS_VAR_ARITH): New macros.
	(_AS_PREPARE, AS_PREPARE): Emit preparation.
	* tests/m4sh.at (AS@&t@_VAR_ARITH): New test.
	* doc/autoconf.texi (Polymorphic Variables) <AS_VAR_ARITH>:
	Document new macro.
	(Limitations of Usual Tools) <expr>: Mention portability problem
	if first argument starts with -.
	(Shell Substitutions) <$((expression))>: Mention it.
	* NEWS: Likewise.

2008-10-27  Eric Blake  <ebb9@byu.net>

	Use read, rather than `cat`, for safe one-line files.
	* lib/autotest/general.m4 (AT_CLEANUP): Avoid a fork, since it is
	known that the file has only one line and no \.
	* lib/autoconf/general.m4 (_AC_COMPUTE_INT_RUN): Likewise.

2008-10-27  Paolo Bonzini  <bonzini@gnu.org>

	* lib/autoconf/general.m4 (_AC_COMPUTE_INT_COMPILE,
	_AC_COMPUTE_INT_RUN): Add IF-SUCCESS argument.
	(_AC_COMPUTE_INT_BODY): New.
	(AC_COMPUTE_INT): Define and use a shell function.

2008-10-27  Paolo Bonzini  <bonzini@gnu.org>

	* lib/autoconf/types.m4 (_AC_CHECK_TYPE_NEW_BODY): Extract
	test body here.  Move head comment of _AC_CHECK_TYPE_NEW here.
	(_AC_CHECK_TYPE_NEW): Define a shell function and call it.

2008-10-27  Paolo Bonzini  <bonzini@gnu.org>

	* lib/autoconf/general.m4 (_AC_CHECK_DECL_BODY): New.
	(AC_CHECK_DECL): Use a shell function.

2008-10-27  Paolo Bonzini  <bonzini@gnu.org>

	* lib/autoconf/headers.m4 (_AC_CHECK_HEADER_OLD,
	_AC_CHECK_HEADER_NEW): Use a shell function.

2008-10-25  Eric Blake  <ebb9@byu.net>

	Track recent copyright assignments.
	* AUTHORS: Update.

2008-10-25  Paolo Bonzini  <bonzini@gnu.org>
	and Eric Blake  <ebb9@byu.net>

	Use a shell function for _AC_CHECK_HEADER_MONGREL.
	* lib/autoconf/headers.m4 (_AC_CHECK_HEADER_MONGREL_BODY): New
	macro.
	(_AC_CHECK_HEADER_MONGREL): Use a shell function.

2008-10-25  Eric Blake  <ebb9@byu.net>

	Simplify _AS_PREPARE handling of functions.
	* lib/m4sugar/m4sh.m4 (AS_REQUIRE_SHELL_FN): Factor...
	(_AS_REQUIRE_SHELL_FN): ...into new helper macro.
	(_AS_PREPARE): Temporarily redefine AS_REQUIRE_SHELL_FN to make
	this task easier.
	(_AS_LINENO_PREPARE): Make more efficient.
	(_AS_MKDIR_P_PREPARE): Simplify use in _AS_PREPARE.
	(_AS_UNSET_PREPARE): Avoid blank newline.
	(AS_INIT): Emit as_func_unset alongside other functions.

2008-10-25  Eric Blake  <ebb9@byu.net>

	Document AS_EXIT.
	* doc/autoconf.texi (Common Shell Constructs) <AS_EXIT>: Document
	this macro.
	(Limitations of Builtins): Mention AS_EXIT.
	* NEWS: Mention it.

	Use AS_EXIT in autoconf.as.
	* bin/autoconf.as: Consistently use AS_EXIT.

2008-10-24  Eric Blake  <ebb9@byu.net>

	Fix m4 underquoting in AC_PROG_INSTALL.
	* lib/autoconf/programs.m4 (AC_PROG_INSTALL): Produce accurate
	character ranges.

	Speed up AC_CHECK_HEADER.
	* lib/autoconf/headers.m4 (AC_CHECK_HEADER): Factor out $@.

2008-10-24  Paolo Bonzini  <bonzini@gnu.org>
	and Eric Blake  <ebb9@byu.net>

	Use a shell function for AC_CHECK_FUNC.
	* lib/autoconf/functions.m4 (_AC_CHECK_FUNC_BODY): New macro.
	(AC_CHECK_FUNC): Use a shell function.
	* lib/autoconf/c.m4 (AC_LANG_SOURCE(C)): Reduce number of forks.

2008-10-24  Eric Blake  <ebb9@byu.net>

	Work around fact that gnulib-tool doesn't use m4_copy.
	* lib/autoconf/general.m4 (AC_LIBOBJ, AC_LIBSOURCES): Defun, not
	define, so that an initial location is present, to account for
	fact that gnulib-tool pushes another AC_DEFUN'd macro on top.

	Make m4_defun_init more robust.
	* lib/m4sugar/m4sugar.m4 (m4_defun_init): Handle indirect macro
	names, and correct number of arguments.
	(m4_copy): Also set up location of the copy.
	(m4_defun): When copied, use current macro name, not original.
	* tests/m4sugar.at (m4@&t@_require: one-shot initialization):
	Update test.

	Optimize clients of AS_REQUIRE.
	* lib/m4sugar/m4sugar.m4 (m4_defun): Add undocumented third
	argument.
	(m4_defun_init): New undocumented macro.
	* lib/m4sugar/m4sh.m4 (_AS_ECHO_LOG, AS_MESSAGE, AS_BASENAME)
	(_AS_DIRNAME_EXPR, AS_DIRNAME, AS_ECHO, AS_ECHO_N, AS_TEST_X)
	(AS_LN_S, AS_MKDIR_P, _AS_PATH_WALK, AS_VERSION_COMPARE)
	(AS_TR_SH, AS_TR_CPP, AS_VAR_APPEND, AS_VAR_PUSHDEF): Use it to
	simplify these macros once the one-shot initialization is
	complete.
	* tests/m4sugar.at (m4@&t@_require: one-shot initialization): New
	test.

	Improve m4_copy.
	* lib/m4sugar/m4sugar.m4 (m4_copy): Add second implementation for
	public use.
	(_m4_copy): New macro, which preserves pushdef stacks.
	(_m4_defun_pro_outer): Bypass it, for speed.
	(m4_init): Bypass new implementation, since it breaks on m4_defn.
	* bin/autoupdate.in (handle_autoconf_macros): Likewise.
	* lib/autoconf/general.m4 (AC_PREREQ): Undefine before redefining,
	now that m4_copy checks this.
	* doc/autoconf.texi (Redefined M4 Macros) <m4_copy>: Document
	this, as well as m4_rename.
	* lib/autoconf/autoconf.m4 (m4_copy): Temporarily redefine when
	renaming builtins, since it breaks on m4_ifdef.
	* NEWS: Likewise.
	* tests/m4sugar.at (m4@&t@_defn): Enhance test.

2008-10-24  Eric Blake  <ebb9@byu.net>

	AC_FUNC_GETGROUPS: Revert regression.
	* lib/autoconf/functions.m4 (AC_FUNC_GETGROUPS): Only set
	ac_cv_func_getgroups_works=no when it is not available.

2008-10-23  Eric Blake  <ebb9@byu.net>

	Whitespace cleanup.
	* lib/autoconf/fortran.m4: Consistently use tabs.

2008-10-23  Chikama Masaki  <masaki.chikama@gmail.com>  (tiny change)

	For gfortran on sh, ignore -little.
	* lib/autoconf/fortran.m4 (_AC_FC_LIBRARY_LDFLAGS): Add -little to
	list of ignored arguments.
	* THANKS: Update.

2008-10-23  Paolo Bonzini  <bonzinI@gnu.org>

	Eliminate empty lines after AC_*_IFELSE.
	* lib/autoconf/general.m4 (_AC_PREPROC_IFELSE, _AC_COMPILE_IFELSE,
	_AC_LINK_IFELSE, _AC_RUN_IFELSE): Add a dnl at end.

2008-10-23  Paolo Bonzini  <bonzinI@gnu.org>

	Avoid a fork in _AC_RUN_LOG and _AC_RUN_LOG_STDERR
	* lib/autoconf/general.m4 (_AC_RUN_LOG, _AC_RUN_LOG_STDERR):
	Return a boolean status code based on $ac_status.

2008-10-23  Paolo Bonzini  <bonzinI@gnu.org>

	Ensure actions can look at conftest* files.
	* lib/autoconf/general.m4 (_AC_PREPROC_IFELSE_BODY,
	_AC_COMPILE_IFELSE_BODY, _AC_LINK_IFELSE_BODY, _AC_RUN_IFELSE_BODY):
	Move rm commands, except IPA files and Apple debug symbols...
	(_AC_PREPROC_IFELSE, _AC_COMPILE_IFELSE, _AC_LINK_IFELSE,
	_AC_RUN_IFELSE): ...in here.
	* tests/compile.at: Add regression test.

2008-10-23  Eric Blake  <ebb9@byu.net>

	Remove excess dnl from m4sh.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_BETTER_SHELL, _AS_PREPARE)
	(_AS_SHELL_FN_WORK, _AS_SHELL_SANITIZE, AS_IF, _AS_ECHO_LOG)
	(AS_MESSAGE, AS_ERROR, AS_BASENAME, _AS_BASENAME_PREPARE)
	(_AS_DIRNAME_EXPR, AS_DIRNAME, _AS_DIRNAME_PREPARE, AS_ECHO)
	(AS_ECHO_N, AS_TEST_X, AS_EXECUTABLE_P, _AS_ME_PREPARE)
	(_AS_LINENO_PREPARE, AS_LN_S, AS_MKDIR_P, _AS_PATH_WALK)
	(AS_SET_CATFILE, AS_HELP_STRING, AS_TMPDIR, AS_VERSION_COMPARE)
	(_AS_TR_SH_PREPARE, AS_TR_SH, _AS_TR_CPP_PREPARE, AS_TR_CPP)
	(_AS_TR_PREPARE, AS_VAR_APPEND, AS_VAR_PUSHDEF)
	(AS_INIT_GENERATED): Use fewer dnl in m4sh macro bodies.

2008-10-23  Paolo Bonzini  <bonzini@gnu.org>
	and Eric Blake  <ebb9@byu.net>

	Use a shell function for _AC_RUN_IFELSE.
	* lib/autoconf/general.m4 (_AC_RUN_IFELSE_BODY): New macro.
	(_AC_RUN_IFELSE): Use a shell function.
	(_AC_RUN_LOG): Avoid subshell for logging.

2008-10-23  Eric Blake  <ebb9@byu.net>

	Formatting tweak: balance () with m4sh case statements.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_BETTER_SHELL)
	(_AS_SHELL_SANITIZE, _AS_ECHO_N_PREPARE, _AS_ECHO_PREPARE)
	(AS_SET_CATFILE, _AS_TEST_PREPARE): Add strategic shell comments.
	(_AS_CASE, _AS_CASE_DEFAULT, AS_CASE): Rearrange newlines, to
	allow output of strategic shell comments.
	(AS_VERSION_COMPARE): Use AS_CASE.
	* tests/m4sh.at (AS@&t@_IF and AS@&t@_CASE): Enhance test.

2008-10-22  Jim Meyering  <meyering@redhat.com>

	AC_FUNC_GETGROUPS: always define $ac_cv_func_getgroups_works
	* lib/autoconf/functions.m4 (AC_FUNC_GETGROUPS): Always define
	the shell variable, $ac_cv_func_getgroups_works.  Otherwise, if
	it is set to "yes" in the environment and configure is run on
	a system like mingw that lacks the getgroups function, it would
	mistakenly define HAVE_GETGROUPS.  Reported by Simon Josefsson in
	<http://thread.gmane.org/gmane.comp.lib.gnulib.bugs/15354>.

2008-10-22  Paolo Bonzini  <bonzini@gnu.org>
	and Eric Blake  <ebb9@byu.net>

	Use a shell function for _AC_LINK_IFELSE.
	* lib/autoconf/general.m4 (_AC_LINK_IFELSE_BODY): New macro.
	(_AC_LINK_IFELSE): Use a shell function.

2008-10-22  Eric Blake  <ebb9@byu.net>

	Fix autoconf logging commands.
	* lib/autoconf/general.m4 (AC_MSG_RESULT_UNQUOTED, _AC_EVAL)
	(_AC_EVAL_STDERR, AC_RUN_LOG): Respect as_lineno.
	(_AC_DO_ECHO): Likewise, and use fewer dnl.
	(_AC_RUN_LOG_STDERR): Avoid subshell for logging.

2008-10-22  Eric Blake  <ebb9@byu.net>

	Fix testsuite failure.
	* tests/mktests.sh (ac_exclude_list): Don't generate test for
	AC_REQUIRE_SHELL_FN.

2008-10-21  Eric Blake  <ebb9@byu.net>

	Improve wording related to automake and autotest.
	* doc/autoconf.texi (Making testsuite Scripts): Clarify wording in
	relation to automake.  Mention dependency on package.m4.
	Consolidate examples.  Define AUTOM4TE.
	* THANKS: Update.
	Reported by William Pursell.

2008-10-21  Eric Blake  <ebb9@byu.net>

	Allow AS_VAR_SET_IF in shell lists.
	* lib/m4sugar/m4sh.m4 (AS_VAR_SET_IF): Allow continuation of
	line.
	* lib/autoconf/general.m4 (AC_CACHE_VAL): Supply newline no longer
	provided by AS_VAR_SET_IF.
	* lib/autoconf/headers.m4 (_AC_CHECK_HEADER_MONGREL): Adjust
	clients.
	* lib/autoconf/libs.m4 (AC_SEARCH_LIBS): Likewise.
	* tests/m4sh.at (AS@&t@_VAR basics): Enhance test.

	Allow AS_VAR_IF in shell lists.
	* lib/m4sugar/m4sh.m4 (AS_VAR_IF): Allow continuation of line.
	* lib/autoconf/functions.m4 (AC_CHECK_FUNC): Adjust clients.
	* lib/autoconf/general.m4 (AC_CHECK_FILE, AC_CHECK_DECL):
	Likewise.
	* lib/autoconf/headers.m4 (_AC_CHECK_HEADER_MONGREL)
	(_AC_CHECK_HEADER_NEW, _AC_CHECK_HEADER_OLD)
	(_AC_CHECK_HEADER_DIRENT): Likewise.
	* lib/autoconf/libs.m4 (AC_CHECK_LIB): Likewise.
	* lib/autoconf/types.m4 (_AC_CHECK_TYPE_NEW, AC_CHECK_MEMBER):
	Likewise.
	* tests/m4sh.at (AS@&t@_VAR basics): Enhance test.

	Allow AS_CASE in shell lists.
	* lib/m4sugar/m4sh.m4 (AS_CASE): Always execute test, in case of
	side effects.  Allow continuation of script on same line as esac.
	* lib/autoconf/c.m4 (AC_PROG_CC_STDC): Adjust client.
	* tests/m4sh.at (AS@&t@_IF and AS@&t@_CASE): Enhance test.
	* NEWS: Document the subtle change.

	Allow AS_IF in shell lists.
	* lib/m4sugar/m4sh.m4 (AS_IF): Always execute test, in case of
	side effects.  Allow continuation of script on same line as fi.
	(_AS_DETECT_BETTER_SHELL): Adjust clients.
	(AS_VAR_IF, AS_VAR_SET_IF): For now, supply newline no longer
	given by AS_IF.
	* lib/autoconf/c.m4 (_AC_PROG_PREPROC_WORKS_IFELSE): Likewise.
	* lib/autoconf/general.m4 (_AC_ENABLE_IF): Likewise.
	(AC_EGREP_CPP, _AC_RUN_IFELSE): Adjust client.
	* lib/autoconf/libs.m4 (AC_SEARCH_LIBS): Likewise.
	* doc/autoconf.texi (Common Shell Constructs) <AS_IF>: Fix typo.
	(Polymorphic Variables): Move mention of dnl to the only two
	AS_VAR functions that need it.

2008-10-21  Paolo Bonzini  <bonzini@gnu.org>
	and Eric Blake  <ebb9@byu.net>

	Use a shell function for _AC_COMPILE_IFELSE.
	* lib/autoconf/general.m4 (_AC_COMPILE_IFELSE_BODY): New macro.
	(_AC_COMPILE_IFELSE): Use a shell function.

2008-10-21  Eric Blake  <ebb9@byu.net>

	Use AS_VAR_APPEND.
	* lib/autoconf/functions.m4 (AC_CHECK_FUNCS_ONCE): Use new macro.
	* lib/autoconf/general.m4 (_AC_INIT_PREPARE)
	(_AC_LIBOBJS_NORMALIZE): Likewise.
	* lib/autoconf/headers.m4 (AC_CHECK_HEADERS_ONCE): Likewise.
	* lib/autoconf/status.m4 (_AC_OUTPUT_SUBDIRS)
	(_AC_OUTPUT_CONFIG_STATUS, _AC_OUTPUT_MAIN_LOOP): Likewise.
	* lib/autotest/general.m4 (AT_INIT): Likewise.

	Add AS_VAR_APPEND.
	* lib/m4sugar/m4sh.m4 (_AS_VAR_APPEND_PREPARE)
	(_AS_VAR_APPEND_WORKS, AS_VAR_APPEND): New macros.
	(AS_PREPARE, _AS_PREPARE): Emit preparation.
	* tests/m4sh.at (AS@&t@_VAR_APPEND): New test.
	* doc/autoconf.texi (Polymorphic Variables) <AS_VAR_APPEND>:
	Document new macro.
	<AS_VAR_SET>: Mention ramification of `""` rules.
	* NEWS: Mention new macro.

2008-10-21  Paolo Bonzini  <bonzini@gnu.org>
	and Eric Blake  <ebb9@byu.net>

	Use a shell function for _AC_PREPROC_IFELSE.
	* lib/autoconf/general.m4 (_AC_PREPROC_IFELSE_BODY): New macro.
	(_AC_PREPROC_IFELSE): Use a shell function.
	* lib/m4sugar/m4sh.m4 (AS_REQUIRE): Factor for faster execution.
	(AS_REQUIRE_SHELL_FN): Bypass AS_REQUIRE if function has already
	been provided.

2008-10-21  Eric Blake  <ebb9@byu.net>

	Add banners to generated files.
	* lib/m4sugar/m4sh.m4 (_AS_SHELL_SANITIZE): Use m4_text_box for
	existing banner.
	(AS_INIT): Add new banners at strategic points.
	* lib/autoconf/general.m4 (AC_INIT): Alter banner location, and
	make consistent with other banners.
	* lib/autotest/general.m4 (AT_INIT): Make banners consistent.

2008-10-20  Paolo Bonzini  <bonzini@gnu.org>

	Add AC_REQUIRE_SHELL_FN and the SHELL_FN diversion.
	* lib/autoconf/general.m4 (AC_REQUIRE_SHELL_FN): New.
	(m4_divert(SHELL_FN)): New.

2008-10-20  Eric Blake  <ebb9@byu.net>

	Avoid unportable use of echo in testsuite.
	* tests/m4sh.at (AS@&t@_VAR basics): Use AS_ECHO, since string
	contains backslash.

2008-10-18  Paolo Bonzini  <bonzini@gnu.org>

	Make sure that nested AS_REQUIRE do not lose the desired diversion.
	* lib/m4sugar/m4sh.m4 (AS_REQUIRE): Expand _m4_divert_desired before
	passing it to m4_divert_require, so that its content is not used
	anymore.
	* tests/m4sh.at (Nested AS_REQUIRE): New testcase.

2008-10-18  Eric Blake  <ebb9@byu.net>

	Document bugs in { } handling.
	* doc/autoconf.texi (Limitations of Builtins): Mention bug on
	empty list.

	Fix some testsuite failures introduced two days ago.
	* tests/m4sh.at (Nested AS@&t@_REQUIRE_SHELL_FN)
	(AS@&t@_REQUIRE_SHELL_FN and m4@&t@_require): Adjust to changed
	API.
	Reported by Ralf Wildenhues.

2008-10-18  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Show how to extract single substitutions from config.status.
	* doc/autoconf.texi (config.status Invocation): Show example
	using `--file=-'.

2008-10-17  Eric Blake  <ebb9@byu.net>

	Add m4_curry.
	* lib/m4sugar/m4sugar.m4 (m4_curry, _m4_curry): New macros.
	* tests/m4sugar.at (m4@&t@_map_args): Rename...
	(m4@&t@_map_args and m4@&t@_curry): ...and add currying tests.
	* doc/autoconf.texi (Looping constructs) <m4_map_args>: Document
	currying as a way to add parameters.
	(Evaluation Macros) <m4_curry>: Document the new macro.
	* NEWS: Likewise.

	Improve suggested test filtering.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_SUGGESTED_PRUNE): New macro,
	extracted from...
	(_AS_DETECT_BETTER_SHELL): ...here, to use faster API.  No need to
	check for an empty required set.

	Add m4_set_map.
	* lib/m4sugar/m4sugar.m4 (m4_set_foreach): New macro.
	* tests/m4sugar.at (m4@&t@_set): Enhance test.
	* doc/autoconf.texi (Set manipulation Macros) <m4_set_map>:
	Document it.
	* NEWS: Likewise.

	Document m4_map_args.
	* lib/m4sugar/m4sugar.m4 (m4_transform, m4_transform_pair):
	Rename...
	(m4_map_args, m4_map_args_pair): ...to these names, and document.
	(m4_version_unletter): Use the interface.
	* lib/m4sugar/foreach.m4 (m4_map_args, m4_map_args_pair)
	(_m4_map_args_, _m4_map_args_pair_, _m4_map_args_pair_end):
	Perform same renames.
	* lib/m4sugar/m4sh.m4 (AS_CASE, AS_IF): Adjust callers.
	* tests/m4sugar.at (m4@&t@_map_args): New test.
	(recursion): Adjust caller.
	* tests/m4sh.at (AS@&t@_IF and AS@&t@_CASE): Likewise.
	* doc/autoconf.texi (Looping constructs) <m4_map_args>: Document
	this interface.
	* NEWS: Mention the new macros.

2008-10-17  Eric Blake  <ebb9@byu.net>

	Reduce vertical whitespace in configure.
	* lib/autoconf/general.m4 (AC_INIT): Silence newline output during
	m4 side effect initializations.
	* lib/m4sugar/m4sh.m4 (AS_PREPARE): Likewise.

2008-10-17  Eric Blake  <ebb9@byu.net>

	Document AS_VAR interfaces.
	* doc/autoconf.texi (Programming in M4sh): M4sh is now prime-time.
	(Polymorphic Variables): New node.
	* NEWS: Update accordingly.

	Test AS_VAR interfaces.
	* tests/m4sh.at (AS@&t@_VAR): New test.
	* lib/m4sugar/m4sh.m4 (AS_VAR_PUSHDEF): Force expansion of
	_AS_TR_SH_PREPARE at top level, rather than argument collection.
	(AS_TR_SH): Support command substitution.

	Add AS_VAR_COPY.
	* lib/m4sugar/m4sh.m4 (AS_VAR_COPY): New macro.
	(AS_VAR_IF): Use it, instead of the broken AS_VAR_GET.
	* lib/autoconf/general.m4 (AC_CACHE_CHECK): Likewise.
	* lib/autoconf/libs.m4 (AC_SEARCH_LIBS): Likewise.
	* lib/autotest/general.m4 (_AT_FINISH): Likewise.

	Sort AS_VAR_* interfaces.
	* lib/m4sugar/m4sh.m4 (AS_VAR_GET): Reduce output to one line.
	(AS_VAR_TEST_SET, AS_VAR_SET, AS_VAR_SET_IF, AS_VAR_POPDEF): Sort,
	no code changes.

2008-10-16  Eric Blake  <ebb9@byu.net>

	Allow comments before functions emitted by m4sh.
	* lib/m4sugar/m4sh.m4 (AS_REQUIRE_SHELL_FN): Add comment
	argument.  Supply closing comment, to ease readability.
	(_AS_MKDIR_P_PREPARE): Adjust caller.
	(_AS_UNSET_PREPARE): Add comment.

	Add AS_FUNCTION_DESCRIBE.
	* lib/m4sugar/m4sh.m4 (AS_FUNCTION_DESCRIBE): New macro.
	* lib/autotest/general.m4 (AT_INIT): Use it.

2008-10-16  Eric Blake  <ebb9@byu.net>

	Speed up m4_qlen with caching.
	* lib/m4sugar/m4sugar.m4 (_m4_qlen): Renamed from old m4_qlen.
	(m4_qlen): Cache results for speed.

2008-10-16  Paolo Bonzini  <bonzini@gnu.org>

	Add a testcase using more then one language.
	* tests/compile.at (Multiple languages): New test.

2008-10-16  Paolo Bonzini  <bonzini@gnu.org>

	Fix Libtool's config.lt test.
	* lib/m4sugar/m4sh.m4 (_AS_PREPARE): Disable AS_REQUIRE while
	expanding it.

2008-10-15  Eric Blake  <ebb9@byu.net>

	Break circular require chain in _AS_LINENO_PREPARE.
	* lib/m4sugar/m4sh.m4 (_AS_LINENO_PREPARE): Ensure that logging is
	disabled when reporting LINENO failure, since logging requires
	LINENO.
	* doc/autoconf.texi (Initialization Macros): Recommend m4_pushdef,
	not m4_rename, since the latter is undocumented.
	* lib/autoconf/status.m4 (_AC_OUTPUT_CONFIG_STATUS): Avoid
	m4_rename, as it does not yet handle pushdef stacks.
	Reported by Ralf Wildenhues.

2008-10-15  Eric Blake  <ebb9@byu.net>

	Cleanups to previous patches.
	* doc/autoconf.texi (Portable Shell): Minor edits.
	(Limitations of Builtins): Touch up wording.
	* lib/m4sugar/m4sh.m4 (AS_LINENO_PUSH): Nuke trailing whitespace.
	(_AS_SHELL_SANITIZE): Wrap comments less than 80 columns.

2008-10-15  Paolo Bonzini  <bonzini@gnu.org>

	Updates to shell portability documentation.
	* doc/autoconf.texi: Updates all references to "Portable Shell" and
	"Limitations of Builtins" to use three-argument commands.
	(Programming in M4sh): Document AS_ECHO, AS_ECHO_N, AS_UNSET.
	(Portable Shell): Move here discussion about "Where is the POSIX
	shell?"  Mention that M4sh provides a SVR2 shell and takes care
	of unsetting variables if necessary.  Talk about M4sh and not only
	Autoconf-generated scripts.
	(Special Shell Variables): Talk about M4sh and not only
	Autoconf-generated scripts.  Don't talk about things that Autoconf
	does not do.  Mention problems of $LINENO with shell functions.
	(Limitations of Builtins).  Mention AS_ECHO and AS_ECHO_N.  Move
	discussion of eval bugs before discussion on proper use of eval.
	Mention AS_IF.  Reword why not to use "shift N".  Mention "foo=;
	unset foo" trick.  Include M4sh code that unsets MAIL for Bash 2.01.
	* NEWS: Update list of documented M4sh macros.

2008-10-15  Paolo Bonzini  <bonzini@gnu.org>

	Assume a (possibly buggy) `unset' is present after a
	`better shell' was found.
	* lib/autoconf/general.m4 (_AC_CACHE_DUMP): Use AS_UNSET.
	* lib/autoconf/programs.m4 (AC_PROG_SED): Use AS_UNSET.
	* lib/m4sugar/m4sh.m4 (_AS_UNSET_PREPARE): Provide $as_unset as an
	alias for AS_UNSET, for backwards compatibility.
	(_AS_DETECT_BETTER_SHELL): Set BASH_ENV and ENV to /dev/null in case
	the shell does not support unset.
	(_AS_SHELL_SANITIZE): Work around Bash 2.01 bugs.  Unset BASH_ENV.
	(AS_INIT, _AS_PREPARE, AS_PREPARE): Call it.
	(AS_UNSET): Assume it is there but it might fail if the variable is
	not set.  Use it throughout instead of $as_unset.

2008-10-15  Paolo Bonzini  <bonzini@gnu.org>

	Turn AS_SHELL_SANITIZE into a for-Libtool-only wrapper.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_REQUIRED, _AS_DETECT_SUGGESTED): Remove
	m4_require of _AS_DETECT_BETTER_SHELL.
	(_AS_CLEANUP): Add it here.
	(_AS_DETECT_BETTER_SHELL): Just expand the test instead of appending it
	to _AS_CLEANUP.
	(_AS_SHELL_SANITIZE): New name of the old AS_SHELL_SANITIZE macro.
	(AS_SHELL_SANITIZE): New macro hacking around Libtool misuse.
	(AS_PREPARE): Use _AS_SHELL_SANITIZE.
	(AS_INIT): Add m4_provide of itself.

2008-10-15  Paolo Bonzini  <bonzini@gnu.org>

	Use "test x$foo = xyes" to avoid upsetting Libtool's sh.test.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_BETTER_SHELL, _AS_SHELL_FN_WORK): Use
	"test x$foo = xyes".

2008-10-15  Paolo Bonzini  <bonzini@gnu.org>

	Trim down the size of the better-shell test.
	* lib/m4sugar/m4sh.at (_AT_DETECT_BETTER_SHELL): Store the common
	snippets into shell variables.
	(_AS_RUN): Rewrite.

2008-10-15  Paolo Bonzini  <bonzini@gnu.org>

	Support a stack of LINENO values for AS_MESSAGE.
	* lib/m4sugar/m4sh.m4 (_AS_ECHO_LOG): If defined, use $as_lineno as
	the line number emitted to the log file.
	(AS_LINENO_PUSH, AS_LINENO_POP): New.
	* tests/m4sh.at (LINENO Stack): New test.

2008-10-14  Eric Blake  <ebb9@byu.net>

	Correct previous patch.
	* doc/autoconf.texi (Shell Functions): Bash obeys Posix, after
	all.

	Document shell function environment pitfall.
	* doc/autoconf.texi (Shell Functions): Document bugs in bash,
	Solaris /bin/sh.

2008-10-14  Paolo Bonzini  <bonzini@gnu.org>

	Use m4_require to implement AS_REQUIRE.
	* lib/m4sugar/m4sugar.m4 (_m4_require_call): Accept a third argument.
	(m4_require): Pass it.
	(m4_divert_require): New.
	* lib/m4sugar/m4sh.m4 (AS_REQUIRE): Rewrite using m4_divert_require.
	Remove comment about differences with m4_require.
	* tests/m4sh.at (AS_REQUIRE_SHELL_FN and m4_require): Update to test
	the expected behavior.
	(Nested AS_REQUIRE_SHELL_FN): New test.

2008-10-13  Paolo Bonzini  <bonzini@gnu.org>

	Test AS_LINENO_PREPARE.
	* tests/m4sh.at: Use documented AS_LINENO_PREPARE.

2008-10-13  Paolo Bonzini  <bonzini@gnu.org>

	Test AS_ME_PREPARE.
	* tests/m4sh.at (as_me): New test.

2008-10-13  Paolo Bonzini  <bonzini@gnu.org>

	Add and document AS_INIT_GENERATED.
	* lib/m4sugar/m4sh.m4 (AS_INIT_GENERATED): New.
	* lib/autoconf/status.m4 (_AC_OUTPUT_CONFIG_STATUS): Use it.
	* doc/autoconf.texi (Initialization macros): Document it.

2008-10-13  Eric Blake  <ebb9@byu.net>

	Use consistent shell function style.
	* lib/m4sugar/m4sh.m4 (_AS_PREPARE, AS_REQUIRE_SHELL_FN)
	(_AS_SHELL_FN_WORK): Imitate GNU Coding Standards for C
	functions.

2008-10-13  Paolo Bonzini  <bonzini@gnu.org>

	* lib/m4sugar/m4sh.m4 (_AS_LINENO_PREPARE): Place names of
	contributors under m4 rather than shell comments.

2008-10-10  Paolo Bonzini  <bonzini@gnu.org>

	* lib/m4sugar/m4sh.m4 (AS_ME_PREPARE, AS_LINENO_PREPARE): New.
	* doc/autoconf.texi (Initialization macros): Document them.
	(Portable Shell): Refer to AS_LINENO_PREPARE.
	* NEWS: Mention them.

	* bin/autoconf.as: Invoke AS_ME_PREPARE.
	* lib/autotest/general.m4: Likewise.

2008-10-10  Paolo Bonzini  <bonzini@gnu.org>

	* doc/autoconf.texi (Programming in M4sh): Make its own chapter.

2008-10-10  Eric Blake  <ebb9@byu.net>

	Fix _AS_MKDIR_P usage.
	* lib/m4sugar/m4sh.m4 (_AS_MKDIR_P): Correct documentation to
	match implementation.
	(_AS_PREPARE, _AS_MKDIR_P_PREPARE): Adjust callers.
	* doc/autoconf.texi (Programming in M4sh) <AS_MKDIR_P>: Tweak
	wording to better match behavior.

2008-10-10  Paolo Bonzini  <bonzini@gnu.org>

	* doc/autoconf.texi: Be less wary of shell functions.
	* NEWS: Document the increased use of shell functions.

2008-10-10  Paolo Bonzini  <bonzini@gnu.org>

	* m4sugar/m4sh.m4 (_AS_MKDIR_P): New, from AS_MKDIR_P.  Adjust
	meaning of as_mkdir_p to be `false' or a full `mkdir -p' command.
	(AS_MKDIR_P): Just dispatch to as_func_mkdir_p.
	(_AS_PREPARE): Define shell functions.
	(_AS_MKDIR_P_PREPARE): Set as_mkdir_p according to the above change.
	Define shell functions.

2008-10-09  Eric Blake  <ebb9@byu.net>

	Only prepare $as_me if it will be used.
	* lib/m4sugar/m4sh.m4 (AS_SHELL_SANITIZE): Avoid unconditional
	preparation.
	(_AS_ECHO_LOG): Depend on $LINENO preparation.
	(AS_MESSAGE): Depend on $as_me preparation.
	(AS_TMPDIR): Use AS_ERROR, rather than a hand-rolled copy.

2008-10-09  Paolo Bonzini  <bonzini@gnu.org>

	* m4sugar/m4sh.m4 (AS_SHELL_SANITIZE): Delay setting as_me
	until the M4SH-INIT diversion using _AS_ME_PREPARE.
	(_AS_PREPARE): Invoke _AS_EXPR_PREPARE before _AS_BASENAME_PREPARE
	and _AS_DIRNAME_PREPARE, and _AS_BASENAME_PREPARE and _AS_ME_PREPARE
	before _AS_LINENO_PREPARE.
	(AS_PREPARE): Include all the AS_REQUIREs manually.
	(_AS_ME_PREPARE): New.
	(_AS_LINENO_PREPARE): Use m4_defun.

2008-10-09  Paolo Bonzini  <bonzini@gnu.org>

	* m4sugar/m4sh.m4 (_AS_BASENAME_EXPR, _AS_DIRNAME_EXPR): Do not
	require _AS_EXPR_PREPARE.
	(_AS_BASENAME_PREPARE, _AS_DIRNAME_PREPARE): Do it here.
	(_AS_PREPARE): Add _AS_BASENAME_PREPARE.

2008-10-08  Eric Blake  <ebb9@byu.net>

	Resync from gnulib.
	* cfg.mk (cvs_executable_files, cvs_files): Rewrite...
	(fetch): ...into new target.
	(executable-update): Delete, now that it is unused.
	* maint.mk (update, local_updates, cvs_files, gnulib_repo)
	(wget-update, cvs-update): Likewise.
	* HACKING (Update the foreign files): Document new procedure.
	* GNUmakefile: Resync from upstream, via new 'make fetch'.
	* build-aux/config.guess: Likewise.

2008-10-08  Paolo Bonzini  <bonzini@gnu.org>

	* lib/m4sugar/m4sh.m4 (_AS_SHELL_FN_SPY): Remove.
	(AS_INIT): Do not call it.

2008-10-08  Paolo Bonzini  <bonzini@gnu.org>

	* lib/m4sugar/m4sh.m4 (_AS_DETECT_BETTER_SHELL): Expand
	_AS_UNSET_PREPARE in M4SH-SANITIZE.

2008-10-08  Eric Blake  <ebb9@byu.net>

	Avoid repeating required shell tests in suggested set.
	* lib/m4sugar/m4sh.m4 (_AS_DETECT_REQUIRED, _AS_DETECT_SUGGESTED):
	Use m4_set, rather than m4_expand_once/m4_append.
	(_AS_DETECT_SUGGESTED): Adjust to new storage layout, and filter
	required tests out of suggested tests.
	Reported by Paolo Bonzini.

2008-10-08  Paolo Bonzini  <bonzini@gnu.org>

	Add m4sh keyword to all m4sh.at tests.
	* tests/m4sh.at: Add m4sh keyword to all tests.  Fix comment
	pastos.

2008-10-08  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Document AS_VERSION_COMPARE.
	* doc/autoconf.texi (Programming in M4sh): Document
	AS_VERSION_COMPARE.
	* NEWS: Update.

	Do not write to testsuite log fd before initialization.
	* lib/autotest/general.m4 (AS_MESSAGE_LOG_FD, AT_JOB_FIFO_FD):
	Define fds only when initializing the log fd so early error
	messages do not try to write to it.
	* tests/autotest.at (Startup error messages): New test.
	* NEWS: Document this 2.63 regression.

2008-10-07  Eric Blake  <ebb9@byu.net>

	Ensure _AS_CLEANUP is defined.
	* lib/m4sugar/m4sh.m4 (_AS_CLEANUP): Give initial definition.
	* tests/m4sh.at (AS@&t@_INIT cleanup): Expose the need for this.

	Improve m4sh maintainability.
	* lib/m4sugar/m4sh.m4: Sort macros for sanitizing the shell; no
	code change.

	Fix m4 quoting in previous patch.
	* lib/m4sugar/m4sh.m4 (AS_REQUIRE_SHELL_FN): Determine diversion
	name prior to invoking AS_REQUIRE.
	Reported by Ralf Wildenhues.

2008-09-18  Paolo Bonzini  <bonzini@gnu.org>
	and Eric Blake  <ebb9@byu.net>

	Add a separate diversion for shell functions.
	* lib/m4sugar/m4sh.m4 (M4SH-INIT-FN): New diversion.
	(AS_REQUIRE): Accept diversion parameter.
	(AS_REQUIRE_SHELL_FN): Use it.

2008-10-06  Eric Blake  <ebb9@byu.net>

	Add m4_default_quoted.
	* lib/m4sugar/m4sugar.m4 (m4_default_quoted): New macro.
	(m4_for, m4_expand_once, m4_text_wrap, m4_text_box): Use it.
	* doc/autoconf.texi (Conditional constructs): Document it.
	* NEWS: Likewise.

	Fix build with case-insensitive make, again.
	* Makefile.am (pkgdata_DATA): Protect by MAKE_CASE_SENSITIVE.
	Reported via Keith Marshall, originally by newthinker in
	<http://thread.gmane.org/gmane.comp.gnu.mingw.user/27725>.

2008-10-06  Bruno Haible  <bruno@clisp.org>

	Warn about /usr/ucb on Solaris.
	* doc/install.texi (Particular Systems): Recommend putting
	/usr/ucb late in PATH, if at all.

2008-10-03  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix more testsuite hang corner cases.
	* lib/autotest/general.m4: Use the serial code path if no test
	is to be run.
	* tests/autotest.at (parallel test execution): Test -j and -jN
	with `-k notmatched'.

2008-10-02  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix hang with `testsuite -k notmatched'.
	* lib/autotest/general.m4: Do not reset $at_jobs if it is equal
	to one.  Fixes hang with `-k notmatched'.

2008-10-02  Eric Blake  <ebb9@byu.net>

	Document more binary file portability traps.
	* doc/autoconf.texi (Limitations of Usual Tools) <sed>: Remind
	reader that NUL and sed don't always mix.
	<tr>: Mention Solaris /usr/ucb/tr bug with \0.

2008-10-02  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Implement parallel Autotest test execution: testsuite --jobs.
	* lib/autotest/general.m4 (AT_JOB_FIFO_FD): New macro.
	(AT_INIT): <at_jobs>: New variable.
	Accept -j, -jN, --jobs[=N], document them in --help output.
	Implement parallel driver loop using a FIFO, enabled with --jobs
	and if mkfifo works; otherwise, fall back to sequential loop.
	(AT_SETUP): Store, do not output summary progress line if
	parallel.
	* tests/autotest.at (parallel test execution, parallel truth)
	(parallel fallacy, parallel skip): New tests.
	* doc/autoconf.texi (testsuite Invocation): Document -j, --jobs,
	the mkfifo requirement, and that --errexit may cause concurrent
	jobs to finish.
	* NEWS: Update.

2008-09-20  Eric Blake  <ebb9@byu.net>

	Fix sample isinf definition.
	* doc/autoconf.texi (Function Portability) <isinf>: Filter out NaN
	first.
	* THANKS: Update.
	Reported by David Cournapeau.

2008-09-16  Eric Blake  <ebb9@byu.net>

	Fix Erlang regression, introduced 2006-11-17.
	* lib/autoconf/erlang.m4 (AC_LANG(Erlang)): Avoid M4 comment
	caused by underquoting.
	* NEWS: Mention this fix.
	* THANKS: Update.
	Reported by BJ Terry.

2008-09-13  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autoconf/general.m4 (AC_CONFIG_AUX_DIRS): Improve a bit.

	Mention Solaris sh ':' redirection bug.
	* doc/autoconf.texi (File Descriptors): Redirecting ':'
	in a loop causes bogus optimization with Solaris sh.

2008-09-10  Eric Blake  <ebb9@byu.net>

	Avoid testsuite bug when autom4te cache is disabled by user.
	* tests/tools.at (autoconf: forbidden tokens, basic): Enable
	cache, even if user normally disabled it.
	Reported by Bruno Haible.

	Avoid testsuite bug in presence of verbose config.site.
	* tests/base.at (Input/Output): Nullify config.site during test.
	Reported by Bob Friesenhahn.

2008-09-09  Eric Blake  <ebb9@byu.net>

	Release Version 2.63.
	* NEWS: Mention the release.

	Formatting tweaks to the manual.
	* doc/autoconf.texi (Introduction, Systemology)
	(File System Conventions, Portable C and C++)
	(Floating Point Portability): Allow URLs to split as needed.
	(Indices): Add entries, to work around texinfo bug on indices that
	start too close to a page break.
	(Particular Functions): Mention ftello.
	(Introduction, Language Choice): Use @enddots at sentence end.

	Resync from gnulib.
	* cfg.mk (cvs_executable_files, cvs_files): Update list of files,
	although for now, they are still manually sync'd.
	* build-aux/gnupload: Update.
	* build-aux/config.sub: Likewise.
	* GNUmakefile: Likewise.

2008-09-06  Eric Blake  <ebb9@byu.net>

	Mention that Automake already supports VPATH.
	* doc/autoconf.texi (Build Directories): Details in this section
	only apply to users avoiding automake.
	* THANKS: Update.
	Reported by Matej Tyc.

	Relax tone when warning about cross-compiler names.
	* lib/autoconf/programs.m4 (_AC_TOOL_WARN): Support cross-compiles
	with poorly named tools; the issue has been reported too many
	times in the last four years to pull support.
	* doc/autoconf.texi (Specifying Names, Generic Programs): Update
	documentation accordingly.
	* THANKS: Update.
	Reported by Josef Tran and others, wording suggested by Ralf
	Wildenhues.

2008-09-01  Eric Blake  <ebb9@byu.net>

	Improve AC_C_BIGENDIAN.
	* doc/autoconf.texi (C Compiler) <AC_C_BIGENDIAN>: Mention that
	universal builds require a config header.
	* lib/autoconf/c.m4 (AC_C_BIGENDIAN): Enhance comments.  Check
	AH_HEADER at the last possible moment, so that users can use
	AC_CONFIG_HEADER after this macro.
	Reported by Stepan Kasal.

	Fix manual date information.
	* doc/autoconf.tex: UPDATED refers to the day the manual was
	built, not the release date of Autoconf.
	Based on a bison patch by Akim Demaille.

2008-08-27  Eric Blake  <ebb9@byu.net>

	Fix off-by-one bug in _m4_shiftn.
	* lib/m4sugar/foreach.m4 (_m4_shiftn): Handle case when shifting
	all arguments.
	* tests/m4sugar.at (M4 loops): Test it.
	Reported by Akim Demaille.

2008-08-26  Eric Blake  <ebb9@byu.net>

	Improve INSTALL formatting.
	* doc/install.texi [!autoconf]: Ensure first paragraphs are
	indented like all others in a plain text rendering.
	* Makefile.am ($(srcdir)/INSTALL): Ensure plaintext formatting.
	Reported by Bruno Haible.

2008-08-26  Stepan Kasal  <skasal@redhat.com>

	Check for case sensitive make.
	* m4/make-check.m4 (AC_PROG_MAKE_CASE_SENSITIVE): New macro,...
	* configure.ac: ... called here.
	* Makefile.am ($(abs_srcdir)/INSTALL, INSTALL): Return to...
	($(srcdir)/INSTALL): ...this, but enclose the rule in
	"if MAKE_CASE_SENSITIVE".

2008-08-26  Eric Blake  <ebb9@byu.net>

	Update invocation documentation.
	* doc/autoconf.texi (autoscan Invocation): Mention --debug.
	(autoreconf Invocation): Mention -v.
	(autom4te Invocation): Tie --freeze to -F, not -f.
	(autoupdate Invocation): Mention --prepend-include.
	* doc/install.texi (configure Invocation): Mention --help=short,
	--help=recursive, -n/--no-create, --prefix.  Avoid TABs.
	* bin/autoscan.in ($help): Omit space before `...'.
	* bin/ifnames.in ($help): Likewise.
	* bin/autoconf.as (Usage): Likewise.
	* bin/autoreconf.in ($help): Likewise.
	* bin/autoheader.in ($help): Likewise.
	* bin/autom4te.in ($help): Likewise.
	* bin/autoupdate.in ($help): Likewise.
	* lib/autoconf/status.m4 (_AC_OUTPUT_CONFIG_STATUS): Use
	`[OPTION]...', rather than `[OPTIONS]'.  Mention --silent.  Indent
	--file correctly.

	Don't let frozen __m4_version__ break downgrade to m4 1.4.x.
	* bin/autom4te.in: Adjust comments, now that we rely on 1.4.5+.
	(files_to_options): Avoid inheriting __m4_version__ from frozen
	file if current M4 does not support it.

2008-08-25  Eric Blake  <ebb9@byu.net>

	Adjust to recent m4 1.6 change to support m4_debugmode(d).
	* lib/m4sugar/m4sugar.m4 (m4_defn, m4_popdef, m4_undefine): Move
	freeze-time decision of using faster 1.6 implementation...
	(m4_init): ...to a runtime decision, and add use of new debugmode
	flag.

2008-08-22  Peter O'Gorman  <pogma@thewrittenword.com>

	Limit AC_C_BIGENDIAN univeral checks to Mac OS X.
	* lib/autoconf/c.m4 (AC_C_BIGENDIAN): Limit the check to
	__APPLE_CC__ with possible -arch flags.
	* NEWS: Document it.

2008-08-22  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* NEWS: Fix typo.

2008-08-22  Eric Blake  <ebb9@byu.net>

	* TODO: Add an item for additional m4sugar looping constructs.
	Suggested by Ralf Wildenhues.

	Add reminder to keep dual implementations in sync.
	* lib/m4sugar/m4sugar.m4: Add comments.
	* lib/m4sugar/foreach.m4: Likewise.
	Suggested by Ralf Wildenhues.

2008-08-22  Peter Eisentraut  <peter_e@gmx.net>  (tiny change)

	Format warning and error messages to match GCS.
	* lib/autoconf/general.m4 (_AC_INIT_DIRCHECK)
	(_AC_INIT_PARSE_ARGS, _AC_CACHE_DUMP): Start warning and error
	messages with a lowercase letter, end them without punctuation.
	* lib/autoconf/lang.m4 (AC_NO_EXECUTABLES): Likewise.
	* lib/autoconf/libs.m4 (AC_PATH_X): Likewise.
	* lib/autoconf/status.m4 (AC_OUTPUT, _AC_OUTPUT_MAIN_LOOP):
	Likewise.
	* tests/fortran.at (GNU Fortran): Likewise.
	* tests/torture.at (Deep Package): Likewise.

2008-08-21  Eric Blake  <ebb9@byu.net>

	Avoid extra side effects in m4sugar list expansion.
	* lib/m4sugar/m4sugar.m4 (m4_mapall_sep, m4_list_cmp): Wrap
	around...
	(_m4_mapall_sep, _m4_list_cmp_raw): ...new helpers, to avoid
	duplicate side effects.
	(m4_version_compare): Adjust caller.
	* lib/m4sugar/foreach.m4 (m4_list_cmp): Rename...
	(_m4_list_cmp_raw): ...to match m4sugar.
	* doc/autoconf.texi (Looping constructs): Document the behavior of
	side effects.
	* tests/m4sugar.at (M4 loops, m4@&t@_map, m4@&t@_version_compare):
	Ensure only one side effect.
	(recursion): Fix test typo.
	Reported by Ralf Wildenhues.

2008-08-21  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* TODO: Add item for compiler default flags.
	Suggested by Bruno Haible.

	* tests/m4sh.at (AS_IF and AS_CASE): Set the expansion limit
	back to 1000.

2008-08-21  Eric Blake  <ebb9@byu.net>

	Formatting improvements.
	* doc/autoconf.texi: Use @file and @command, rather than @code,
	where appropriate.

	Document another make bug.
	* doc/autoconf.texi (The Make Macro SHELL): Mention bug in BSD
	make, GNU make <= 3.80.

	Tweak wording about SHELL in Makefile.
	* doc/autoconf.texi (The Make Macro SHELL): Stronger wording on
	the importance of proper SHELL settings.
	Reported by Bruno Haible, in
	http://lists.gnu.org/archive/html/bug-libtool/2008-04/msg00029.html.

2008-08-20  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Avoid timestamp races for updated input.
	* tests/m4sh.at (AS_IF and AS_CASE): Use `autom4te --force' for
	second script.
	* tests/tools.at (autotools and whitespace in file names): Add
	--force for repeated invocations.

2008-08-20  Bruno Haible  <bruno@clisp.org>

	Add section to INSTALL about particular systems.
	* doc/install.texi (Particular systems): New node.
	* doc/autoconf.texi: Adjust menus.

2008-08-19  Bruno Haible  <bruno@clisp.org>
	and Peter O'Gorman  <peter@pogma.com>

	Mention universal binaries in INSTALL.
	* doc/install.texi (Compiling For Multiple Architectures): Explain
	how to create universal binaries on MacOS X.

2008-08-19  Jim Meyering  <jim@meyering.net>
	    Eric Blake  <ebb9@byu.net>
	    Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Avoid shell parse errors after interrupt due to empty ``.
	* doc/autoconf.texi (Shell Substitutions): Document the issue.
	* lib/m4sugar/m4sh.m4 (AS_VAR_IF): New function.
	* lib/autoconf/functions.m4 (AC_CHECK_FUNC): Use it in place of
	"test AS_VAR_GET([...]) = yes"
	* lib/autoconf/general.m4 (AC_CHECK_FILE, AC_CHECK_DECL): Likewise.
	* lib/autoconf/headers.m4 (_AC_CHECK_HEADER_MONGREL): Likewise.
	(_AC_CHECK_HEADER_NEW, _AC_CHECK_HEADER_OLD): Likewise.
	(_AC_CHECK_HEADER_DIRENT): Likewise.
	* lib/autoconf/libs.m4 (AC_CHECK_LIB): Likewise.
	* lib/autoconf/types.m4 (_AC_CHECK_TYPE_NEW, AC_CHECK_MEMBER): Likewise.
	* lib/autoconf/status.m4 (_AC_OUTPUT_FILES_PREPARE): Use
	temporary variable to work around the issue.
	* tests/foreign.at (Libtool): Quote result of command
	substitution.

2008-08-18  Eric Blake  <ebb9@byu.net>

	Test m4_transform without tickling shell bugs.
	* tests/m4sh.at (AS@&t@_IF and AS@&t@_CASE): Relax test to
	something more manageable.
	* tests/m4sugar.at (recursion): Move stress test of
	m4_transform_pair here.
	Reported by Ralf Wildenhues.

	Let 'git diff' give better context for doc updates.
	* .gitattributes (*.texi*): Add new entry.
	* README-hacking: Mention how to use it.
	Inspired by a coreutils patch by Jim Meyering.

2008-08-15  Eric Blake  <ebb9@byu.net>

	Fix m4_map regression from 2007-10-16.
	* lib/m4sugar/m4sugar.m4 (_m4_apply): New macro.
	(m4_map): Ignore empty sublists.  For a list consisting of only an
	empty sublist, this restores 2.61 behavior of being a no-op.
	(m4_map_sep): Likewise, and expand separator.
	(m4_mapall, m4_mapall_sep): New macros, to regain 2.62 behavior.
	(_m4_map): Rewrite, to be common base for all four variants.
	* lib/m4sugar/foreach.m4 (_m4_map): Adjust to new prototype.
	* tests/m4sugar.at (m4@&t@_map): Add tests.
	* doc/autoconf.texi (Looping constructs) <m4_map>: Document new
	macros, and mention ramifications of expanded separator.
	* NEWS: Mention the change.

2008-08-14  Eric Blake  <ebb9@byu.net>

	Implement m4_transform_pair, to speed up AS_IF.
	* lib/m4sugar/m4sugar.m4 (m4_transform, m4_transform_pair): New
	macros, undocumented for now.
	* lib/m4sugar/foreach.m4 (m4_transform, m4_transform_pair): Also
	the m4 1.4.x counterparts.
	* lib/m4sugar/m4sh.m4 (AS_IF, AS_CASE): Use it.
	* tests/m4sh.at (AS@&t@_IF and AS@&t@_CASE): Test it.

2008-08-14  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autoconf/programs.m4 (AC_PATH_TARGET_TOOL)
	(AC_CHECK_TARGET_TOOL, AC_CHECK_TARGET_TOOLS): Require, do not
	warn about previous AC_CANONICAL_TARGET.
	(AC_CHECK_TARGET_TOOL): Add missing `$' making the macro
	unusable in the non-cross-compiling case.
	* NEWS, THANKS: Update.
	Report by Dave Erickson.

2008-08-12  Eric Blake  <ebb9@byu.net>

	Optimize m4_bmatch.
	* lib/m4sugar/foreach.m4 (m4_bmatch): Provide linear
	implementation for m4 1.4.x.
	* tests/m4sugar.at (m4@&t@_bmatch): New test.
	(recursion): Test the linear nature.
	* NEWS: Document the fix.

	Fix m4_cond corner case.
	* lib/m4sugar/foreach.m4 (_m4_cond): Ensure alternate
	implementation allows concatenation with subsequent text.
	* tests/m4sugar.at (m4@&t@_cond): Enhance test.

	Add test for m4_cond.
	* tests/m4sugar.at (m4@&t@_cond): New test.
	Reported by Ralf Wildenhues.

2008-08-06  Eric Blake  <ebb9@byu.net>

	Fix autoheader 2.62 regression on AC_DEFINE([__EXTENSIONS__]).
	* lib/autoconf/specific.m4 (AC_USE_SYSTEM_EXTENSIONS): Use a
	unique key for the AH_VERBATIM.
	* tests/c.at (AC_USE_SYSTEM_EXTENSIONS): New test.
	* NEWS: Mention the fix.
	Reported by Andreas Schwab, analyzed by Stepan Kasal.

	Add linear m4_cond for m4 1.4.x.
	* lib/m4sugar/m4sugar.m4 (m4_cond): Split into...
	(_m4_cond): ...this, for fewer macros per iteration.
	* lib/m4sugar/foreach.m4 (_m4_cond): New implementation.
	* tests/m4sugar.at (recursion): Test it.
	* NEWS: Document the linear guarantee.

	Speed up diversion handling.
	* lib/m4sugar/m4sugar.m4 (m4_divert, m4_divert_push)
	(m4_divert_pop, m4_divert_text): Avoid dnl for fewer macro
	expansions.

	AC_C_CHAR_UNSIGNED is not strictly necessary.
	* doc/autoconf.texi (C Compiler) <AC_C_CHAR_UNSIGNED>: Mention a
	portable alternative to this macro.
	* THANKS: Update.
	Reported by Hallvard B Furuseth.

	Update some files from upstream.
	* GNUmakefile: Update.
	* build-aux/announce-gen: Likewise.
	* build-aux/config.guess: Likewise.
	* build-aux/config.sub: Likewise.
	* build-aux/git-version-gen: Likewise.
	* build-aux/texinfo.tex: Likewise.
	* build-aux/vc-list-files: Likewise.
	* doc/make-stds.texi: Likewise.
	* doc/standards.texi: Likewise.

2008-08-04  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix AC_CONFIG_FILES([$var]) 2.62 regression.
	* lib/autoconf/status.m4 (_AC_OUTPUT_CONFIG_STATUS): Flatten
	whitespace in $ac_config_files and $ac_config_headers.
	* tests/torture.at (Parameterized AC_CONFIG_FILES): New test.
	Report by Andreas Schwab and Per Øyvind Karlsen.
	* THANKS: Update.

2008-07-30  Eric Blake  <ebb9@byu.net>

	Fix bugs in previous version of m4_bpatsubsts.
	* lib/m4sugar/foreach.m4 (_m4_bpatsubsts): Don't expand $1, and
	allow concatenation with subsequent text.
	* tests/m4sugar.at (m4@&t@_bpatsubsts): Enhance test.

2008-07-29  Eric Blake  <ebb9@byu.net>

	Add linear m4_bpatsubsts for m4 1.4.x.
	* lib/m4sugar/m4sugar.m4 (m4_bpatsubsts): Match documentation
	about anchors, even for only one substitution.
	* lib/m4sugar/foreach.m4 (_m4_bpatsubsts): New implementation.
	* doc/autoconf.texi (Conditional constructs) <m4_bpatsubsts>:
	Clarify behavior with regard to quoting.
	* tests/m4sugar.at (recursion): Test scaling of m4_bpatsubsts.
	(m4@&t@_bpatsubsts): New test.
	* NEWS: Document the linear guarantee.

	Tweak m4_do semantics.
	* lib/m4sugar/m4sugar.m4 (m4_do): Don't concat final argument with
	subsequent text.
	* lib/m4sugar/foreach.m4 (m4_do): Don't concat intermediate
	arguments, and avoid infinite loop.
	* doc/autoconf.texi (Evaluation Macros) <m4_do>: Document the
	behavior.
	* tests/m4sugar.at (m4@&t@_do): New test.

	Optimize m4_for.
	* lib/m4sugar/m4sugar.m4 (m4_for): Use fewer macros.
	(_m4_for): Take additional parameter, for fewer m4_indir calls.
	* lib/m4sugar/foreach.m4 (_m4_foreach, _m4_shiftn, m4_do)
	(m4_reverse, _m4_list_pad, _m4_list_cmp): Adjust all callers.
	* doc/autoconf.texi (Looping constructs) <m4_for>: Document subtle
	semantic change caused by the optimization.
	* tests/m4sugar.at (M4 loops): Test the new semantics.

	One more m4_list_cmp tweak.
	* lib/m4sugar/m4sugar.m4 (_m4_list_cmp_1): Don't defer shift.
	* lib/m4sugar/foreach.m4 (m4_list_cmp): Fix comment.
	* tests/m4sugar.at (recursion): Test both directions of list
	disparity.

	Add m4_reverse, and improve m4_list_cmp.
	* lib/m4sugar/m4sugar.m4 (m4_reverse): New macro.
	(m4_list_cmp): Rewrite to give linear behavior with M4 1.6 on an
	m4_reverse'd list.
	* lib/m4sugar/foreach.m4 (m4_reverse): Add the M4 1.4.x
	counterpart.
	* tests/m4sugar.at (recursion): Test it.
	* doc/autoconf.texi (Evaluation Macros) <m4_reverse>: Document
	it.
	(Text processing Macros) <m4_append>: Cross-reference to m4_set.
	* NEWS: Mention new macro.

2008-07-28  Eric Blake  <ebb9@byu.net>

	Avoid _m4_shiftn for m4 1.6 speedup.
	* lib/m4sugar/m4sugar.m4 (m4_foreach, _m4_foreach, m4_map)
	(_m4_map, m4_map_sep): Rewrite recursion to use one less m4_if.
	* lib/m4sugar/foreach.m4 (_m4_map): Accomodate changed signature.

	Implement O(n) unique element set creation.
	* lib/m4sugar/m4sugar.m4 (m4_set_add, m4_set_add_all)
	(m4_set_contains, m4_set_contents, m4_set_delete)
	(m4_set_difference, m4_set_dump, m4_set_empty, m4_set_foreach)
	(m4_set_intersection, m4_set_list, m4_set_listc, m4_set_remove)
	(m4_set_size, m4_set_union): New macros.
	* lib/m4sugar/foreach.m4 (m4_set_add_all): Add O(n) fallback for
	m4 1.4.x.
	* lib/autoconf/general.m4 (_AC_INIT_DEFAULTS, AC_SUBST): Use
	new m4_set API for the set most likely to be large.
	* doc/autoconf.texi (Set manipulation Macros): New node.
	* NEWS: Mention new macros.
	* tests/m4sugar.at (m4@&t@_set): New test.

2008-07-25  Eric Blake  <ebb9@byu.net>

	Avoid infinite aclocal loop.
	* lib/m4sugar/m4sugar.m4 (m4_init): Bypass m4_include tracing, so
	that aclocal doesn't insist on finding m4sugar/foreach.m4.

	Provide O(n) replacement macros for M4 1.4.x.
	* lib/m4sugar/foreach.m4: New file.
	(m4_foreach, m4_case, _m4_shiftn, m4_do, m4_dquote_elt, _m4_map)
	(m4_join, m4_joinall, m4_list_cmp, _m4_minmax): Replace m4sugar
	macros based on $@ recursion [fast on M4 1.6, but quadratic on M4
	1.4.x] with versions based on m4_for/m4_foreach [slow on 1.6, but
	linear on 1.4.x].
	* lib/m4sugar/m4sugar.m4 (m4_init): Dynamically load new file if
	older M4 is assumed.
	(m4_map_sep): Optimize.
	(m4_max, m4_min): Refactor, by adding...
	(_m4_max, _m4_min, _m4_minmax): ...more efficient helpers.
	(m4_defn, m4_popdef, m4_undefine): Use foreach recursion.
	* lib/m4sugar/Makefile.am (dist_m4sugarlib_DATA): Distribute new
	file.
	* tests/m4sugar.at (M4 loops): Add a stress test that takes
	forever if m4_foreach and friends are quadratic.
	* NEWS: Mention this.

2008-07-21  Eric Blake  <ebb9@byu.net>

	Ignore undefined macros, necessary with m4 1.6.
	* bin/autoupdate.in (_au___undefine): New macro,...
	(_au__undefine): ...wrapped by ifdef to silence m4 warnings.
	Reported by Ralf Wildenhues.

	Resync with gnulib.
	* GNUmakefile: Grab from upstream, to fix issue where 'make
	install' would allow installation of stale version string.

2008-07-19  Eric Blake  <ebb9@byu.net>

	Support multiple arguments to m4_defn, m4_popdef, and m4_undefine.
	* lib/m4sugar/m4sugar.m4 (m4_defn, m4_popdef, m4_undefine): Loop
	through all variables, per POSIX and newer m4.
	(_m4_text_wrap): Exploit the looping capabilities.
	* tests/m4sugar.at (m4@&t@_defn): Test this.
	* NEWS: Document it.
	* doc/autoconf.texi (Redefined M4 Macros) <m4_defn, m4_popdef>
	<m4_undefine>: Likewise.

	Reduce overhead of m4_builtin([defn]).
	* lib/m4sugar/m4sugar.m4 (_m4_defn, _m4_popdef, _m4_undefine): New
	internal macros, which are slightly more efficient than
	m4_builtin([defn]) and company.
	(m4_defn, m4_popdef, m4_undefine, m4_warn, m4_ifset)
	(_m4_dumpdefs_up, _m4_dumpdefs_down, _m4_wrap, m4_for)
	(_m4_divert_n_stack, m4_divert_pop, m4_expansion_stack_push)
	(m4_expansion_stack_dump, _m4_defun_pro, _m4_defun_epi)
	(_m4_defun_epi_outer, _m4_require_call, m4_combine, m4_append)
	(_m4_append_uniq, m4_append_uniq_w, _m4_text_wrap, m4_text_box)
	(m4_version_prereq): Use them.

	Use warnings from m4 when available.
	* lib/m4sugar/m4sugar.m4 (m4_defn, m4_popdef, m4_undefine): Don't
	define slower wrapper if m4 will warn on our behalf; key off of
	__m4_version__, added alongside the new warnings in m4 1.6.
	* tests/m4sugar.at (m4@&t@_defn): New test.

2008-07-18  Eric Blake  <ebb9@byu.net>

	Add m4_joinall.
	* lib/m4sugar/m4sugar.m4 (m4_joinall, _m4_joinall): New macros.
	* tests/m4sugar.at (m4@&t@_join): Test them.
	* doc/autoconf.texi (Text processing Macros) <m4_join>: Document
	m4_joinall.
	* NEWS: Likewise.

2008-07-17  Stepan Kasal  <skasal@redhat.com>
	and Eric Blake  <ebb9@byu.net>

	Improve documentation of config.h.in template rules.
	* doc/autoconf.texi (Header Templates): Mention rules on comments
	and whitespace, and that the user cannot rely on #undef to survive
	through config.status.

2008-07-16  Eric Blake  <ebb9@byu.net>

	Revert m4_prepend; it is less efficient, and unused by bison.
	* lib/m4sugar/m4sugar.m4 (m4_prepend, m4_prepend_uniq)
	(m4_prepend_uniq_w): Delete addition from 2008-07-11.
	(_m4_grow_uniq_1): Rename back...
	(_m4_append_uniq): ...to this.
	* NEWS: Revert NEWS blurb.
	* doc/autoconf.texi (Text processing Macros) <m4_prepend>: Delete.
	* tests/m4sugar.at (m4@&t@_prepend): Delete.

2008-07-15  Eric Blake  <ebb9@byu.net>

	Avoid failure if version.m4 is omitted but m4_PACKAGE_* unused.
	* lib/m4sugar/m4sugar.m4 (m4_version_compare): Provide alternate
	definition for non-Autoconf clients of m4sugar.

2008-07-14  Eric Blake  <ebb9@byu.net>

	Tighten bound of potential speed of m4_append.
	* doc/autoconf.texi (Text processing Macros) <m4_append>
	<m4_prepend>: If m4 is fixed, m4_append can be linear rather than
	O(n log n).
	* lib/m4sugar/m4sugar.m4 (m4_append, m4_append_uniq): Fix comments.
	Analysis by Bruno Haible.

2008-07-11  Eric Blake  <ebb9@byu.net>

	Inherit improvements from bison's fork of m4sugar.
	* lib/m4sugar/m4sugar.m4 (m4_PACKAGE_VERSION): Ignore failure to
	find version.texi, since bison does not provide it.
	(m4_prepend): Add new macro, from bison.
	(m4_prepend_uniq, m4_prepend_uniq_w): Add new macros, for
	completeness.
	(_m4_append_uniq): Rename...
	(_m4_grow_uniq_1): ...to this to share implementation, and
	optimize initial assignment.
	(m4_append_uniq_w): Adjust caller.
	* NEWS: Document new macros.
	* doc/autoconf.texi (Text processing Macros) <m4_append>: Mention
	speed consideration.
	<m4_prepend>: Document the new prepend variants.
	* tests/m4sugar.at (m4@&t@_prepend): New test.

	Work around M4 1.6 warning on undefined macros.
	* lib/m4sugar/m4sugar.m4 (changeword, symbols): Don't rename if
	not already available as builtins.

2008-07-06  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* doc/autoconf.texi (@dvar): Remove trailing newline.
	(@ovar): Likewise.  Fix macro documentation.

2008-07-02  Stepan Kasal  <skasal@redhat.com>

	Add quotes to the header of autoscan-generated source.
	* bin/autoscan.in: Add quotes to AC_PREREQ and AC_INIT.

2008-06-28  Andreas Schwab  <schwab@suse.de>

	* doc/autoconf.texi (autoscan Invocation): Fix spacing.
	(autoconf Invocation): Likewise.
	(autoreconf Invocation): Likewise.
	(autoheader Invocation): Likewise.
	(autom4te Invocation): Likewise.

2008-06-19  Eric Blake  <ebb9@byu.net>

	Add comment explaining recent patch.
	* lib/autotest/general.m4 (AT_INIT) <at_pass_list>: Explain choice
	of * vs. ? globbing.

2008-06-19  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autoconf/status.m4 (_AC_OUTPUT_LINK): Do not warn when not
	linking a file to itself.
	Report by Bruno Haible.

2008-06-19  Eric Blake  <ebb9@byu.net>

	Resync with gnulib.
	* GNUmakefile: Grab from upstream, to fix VPATH 'make dist' bug.
	Reported by Stepan Kasal.

2008-06-18  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Reorganize autotest files, factorize for parallel execution.
	* lib/autotest/general.m4 (AS_MESSAGE_LOG_FD): Move definition
	earlier in the file.
	(AT_INIT): Create line number cache in
	$at_suite_dir/at-source-lines.
	<at_helper_dir>: New directory at-groups below $at_suite_dir.
	Add comment explaining the new directory structure.
	(at_func_group_prepare, at_func_group_postprocess): New shell
	functions to factorize per-test group work.  Keep the actual
	test execution outside of a shell function in order to avoid
	zsh 4.x exit status bugs.
	<at_check_line_file, at_status_file, at_stdout, at_stder1>
	<at_stderr, at_test_source>: Turn these into per-group files
	below $at_helper_dir.  Also store test results there in files
	named pass, fail, xpass, xfail, skip.  Let the parent collect
	results from $at_helper_dir.  Adjust summary statistics
	computation and result output.

2008-06-17  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix '#undef variable /* comment */' transform in config headers.
	* lib/autoconf/status.m4 (_AC_OUTPUT_HEADERS_PREPARE): For
	undefined preprocessor macros that are followed by a comment
	in the header template, do not create nested comments in the
	output.
	* tests/torture.at (@%:@define header templates): Extend test.
	* NEWS: Update.
	Report by Karsten Hopp <karsten@redhat.com>.

2008-06-09  Eric Blake  <ebb9@byu.net>

	Mark AC_TYPE_SIGNAL as obsolete.
	* lib/autoconf/types.m4 (AC_TYPE_SIGNAL): Switch to AU_DEFUN.
	* doc/autoconf.texi (Function Portability): Update documentation.
	(Particular Types): Move AC_TYPE_SIGNAL...
	(Obsolete Macros): ...here, and mention why.
	* NEWS: Mention the change.

	Allow lib64 as a default X library location.
	* lib/autoconf/libs.m4 (_AC_PATH_X_XMKMF): Add lib64.
	* NEWS: Mention the change.
	* THANKS: Update.
	Reported by Brad Walker.

2008-06-05  Eric Blake  <ebb9@byu.net>

	Fix regression in AT_KEYWORDS([Macro]), from 2007-10-18.
	* lib/autotest/general.m4 (AT_KEYWORDS): Expand argument prior to
	converting it to lower case.
	* tests/autotest.at (Keywords and ranges): Test this.
	* NEWS: Document the fix.
	* THANKS: Update.
	Reported via Karsten Hopp, by Jochen Schmitt in
	https://bugzilla.redhat.com/show_bug.cgi?id=449973

2008-06-03  Eric Blake  <ebb9@byu.net>

	Fix 'make dist' regression from 2008-05-08.
	* Makefile.am (INSTALL): Add rule, to accomodate 'make dist' after
	GNUmakefile's _autoconf rule removes INSTALL.

2008-05-27  Eric Blake  <ebb9@byu.net>

	Document Solaris /bin/sh redirection pitfall.
	* doc/autoconf.texi (File Descriptors): Mention redirection bug.

2008-05-14  Eric Blake  <ebb9@byu.net>

	Improve documentation of ! issues.
	* doc/autoconf.texi (Limitations of Builtins) <!>: Touch up.
	Reported by Noah Misch.

	Document some FreeBSD shell bugs.
	* doc/autoconf.texi (Limitations of Builtins) <!>: Mention ! issue
	in compound pipe commands.
	<export>: Mention difference of exporting an undefined variable.
	(Shell Functions): Mention loss of $? in entry to shell functions.
	Extracted from the git mailing list.

2008-05-13  Stepan Kasal  <kasal@ucw.cz>

	Work around MSYS and Cygwin bugs when dealing with trailing space.
	* tests/atlocal.in (func_sanitize_dir_name): Let atlocal succeed,
	even when platform bugs are tickled.
	Reported by Keith Marshall and Eric Blake.

2008-05-12  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Let AC_MSG_FAILURE report pwd.
	* lib/autoconf/general.m4 (_AC_ARG_VAR_VALIDATE, AC_MSG_FAILURE):
	Output $ac_pwd along with fatal failure.
	* tests/torture.at (Deep Package): Extend test.
	Reported numerous times against GCC, and probably other packages.

2008-05-12  Eric Blake  <ebb9@byu.net>

	Enforce --help and --version compliance.
	* configure.ac (AM_INIT_AUTOMAKE): Add std-options option.

2008-05-08  Keith Marshall  <keithmarshall@users.sourceforge.net>  (tiny change)

	Avoid case-insensitive `make install' vs. `INSTALL' conflict.
	* Makefile.am ($(srcdir)/INSTALL): Replace all references...
	($(abs_srcdir)/INSTALL): ...with this.

2008-05-06  Eric Blake  <ebb9@byu.net>

	Fix typo.
	* doc/autoconf.texi (Shell Substitutions): Drop at_ prefix.

	Avoid overfull \hbox.
	* doc/autoconf.texi (Versioning): Reword to fit line size.

	Document $(( )) pitfalls.
	* doc/autoconf.texi (Shell Substitutions): Mention octal
	vs. decimal.  Mention autotest's at_func_arith.

	Improve behavior of './testsuite 01'.
	* lib/autotest/general.m4 (AT_INIT) <at_func_validate_ranges>:
	Alter usage to eval its arguments, in order to normalize away
	leading zero.  All callers updated.
	* tests/autotest.at (Keywords and ranges): Test range
	normalization with leading 0.

2008-04-26  Eric Blake  <ebb9@byu.net>

	Mention Solaris /usr/ucb/tr pitfall.
	* doc/autoconf.texi (Limitations of Usual Tools) <tr>: Add section.
	Reported by Bruno Haible and Jim Meyering.

2008-04-24  Eric Blake  <ebb9@byu.net>

	Mention m4sugar's internal quote strings.
	* doc/autoconf.texi (Quadrigraphs): Mention alternate quote used
	in m4sugar, and how to still output it literally.
	* tests/m4sugar.at (m4@&t@_split): And test it.
	Reported by Joel E. Denny.

2008-04-23  Eric Blake  <ebb9@byu.net>

	Allow unbalanced () in m4_expand.
	* lib/m4sugar/m4sugar.m4 (m4_expand, _m4_expand): Use more complex
	quotes.
	(m4_noquote, _m4_split): Use consistent complex quote.
	* tests/autotest.at (Left paren, Right paren): Test this.
	(Parentheses): Ensure new quadrigraphs still work.
	(AT_CHECK_AT_TITLE_CHAR): All title char tests exercise m4_expand.
	* NEWS: Mention the fix.
	* doc/autoconf.texi (Quadrigraphs): Revert mention of macros that
	require quadrigraphs for ().
	(Evaluation Macros) <m4_expand>: Relax the restriction against
	unbalanced ().
	(Pretty Help Strings) <AS_HELP_STRING>: Likewise.
	(Writing Testsuites) <AT_SETUP>: Likewise.
	Reported by Joel E. Denny, fix suggested by Noah Misch.

2008-04-22  Eric Blake  <ebb9@byu.net>

	Support unbalanced () in AT_SETUP by adding two new quadrigraphs.
	* bin/autom4te.in (handle_output): Substitute @{:@ and @:}@.
	(handle_traces): Likewise.
	* lib/m4sugar/m4sugar.m4 (m4_qlen): Account for new quadrigraphs.
	* tests/autotest.at (AT_CHECK_AT_TITLE_CHAR): Add new tests.
	* doc/autoconf.texi (Quadrigraphs): Document them.
	(Evaluation Macros) <m4_expand>: Enhance documentation.
	(Text processing Macros) <m4_text_box>: Document cases where
	quadrigraphs can help for problemetic unbalanced parentheses.
	(Pretty Help Strings) <AS_HELP_STRING>: Likewise.
	(Writing Testsuites) <AT_SETUP>: Likewise.
	(Limitations of Builtins) <case>: Consolidate text on unbalanced
	parentheses, and add an example of creative comments.
	* NEWS: Document the addition.
	Reported by Joel E. Denny.

2008-04-16  Eric Blake  <ebb9@byu.net>

	Document pdksh exec behavior.
	* doc/autoconf.texi (Limitations of Builtins) <exec>: New
	subsection.
	Discovered by Jim Meyering.

2008-04-14  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* tests/autotest.at (AT_CHECK_AT): Allow to pass additional
	arguments to the inner suite.
	(errexit, input from stdin): New tests.

2008-04-13  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* NEWS: Post-release update.

2008-04-10  Eric Blake  <ebb9@byu.net>

	AC_AUTOCONF_VERSION might contain arbitrary macro names.
	* doc/autoconf.texi (Versioning): Mention problem with expansion.
	* tests/tools.at (autoconf: AC_AUTOCONF_VERSION): Adjust test.

2008-04-09  Slava Sysoltsev <Viatcheslav.Sysoltsev@h-d-gmbh.de>  (tiny change)

	Flush buffered output before exit.
	* bin/autom4te.in (handle_output): Explicitly close file.
	* THANKS: Update.
	See http://lists.gnu.org/archive/html/autoconf/2008-04/msg00026.html.

2008-04-08  Eric Blake  <ebb9@byu.net>

	Generate web docs for 2.62.
	* doc/autoconf.texi (Evaluation Macros): Fix typo.
	(Notices): Use recommended means to escape RCS keyword.
	* cfg.mk (gnulib_dir): New macro.
	(web-manual): New target.

2008-04-05  Eric Blake  <ebb9@byu.net>

	Release Version 2.62.
	* NEWS: Mention the release.

2008-04-04  Stepan Kasal  <kasal@ucw.cz>
	and Eric Blake  <ebb9@byu.net>

	Return back to GPLv2+, until the text of the exceptions is
	finalized, reverting the change from 2007-07-03 and the first
	part of the change from 2007-07-20.
	* COPYING: Revert to GPLv2.
	* COPYINGv3: New file, since some auxiliary build tools, used for
	building autoconf and not installed, are GPLv3.
	* Makefile.am (EXTRA_DIST): Distribute COPYINGv3.
	* NEWS: Remove mention of GPLv3.
	* README: Clarify situation regarding GPLv3.

2008-04-05  Eric Blake  <ebb9@byu.net>

	Prepare for release.
	* maint.mk (announcement): Avoid deleted option.
	* cfg.mk (release_archive_dir): Use default.
	* build-aux/gnupload: New file, from automake/gnulib.
	* Makefile.am (EXTRA_DIST): Distribute it.
	* .x-sc_two_space_separator_in_usage: New file, to exempt gnupload
	from syntax check.

2008-04-05  Jim Meyering  <meyering@redhat.com>
	and Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Work around CR EOL markers on OS/2 (www.ecomstation.com Ecs v2 rc4)
	* lib/autoconf/status.m4 (_AC_OUTPUT_FILES_PREPARE): When CR
	is the EOL marker, skip a step that would remove and translate
	carriage return bytes.
	* THANKS: Update.
	Reported by Elbert Pol.

2008-04-05  Eric Blake  <ebb9@byu.net>

	Avoid some autoreconf -Wall warnings.
	* configure.ac: Use proper quoting, to be a good example.
	(PACKAGE_NAME): Remove setting covered by autoconf.
	(AM_INIT_AUTOMAKE): Bump automake requirement, for html rules.
	* doc/Makefile.am (TEXI2DVI): Remove settings covered by
	automake.
	(html, autoconf_1.html, standards_1.html): Likewise.
	(TEXI2HTML, TEXI2HTML_FLAGS): Remove unused macros.
	* Makefile.am (html): Likewise.
	* doc/autoconf.texi (Quoting and Parameters): Add missing section
	name.
	* tests/Makefile.am (AUTOMAKE_OPTIONS): Intentionally ignore
	warning about our override, until Automake is fixed.
	* README-hacking: Document minimum requirements for bootstrap.

2008-04-03  Eric Blake  <ebb9@byu.net>

	Fix version number generation in man pages.
	* Makefile.am (EXTRA_DIST): Distribute .version.
	(.version): New rule.
	* man/Makefile.am (common_dep): Depend on .version, not
	configure.ac.
	(.x.1): Use package name for version string.
	* GNUmakefile [!_have-Makefile]: Sync from upstream, again.
	* build-aux/git-version-gen: Sync from upstream.

	More maintainer tweaks: pass 'make maintainer-distcheck'.
	* GNUmakefile (_is-dist-target): Sync from upstream.
	* build-aux/vc-list-files: Sync from upstream, yet again.
	* tests/atlocal.in (unsupported_fs_chars): Always remove tdir.
	* tests/Makefile.am (EXTRA_DIST): Don't distribute the built
	package.m4.
	* lib/autoconf/general.m4 (_AC_INIT_COPYRIGHT): Bump year.

	Fix VPATH 'make syntax-check'.
	* maint.mk (VC_LIST, VC_LIST_EXCEPT, sc_changelog)
	(sc_prohibit_jm_in_m4, makefile-check): Support VPATH.
	(author_mark_check): Avoid error message.
	* build-aux/vc-list-files: Sync from upstream again.
	* build-aux/texinfo.tex: Likewise.

	Sync files from upstream, and pass 'make syntax-check'.
	* config/announce-gen: Move...
	* build-aux/announce-gen: ...here, and sync from gnulib.
	* Makefile.am (EXTRA_DIST): Adjust accordingly.
	* cfg.mk (announce_gen): Likewise.
	(prev_version_file): Delete, relying on default in maint.mk.
	(gpg_key_ID): New macro.
	(url_dir_list): Rewrite to match coreutils.
	* config/prev-version.txt: Move...
	* .prev-version: ...here, and adjust to 2.61.
	* build-aux/vc-list-files: Sync from coreutils.
	* maint.mk: Resynchronize with coreutils, where possible.
	(ME): Remove $(srcdir) from definition.
	(CVS): Delete.
	(GIT, VC, VC-tag): New macros.
	(CVS_LIST, CVS_LIST_EXCEPT): Rename...
	(VC_LIST, VC_LIST_EXCEPT): ...to this.
	(cvs-tag-check): Delete.
	(cvs-diff-check): Rename...
	(vc-diff-check): ...to this.
	(sc_file_system): Allow FHS acronym.
	* doc/autoconf.texi (Particular Functions): Recommend
	unconditional <config.h>.
	* build-aux/config.guess: Sync from upstream (manually).
	* build-aux/config.sub: Likewise.
	* build-aux/texinfo.tex: Likewise.
	* doc/make-stds.texi: Likewise.
	* doc/standards.texi: Likewise.
	* .gitattributes: Ignore whitespace problems in upstream files.

2008-04-03  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* doc/autoconf.texi (Limitations of Usual Tools): Mention awk %u
	bug on HP-UX/IA.
	Report by Peter O'Gorman.

2008-04-02  Eric Blake  <ebb9@byu.net>

	Recommend the just-released M4 1.4.11.
	* NEWS: Update recommendation.
	* README: Likewise.
	* doc/autoconf.texi (Introduction): Likewise.
	* m4/m4.m4 (AC_PROG_GNU_M4): Likewise.

2008-04-01  Eric Blake  <ebb9@byu.net>

	* lib/autoconf/status.m4 (_AC_OUTPUT_CONFIG_STATUS): Bump
	copyright year.

2008-03-28  Peter O'Gorman  <peter@pogma.com>

	Find X11 on Mac OS X too.
	* lib/autoconf/libs.m4 (_AC_PATH_X_DIRECT,_AC_PATH_X_XMKMF):
	Check for libX11 with extensions dylib la and dll too.
	* THANKS: Update.
	Reported by Martin Costabel.

2008-03-28  Eric Blake  <ebb9@byu.net>

	Update TODO based on completed tasks.
	* TODO (AC_PROG_INSTALL takes multiple files): Done.
	(AC_GNU_SOURCE deprecation): Done, see AC_USE_SYSTEM_EXTENSIONS.
	(AC_COMPILE_IFELSE documentation): Done.
	(Tracing builtins): Done, now that we require M4 1.4.5.
	(AC_PROG_CC_POSIX suggestion, providing header files)
	(AC_TYPE_SIGNAL): Not needed; gnulib's approach is better.
	(cache consistency): Done with precious variables.

2008-03-26  Eric Blake  <ebb9@byu.net>

	Document --trace=macro:format in --help output.
	* bin/autom4te.in (help): Mention optional trace format.
	* bin/autoconf.as (usage): Likewise.

	* doc/autoconf.texi (Limitations of Usual Tools) <sed>: Fix
	typos in last patch.
	Reported by Ralf Wildenhues.

2008-03-26  Jim Meyering  <meyering@redhat.com>

	Fix texinfo syntax error.
	* doc/autoconf.texi (Limitations of Usual Tools): s/@kbd {/@kbd{/

2008-03-26  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Warn, not fail on whitespace-only precious variable differences.
	* lib/autoconf/general.m4 (_AC_ARG_VAR_VALIDATE): Output
	precious variable differences less ambiguous with `ugly-quotes'.
	If their settings differ only in whitespace, do not fail, but
	reuse the old value.
	* tests/torture.at (AT_CHECK_AC_ARG_VAR): Extend macro to allow
	an optional status and expected-warning argument.  Fix m4
	quotation for initial value.
	(AC_ARG_VAR): Also test for whitespace-only differences, and
	that the old value is retained in this case.
	* doc/autoconf.texi (Setting Output Variables): Document this.
	* NEWS: Update.
	Report and initial patch by Paolo Bonzini.

2008-03-26  Eric Blake  <ebb9@byu.net>

	Document busybox sed bug.
	* doc/autoconf.texi (Limitations of Usual Tools) <sed>: Mention
	restrictions when using back-references.
	Reported by Vincent Lefevre:
	<http://thread.gmane.org/gmane.comp.gnu.coreutils.bugs/13013>.

	Document Automake interaction with AC_CONFIG_MACRO_DIR.
	* doc/autoconf.texi (Input): Mention ACLOCAL_AMFLAGS for automake
	users.
	* THANKS: Update.
	Reported by Chris Pickett.

2008-03-25  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* tests/autotest.at (Using atlocal): Quote instances of `pwd`.

	* tests/local.at (AT_CHECK_M4): Factorize warning output
	normalization.
	Suggested by Eric Blake.

2008-03-24  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix .exe-related test failure on MinGW.
	* tests/local.at (AT_CHECK_M4): Normalize `/bin/m4.exe' correctly
	for comparing warning output.

	Fix Fortran testsuite failures with gfortran 4.3.
	* lib/autoconf/fortran.m4 (_AC_PROG_FC_V_OUTPUT): When scanning
	verbose compiler output, skip lines that set variables; gfortran
	4.3 sets LIBRARY_PATH, COMPILER_PATH, COLLECT_GCC_OPTIONS.
	* THANKS: Update.
	Report by Vincent Lefèvre.

2008-03-21  Eric Blake  <ebb9@byu.net>

	* GNUmakefile: Resynchronize with gnulib.

	Document more uses of $cross_compiling.
	* doc/autoconf.texi (Runtime): Document that a temporary override
	is permissible.
	* THANKS: Update.
	Reported by Ineiev, example by Ralf Wildenhues.

	Don't swallow $1 in textual local variables.
	* lib/m4sugar/m4sugar.m4 (m4_combine): Don't use overquoting and
	expansion of text arguments, as that swallows $1.
	(m4_text_wrap): Likewise, by splitting out...
	(_m4_text_wrap): ...new helper macro.  Also, allow arbitrary
	expression for width.
	* tests/m4sugar.at (m4@&t@_text_wrap): Test this.
	(m4@&t@_combine): Likewise.

2008-03-21  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Avoid leftover files on Leopard.
	* lib/autoconf/lang.m4 (_AC_COMPILER_EXEEXT): Remove a.out.dSYM
	directory created on darwin.
	(AC_NO_EXECUTABLES): Likewise; also remove objects which may be
	left over from a broken link.
	* tests/c.at (AC_NO_EXECUTABLES (working linker))
	(AC_NO_EXECUTABLES (broken linker)): New tests.
	Report by Gary V. Vaughan.

	* lib/autom4te.in (Automake-preselections): Trace
	_AM_COND_IF, _AM_COND_ELSE, _AM_COND_ENDIF.

2008-03-20  Eric Blake  <ebb9@byu.net>

	Kill more CVS references.
	* README-cvs: Delete.  See README-hacking instead.
	* README-hacking: Update wording, based on older file.
	* BUGS: Remove CVS mention.

2008-03-20  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* tests/tools.at (autotools and whitespace in file names): Skip
	if aclocal is not present.

2008-03-20  Eric Blake  <ebb9@byu.net>

	Sync GNUmakefile with gnulib.
	* GNUmakefile (Makefile.cfg): Rename...
	(cfg.mk): ...to this, and make optional.
	(GNUmakefile.cfg): Delete, redundant with cfg.mk.
	(Makefile.maint): Rename...
	(maint.mk): ...to this.
	(all) [!_have-Makefile]: Rename...
	(abort-due-to-no-makefile): ...to this, and invoke via
	.DEFAULT_GOAL to pick up all targets.
	* Makefile.cfg: Rename...
	* cfg.mk: ...to this.
	* Makefile.maint: Rename...
	* maint.mk ...to this.
	(ME): Reflect name change.
	(makefile-check, m4-check, author_mark_check, msg): Use $(ME)
	rather than hard-coded name.
	* GNUmakefile.cfg: Delete; move rules into cfg.mk.
	* Makefile.am (EXTRA_DIST): Reflect file name changes.
	* .x-sc_prohibit_atoi_atof: Likewise.
	* lib/freeze.mk: Likewise.

2008-03-19  Stepan Kasal  <kasal@ucw.cz>

	* doc/autoconf.texi (Introduction): Improve the paraphrase of
	Henry Spencer's quotation.

2008-03-19  Eric Blake  <ebb9@byu.net>

	AC_CONFIG_HEADERS replaced AC_CONFIG_HEADER.
	* bin/autoscan.in (output): Avoid obsolete spelling.
	* tests/local.at (AC_STATE_SAVE): Update usage.
	* THANKS: Update.
	Reported by John Calcote.

	Emphasize that ease of configure triumphs over ease of autoconf.
	* doc/autoconf.texi (Introduction): Expand on primary
	vs. secondary goal of autoconf.
	* THANKS: Update.
	Inspired by Paul Smith.

2008-03-17  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/Autom4te/FileUtils.pm (handle_exec_errors): New argument
	$hint, show if the executing program does not exist.
	(xsystem_hint): New function, like xsystem but allows to pass
	a hint.
	* bin/autoreconf.in: Use xsystem_hint for spawning autopoint and
	libtoolize.
	Report by Bruce Korb.

2008-03-14  Stepan Kasal  <kasal@ucw.cz>

	* lib/Autom4te/ChannelDefs.pm, tests/fortran.at,
	tests/mktests.sh, tests/wrapper.as: Fix typos.

2008-03-12  Eric Blake  <ebb9@byu.net>

	Fix yesterday's regression in m4_wrap([$1]).
	* lib/m4sugar/m4sugar.m4 (_m4_wrap): Don't directly invoke wrapped
	text, since it may contain text that looks like parameters.
	* tests/m4sh.at (AS@&t@_INIT cleanup): Enhance test.

2008-03-11  Eric Blake  <ebb9@byu.net>

	Improve error messages for common testsuite bugs.
	* lib/autotest/general.m4 (_AT_DEFINE_INIT, _AT_DEFINE_SETUP): New
	macros for defining order-enforced macros.
	(AT_INIT, AT_SETUP, AT_CLEANUP, AT_BANNER, AT_XFAIL_IF)
	(AT_CAPTURE_FILE, AT_DATA, AT_CHECK, AT_CHECK_NOESCAPE): Add error
	messages when order violations are detected.
	* tests/autotest.at (AT_CHECK_AT_SYNTAX): New helper macro.
	(AT_SETUP without AT_INIT, AT_BANNER without AT_INIT)
	(AT_CLEANUP without AT_INIT, Missing AT_CLEANUP)
	(AT_CHECK without AT_SETUP, AT_DATA without AT_SETUP)
	(AT_XFAIL_IF without AT_DATA, AT_KEYWORDS without AT_SETUP,
	(AT_CLEANUP without AT_SETUP, AT_BANNER inside AT_SETUP)
	(AT_SETUP inside AT_SETUP, Multiple AT_INIT)
	(Banner-only test suite): New tests.
	Reported by Christopher Hulbert.

	Tweak m4_wrap to force FIFO or LIFO semantics.
	* lib/m4sugar/m4sugar.m4 (m4_wrap): Override M4 implementation.
	(m4_wrap_lifo, _m4_wrap): New macros.
	* lib/m4sugar/m4sh.m4 (AS_INIT): Combine all cleanup into known
	order, prior to m4sugar's.
	(_AS_DETECT_BETTER_SHELL): Use cleanup parameter, rather than
	m4_wrap.
	* lib/autotest/general.m4 (AT_INIT): Combine all cleanup into
	known order, prior to m4sh's.
	* doc/autoconf.texi (Diagnostic Macros) <m4_fatal>: Document
	argument.
	(Redefined M4 Macros) <m4_wrap>: Rewrite documentation to match
	new behavior.
	* tests/m4sh.at (AS_INIT cleanup): New test.
	* NEWS: Document the change.

2008-03-10  Eric Blake  <ebb9@byu.net>

	Encode nested autotest data.
	* tests/autotest.at (AT_CHECK_AT_PREP): Avoid raw AT_ in output.
	(unusual file names): Likewise.
	(m4_pattern_allow): Remove loophole, to make it easier to catch
	poorly written tests.

	Factor some autotest tests.
	* tests/autotest.at (AT_CHECK_AT_PREP): New macro, to factor out
	common initialization.
	(AT_CHECK_AT, Banners, Keywords and ranges, srcdir propagation)
	(whitespace in absolute testdir, unusual file names): Use it.

2008-03-06  Eric Blake  <ebb9@byu.net>

	Minor documentation fix.
	* doc/autoconf.texi (Evaluation Macros): Fix typo.

2008-03-04  Eric Blake  <ebb9@byu.net>

	Make AT_CHECK act like a simple command.
	* lib/autotest/general.m4 (_AT_CHECK): Wrap commands in {;}.
	* tests/torture.at (AT_CHECK_CONFIG_CREATION_NOWRITE): Test it.

2008-03-04  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	On MinGW, substitution of CR and 0xFF fails.
	* tests/torture.at (Substitute and define special characters):
	MinGW awk cannot handle 0xFF, and on MinGW, the test does the
	wrong thing for CR.

2008-03-04  Eric Blake  <ebb9@byu.net>

	Pull in recent maintainer improvements from coreutils.
	* GNUmakefile (_is-dist-target): 'make distclean' should not
	trigger autoreconf.
	(_dummy): Change directories before removing autom4te.cache.
	(check dist distcheck install) [!_have-Makefile]: Provide nicer
	diagnostics.
	* configure.ac (AC_CONFIG_LINKS): Copy GNUmakefile into VPATH
	builds, after initial bootstrap.
	* Makefile.am (distclean-local): Work around current automake bug.
	* Makefile.maint (ME): Allow VPATH usage.

	Use git-merge-changelog when available.
	* .gitattributes: New file.
	* README-hacking: Document use of git-merge-changelog.

	Work around cygwin bug.
	* tests/atlocal.in (unsupported_fs_chars): Avoid cygwin bug where
	"touch 't\'" creates regular file 't'.

	Ignore tests that require read-only directories under root.
	* tests/torture.at (AT_CHECK_CONFIG_CREATION_NOWRITE): Skip
	no-write portion if user has root-like privileges.

2008-03-04  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autotest/general.m4 (AT_INIT): Fix detection of '-C -'.

2008-03-03  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	autoreconf -m now honors $MAKE.
	* bin/autoreconf.in ($run_make): Renamed from ...
	($make): ... this.  Use now as command to run `make',
	overridden by $MAKE.  Document this in --help output.
	* doc/autoconf.texi (autoreconf Invocation): Document
	all environment variables honored by autoreconf.
	* NEWS: Update.
	Report by Paul Eggert.

2008-03-03  Eric Blake  <ebb9@byu.net>

	Documentation improvements.
	* doc/autoconf.texi (Looping constructs): s/recurses/repeats/.
	(Evaluation Macros): Drop `1' suffix from metasyntax variable name
	that preceeds @dots.  Improve wording.
	(Text processing Macros): Drop `1' suffix from metasyntax variable
	name that preceeds @dots.
	(Number processing Macros): Drop `1' suffix from metasyntax
	variable name that preceeds @dots.  Improve wording.
	* lib/m4sugar/m4sugar.m4 (m4_cmp): Comment wording fix.
	Suggested by Ralf Wildenhues.

2008-03-02  Jim Meyering  <meyering@redhat.com>

	Don't infloop upon "make dist".
	* GNUmakefile: Merge from coreutils.
	* Makefile.am (dist-hook): Inject .tarball-version into tarball,
	not .version.
	* configure.ac (AC_INIT): Use .tarball-version, not .version.
	* build-aux/git-version-gen: Update from gnulib.

2008-03-02  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* tests/torture.at (AC_CONFIG_FILES, HEADERS, LINKS and COMMANDS):
	Before using /dev/full, check that it is a writable character
	special device.
	Report by Benoit Sigoure and Eric Blake.

	Actually test that @configure_input@ is expanded correctly.
	* tests/torture.at (AC_CONFIG_FILES, HEADERS, LINKS and COMMANDS):
	Actually check generated file contents for the name of the
	generated file, using AC_PROG_FGREP and $FGREP.

2008-03-01  Benoit Sigoure  <tsuna@lrde.epita.fr>

	Be nice with file systems that don't handle unusual characters.
	* tests/atlocal.in (func_sanitize_file_name)
	(func_sanitize_dir_name): New shell functions.
	* tests/tools.at (autom4te and whitespace in file names)
	(autotools and whitespace in file names): Use them.
	* tests/torture.at (AC_CONFIG_FILES, HEADERS, LINKS and COMMANDS):
	Cover more potentially problemtic file names.  Use the new
	functions.

	Properly handle funny file names for headers in config.status.
	The test suite did not cover this bug because the code was not
	quoting properly the arguments of `rm -f' (which "fails" silently)
	as well as the arguments of `diff' (whose output was redirected to
	/dev/null so we couldn't see its error message).
	* lib/autoconf/status.m4 (_AC_OUTPUT_HEADER): Properly quote the
	file names passed to `rm' and `diff'.
	* tests/torture.at (AC_CONFIG_FILES, HEADERS, LINKS and COMMANDS):
	Add a regression test.

2008-03-01  Benoit Sigoure  <tsuna@lrde.epita.fr>
	and Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Properly expand @configure_input@ in config.status.
	* lib/autoconf/status.m4 (_AC_OUTPUT_FILE, _AC_OUTPUT_MAIN_LOOP):
	Escape the backslashes and ampersands in $configure_input before
	using it in the sed replacement string to expand @configure_input@.
	Report by Eric Blake and Patrick Welche.

2008-03-01  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Ignore errors from ./run on w32.
	* tests/autotest.at (whitespace in absolute testdir):
	Ignore stderr for `./run' which fails to remove the
	busy test directory on w32.

2008-02-22  Eric Blake  <ebb9@byu.net>

	Improve documentation for writing autotest suites.
	* doc/autoconf.texi (Writing Testsuites) <AT_CHECK>: Mention that
	checks must live inside a test group.
	Reported by Christopher Hulbert.

2008-02-21  Eric Blake  <ebb9@byu.net>

	Sync git-version-gen from upstream.
	* build-aux/git-version-gen: Pull from gnulib.
	* configure.ac (AC_INIT): Adjust to new calling convention.

2008-02-12  Eric Blake  <ebb9@byu.net>

	Avoid trailing space in config.h with AC_DEFINE([var], []).
	* lib/autoconf/general.m4 (_AC_DEFINE_Q): Explicitly mark empty
	defines with a comment.

2008-02-08  Eric Blake  <ebb9@byu.net>

	Fix texinfo typos in previous patch.
	* doc/autoconf.texi (Site Defaults): s/[{}]/@&/g.
	Reported by Ralf Wildenhues.

	Describe a config.site that can be used for FHS compliance.
	* doc/autoconf.texi (Site Defaults): Fix typo.  Add new example
	for FHS.
	* THANKS: Update.
	Reported by Jules Colding and Ralf Wildenhues.

2008-02-02  Eric Blake  <ebb9@byu.net>

	* doc/autoconf.texi (Limitations of Usual Tools) <grep>: Fix typo.

2008-02-02  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autotest/general.m4 (AT_INIT): Fix --clean to work
	again, broken since introduction of `-C dir'.
	* tests/autotest.at (Choosing where testsuite is run): Test it.

2008-01-30  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/autoconf.texi: Update Back-Cover text to reflect new GNU wording.

2008-01-29  Eric Blake  <ebb9@byu.net>

	Fix more autotest regressions.
	* lib/autotest/general.m4 (AT_LINE): Fix regression from
	2007-10-04 when file name is `dnl'.
	(AT_INIT) <PREPARE_TESTS>: Move command-line assignments...
	<TESTS_BEGIN>: ...to this new diversion, to fix regression from
	yesterday in libtool's testsuite.
	(_AT_ARG_OPTION): Detect write failure.
	* doc/autoconf.texi (Diversion support): Document PREPARE_TESTS to
	make libtool's use kosher.  Document m4_init.
	(Programming in M4sh): Document AS_INIT.
	(Writing Testsuites): Document limitation of AT_DATA file name.
	* tests/autotest.at (unusual file names): New test.
	(Banners, Keywords and ranges): Use correct shell.

	More corner cases in testsuite VAR=VALUE handling.
	* lib/autotest/general.m4 (AT_INIT) <PREPARE_TESTS): Fix quoting
	bug.
	<PARSE_ARGS_END>: Also detect leading digits in assignments.
	* tests/autotest.at (Using atlocal): Enhance test to catch last
	bug.

	* doc/autoconf.texi (Limitations of Builtins) <.>: Mention bash
	bug.

2008-01-28  Eric Blake  <ebb9@byu.net>

	Fix regression in handling VAR=VALUE arguments to testsuite.
	* lib/autotest/general.m4 (AT_INIT) <PARSE_ARGS_END>: Detect
	leading = as invalid.  Defer use of command-line variable
	assignments...
	<PREPARE_TESTS>: ...here, after atconfig has been sourced.  Fix
	regression in sourcing files.
	* tests/autotest.at (Using atlocal): New test to catch this.
	(Debugging a successful test, Choosing where testsuite is run):
	Use correct shell.
	Reported by Ralf Wildenhues.

	Document grep peculiarity.
	* doc/autoconf.texi (Limitations of Usual Tools) <grep>: Document
	BSD behavior on binary input.

	Minor testsuite improvements.
	* lib/autotest/general.m4 (AT_INIT) <PREPARE_TESTS>: Use fewer
	forks when sanitizing PATH.  Always output machine information,
	not just when atconfig was located.

	Add 'testsuite -C dir'.
	* lib/autotest/general.m4 (_AT_ARG_OPTION): Move missing argument
	detection...
	(AT_INIT) <PARSE_ARGS_END>: ...here, since -k always takes
	argument.
	<DEFAULTS>: Delay computation of variables based on $at_dir...
	<PREPARE_TESTS>: ...to here, since -C can change $at_dir.
	<TESTS>: Re-invoke via absolute name, since -C may be in effect.
	<PARSE_ARGS>: Parse new option.
	<HELP_TUNING>: Document it.
	* tests/autotest.at (Choosing where testsuite is run): New test
	for this feature.
	(Keywords and ranges): Add test for missing -k argument.
	* NEWS: Document this.
	* doc/autoconf.texi (testsuite Invocation): Likewise.

2008-01-24  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* build-aux/config.guess, build-aux/config.sub,
	build-aux/texinfo.tex: Sync from gnulib.
	* doc/fdl.texi, doc/make-stds.texi, doc/standards.texi:
	Likewise.

2008-01-23  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* doc/autoconf.texi (Particular Programs): Do not mention the
	Autoconf version in which the AC_PROG_INSTALL change was done.
	Suggested by Paul Eggert.

2008-01-22  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix --help=recursive with multiple AC_CONFIG_SUBDIRS.
	* lib/autoconf/general.m4 (_AC_INIT_HELP): If, for recursive help
	mode, we change to the source directory, also set $ac_pwd so we
	do not go back to the build tree for the next config subdir.
	* tests/torture.at (Deep Package): Extend test to contain two
	config subdirs on the top level.

	Fix parallel `maintainer-check'.
	* Makefile.am (maintainer-check-tests): Depend on `all'.
	Use `$(MAKE) $(AM_MAKEFLAGS)' instead of plain `make'.
	* tests/Makefile.am (maintainer-check-c++, maintainer-check-posix):
	Likewise.
	(maintainer-check): Serialize the testsuite runs.

	* lib/autoconf/general.m4 (_AC_INIT_PARSE_ENABLE2): Accept `+'
	in feature string for --enable/--with.  Convert to underscore
	for variable name.

	* lib/autoconf/programs.m4 (AC_PROG_INSTALL): Require that
	`install -c file1 file2 dir' works.
	* doc/autoconf.texi (Particular Programs): Document this.
	* NEWS: Update.

2008-01-21  Eric Blake  <ebb9@byu.net>

	Improve documentation about default include directives.
	* doc/autoconf.texi (Generic Headers, Generic Declarations)
	(Generic Structures, Generic Types)
	(Generic Compiler Characteristics): Add links to
	AC_INCLUDES_DEFAULT.
	Reported by Reuben Thomas.

2008-01-15  Eric Blake  <ebb9@byu.net>

	* lib/m4sugar/m4sugar.m4 (m4_qlen): Use fewer macros.

2008-01-08  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* tests/Makefile.am (noinst_SCRIPTS): Renamed from
	check_SCRIPTS.  Building the wrappers for `all' allows help2man
	to use them for the manpages.
	Report by Benoit Sigoure.

	* bin/autoreconf.in: Discard stderr for $autoconf/$aclocal --help.

2007-12-16  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix some write failure cases in Autotest.
	* lib/autotest/general.m4 (AT_INIT): Do not exit successfully
	upon write failures for --help, --version, --list.
	Guard against write failures for intermediate created scripts.
	<at_func_create_debugging_script>: Do not make the debugging
	script executable if it is not complete.

2007-12-12  Eric Blake  <ebb9@byu.net>

	Fix thinko in earlier patch - m4_join isn't defined yet.
	* lib/m4sugar/m4sugar.m4 (m4_expansion_stack_push, _m4_defun_pro)
	(_m4_defun_pro_outer, _m4_defun_epi, _m4_defun_epi_outer)
	(m4_require): Use m4_do, not m4_join.

	Fix some whitespace tests on cygwin.
	* tests/tools.at (autom4te and whitespace in file names): Restore
	font-lock.  Create $TMPDIR before it might be used.

	Fix spurious testsuite failure with M4 1.4.11.
	* tests/local.at (AT_CHECK_M4): Cater to new m4 error message.

	Optimize AC_REQUIRE.
	* lib/m4sugar/m4sugar.m4 (m4_expansion_stack_push, _m4_defun_pro)
	(_m4_defun_pro_outer, _m4_defun_epi, _m4_defun_epi_outer)
	(m4_require): Avoid extra macro calls.

2007-12-08  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* tests/torture.at (srcdir): Fix quoting.

	Do not pass top_srcdir to configure scripts in testsuite.
	* tests/autotest.at (srcdir propagation): Copy install-sh to
	source tree.
	(my only test): Drop setting of `top_srcdir'.
	* tests/base.at (Input/Output): Likewise.
	* tests/local.at (AT_CONFIGURE_AC): Copy install-sh,
	config.guess, and config.sub to test source tree.
	Drop AC_CONFIG_AUX_DIR setting.
	(AT_CHECK_CONFIGURE): Drop setting of `top_srcdir'.
	* tests/torture.at (Substitute a 2000-byte string): Drop
	AC_CONFIG_AUX_DIR setting, copy install-sh to test source tree.
	(Substitute a newline, datarootdir workaround): Likewise.
	(Define a newline): Adjust for linenumber changes in configure.ac.
	* tests/foreign.at (Libtool): Adjust comment to reflect changes.

	* tests/semantics.at (AC_PATH_PROGS_FEATURE_CHECK): Skip test
	if `pwd` contains whitespace.

	Quote $abs_top_srcdir in tests.
	* tests/local.at (AT_CHECK_PERL_SYNTAX): Likewise.
	* tests/tools.at (Syntax of the shell scripts): Likewise.

	* tests/m4sh.at (LINENO): Quote $0.

	Fix testsuite program wrapper for whitespace in `pwd`.
	The problem here is that the usual mantra is that command
	variables can contain arguments, thus we cannot just escape
	$AUTOCONF, $AUTOM4TE etc.  The compromise is to put the
	$top_builddir/tests directory early in $PATH, so that the
	wrappers are found by their plain name.
	* tests/wrapper.as: Put $testdir early in $PATH.
	(AUTOCONF, AUTOHEADER, AUTOM4TE): Set to plain command names.

	Proper config.status --file/--header and $srcdir escaping.
	* lib/autoconf/status.m4 (_AC_OUTPUT_MAIN_LOOP): Quote special
	characters in $ac_file_inputs.
	(_AC_OUTPUT_FILE, _AC_OUTPUT_HEADER): eval $ac_file_inputs
	accordingly.
	* tests/torture.at (datarootdir workaround): Adjust.
	(AC_CONFIG_FILES, HEADERS, LINKS and COMMANDS): Extend test.

	Fix Autotest for whitespace in `pwd`.
	* lib/autotest/general.m4 (AT_INIT)
	<at_func_create_debugging_script, Driver Loop>:
	Quote $at_group_dir.
	* tests/autotest.at (whitespace in absolute testdir): New test.

	* lib/autom4te.in: Quote @datadir@.

	Proper file name escaping in Autoconf programs and Perl modules.
	This includes escaping of characters special to the shell
	as well as special to Perl, e.g., leading `<' or `>'.
	For example, when $file starts with `>', `open ">$file"'
	wrongly tries to append to a different file.
	* bin/autoconf.as: Fix quoting for autom4te options.
	* lib/Autom4te/General.pm (shell_quote): New function, taken
	from coreutils, written by Jim Meyering.
	(mktmpdir): Use it.
	* bin/autom4te.in (files_to_options, handle_m4): Use shell_quote
	and open_quote.
	* bin/autoreconf.in (parse_args): Likewise.
	* bin/autoscan.in (main): Likewise.
	* bin/autoupdate.in (main): Likewise.
	* bin/autoheader.in: Likewise, fixing old insufficient escaping.
	* bin/ifnames.in: Likewise, XFile usage fixes.
	* tests/tools.at (autom4te and whitespace in file names): Extend
	test.  Test twice, with special characters allowed on w32, and the
	rest.  Test leading and trailing whitespace, for `open_quote'.
	(autotools and whitespace in file names): New, analogous test.
	Reported by Paul Eggert and Benoit Sigoure, additional suggestions
	by Russ Allbery and Eric Blake.

	Sync from Automake.
	* lib/Autom4te/Channels.pm, lib/Autom4te/Configure_ac.pm,
	lib/Autom4te/Struct.pm, lib/Autom4te/XFile.pm: Likewise.
	* lib/Autom4te/FileUtils.pm (open_quote): New function.
	(update_file, contents): Use it.

	* Makefile.am (autom4te-update): Rewrite for git.

2007-12-04  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* doc/autoconf.texi (autom4te Invocation, Autom4te Cache): Fix typos.

	Fix copyright years.
	* Makefile.am, doc/install.texi, lib/autoconf/fortran.m4,
	lib/autoconf/lang.m4, lib/freeze.mk: Likewise.

2007-12-04  Eric Blake  <ebb9@byu.net>

	Manually resync with gnulib, since 'make cvs-update' no longer works.
	* build-aux/config.guess: New upstream version.
	* build-aux/config.sub: Likewise.

	When using older automake, don't downgrade build-aux/texinfo.tex.
	* configure.ac (AM_INIT_AUTOMAKE): Add no-texinfo.tex option.
	* doc/Makefile.am (TEXINFO_TEX): Add.

2007-11-27  Paul Eggert  <eggert@cs.ucla.edu>

	Fix AC_C_BIGENDIAN bug caused by new awk method of substitution.
	* lib/autoconf/c.m4 (AC_C_BIGENDIAN): Don't comment out the
	#undef as this runs afoul of our new way of creating config.h.
	Problem reported by Jim Meyering in
	<http://lists.gnu.org/archive/html/autoconf-patches/2007-11/msg00164.html>.

2007-11-26  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix autom4te for unusual characters in input file names.
	* bin/autom4te.in (files_to_options): Quote active characters
	for the shell.
	* tests/tools.at (autom4te and white space in file names):
	New test.

	* doc/autoconf.texi (Limitations of Usual Tools) <awk>:
	Document that Tru64 awk always splits $0.

2007-11-24  Stepan Kasal  <kasal@ucw.cz>

	* lib/autotest/general.m4 (AT_INIT): Do not extract the
	`#AT_STOP_...' line at the end of each test.

2007-11-23  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autotest/general.m4 (AT_INIT): For awk line number
	extraction script, ensure `$at_group' has a defined value
	even for the empty set, and properly quote its usage inside
	the awk script.

2007-11-22  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* doc/autoconf.texi (Shell Functions): New chapter.  Document
	IRIX sh $0 issue in functions, move content from ...
	(Portable Shell): ... here.
	(Shell Script Compiler): Note that shell functions are not
	totally unportable any more.

2007-11-22  Stepan Kasal  <kasal@ucw.cz>
	and Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autotest/general.m4 (AT_INIT): Exit awk script after
	extracting the line numbers of the last needed test.

2007-11-20  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autotest/general.m4 (AT_INIT) <at_func_create_debugging_script>:
	Fix quoting.

2007-11-19  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix IRIX testsuite debugging failures: $0 in functions.
	* lib/autotest/general.m4 (AT_INIT) <at_func_create_debugging_script>:
	Do not use $0 inside a function, as IRIX sh will set that to the
	function name rather than the script invocation name.

2007-11-19  Paolo Bonzini  <bonzini@gnu.org>
	and Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autotest/general.m4 (at_func_test): Use cached line numbers
	to extract test scripts.
	(AT_INIT): Extract and cache test script line numbers.

2007-11-19  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autotest/general.m4: Revert 2007-11-15 patch and
	subsequent fixups; the awk -> here-document conversion trashes
	performance too much with AIX sh.

2007-11-18  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* tests/local.at: Do not test m4, perl with AT_TESTED.

	Diagnose and guard against write errors dealing with config.status.
	The general idea is this: all write failures from `configure'
	writing `config.status' are indicated by $ac_write_error, which
	is only checked at the end.  This is safe because config.status
	code is not executed before the file is complete.  Other write
	failures, be they inside config.status, or in sub shell/awk
	scripts spawned from configure or config.status, typically need
	earlier checking, as their results are used right afterwards.
	* lib/autoconf/status.m4 (AC_OUTPUT): Initialize `ac_write_fail'
	before writing config.status, check afterwards.
	(_AC_OUTPUT_FILES_PREPARE, _AC_OUTPUT_FILE)
	(_AC_OUTPUT_HEADERS_PREPARE,_AC_OUTPUT_CONFIG_STATUS):
	Set `ac_write_error' for write failures to config.status.  Barf
	upon write failures to temporary files.
	Adjust note about closing and reopening the here-document.
	(_AC_OUTPUT_HEADER, _AC_OUTPUT_LINK, _AC_OUTPUT_COMMAND)
	(_AC_OUTPUT_MAIN_LOOP): Likewise, adjust note about closing and
	reopening the here-document.
	* tests/torture.at (AC_CONFIG_FILES, HEADERS, LINKS and COMMANDS):
	Ensure `ac_write_error' does not escape into config.status.
	Also, add a couple of code paths not yet exercised in the test
	suite: a config file with input from stdin, and a config header
	output to stdout.
	Suggestion for catching write errors by Bruno Haible.

2007-11-17  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Avoid error with Tru64 awk and testsuite lines with many words.
	* lib/autotest/general.m4 (AT_INIT): In the awk script that
	reads the testsuite, set the field separator to an unusual value,
	in order to not run over the limit of 199 fields.  Tru64 4.0D awk
	even splits the input if $i, i>0, was never accessed in the script.

	Revert 2007-10-17 change.
	* TODO: Multiline args in config files and headers mean something
	different and are not fixed, see
	<http://lists.gnu.org/archive/html/autoconf-patches/2007-05/msg00017.html>
	Report by Stepan Kasal.

	* doc/autoconf.texi (Generic Programs): Fix typo.

2007-11-16  Stepan Kasal  <kasal@ucw.cz>

	AC_*_TOOL does not canonicalize the prefix
	* doc/autoconf.texi (Generic Programs): Do not say that
	the *_TOOL macros canonicalize, they simply use the `host_alias'.

2007-11-16  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Diagnose write errors in config.status instantiations.
	* lib/autoconf/status.m4 (_AC_OUTPUT_FILE)
	(_AC_OUTPUT_HEADER, _AC_OUTPUT_MAIN_LOOP): Bail out
	on write errors.
	* tests/torture.at (AC_CONFIG_FILES, HEADERS, LINKS and COMMANDS):
	Extend test to also check for some write error failures, using...
	<AT_CHECK_CONFIG_CREATION_NOWRITE>: ...this new macro.
	Report by Bruno Haible.

	Indentation fixups.
	* lib/autotest/general.m4 (AT_INIT) <at_func_log_failure>: Fix
	indentation.
	(_AT_CHECK): Use less indentation, to save space.

2007-11-15  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Add witness macro for @top_build_prefix@ substitution.
	* lib/autoconf/status.m4 (_AC_HAVE_TOP_BUILD_PREFIX): New macro.
	(_AC_OUTPUT_FILE): Mention it here.

2007-11-15  Paolo Bonzini  <bonzini@gnu.org>
	and Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autotest/general.m4 (at_func_test): Remove.
	(AT_INIT): Pre-extract test groups into separate files.
	(AT_CLEANUP): Source pre-extracted file instead of calling at_func_test.
	Remove at-test-source files together with the $at_group_dir.
	* tests/autotest.at (Long test source lines): New test.

2007-11-15  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Shell functions and variables may share a namespace.
	* doc/autoconf.texi (Portable Shell): Mention Solaris sh
	limitation.

2007-11-14  Paul Eggert  <eggert@cs.ucla.edu>

	* lib/autoconf/types.m4 (_AC_TYPE_LONG_LONG_SNIPPET): Make comment match
	gnulib.

2007-11-14  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autoconf/status.m4: Fix a couple of comment typos.

	* lib/m4sugar/m4sh.m4 (AS_TMPDIR): Use $as_me, not $me.

2007-11-13  Jim Meyering  <meyering@redhat.com>

	Clean up the rule to create "expr".
	* tests/Makefile.am (expr): Don't redirect directly to target.
	Redirect just once, not for each echo statement.
	Use $@, not literal "expr".

2007-11-13  Paul Eggert  <eggert@cs.ucla.edu>

	Don't worry about preprocessor when testing long long.
	See: http://lists.gnu.org/archive/html/bug-gnulib/2007-11/msg00075.html
	* doc/autoconf.texi (Preprocessor Arithmetic): New section.
	(AC_TYPE_LONG_LONG_INT, AC_TYPE_UNSIGNED_LONG_LONG_INT):
	These no longer check for preprocessor flaws.
	* lib/autoconf/types.m4 (_AC_TYPE_LONG_LONG_SNIPPET):
	Do not check for preprocessor flaws.

2007-11-13  Jim Meyering  <meyering@redhat.com>

	Adapt dependencies, now that a version change doesn't modify configure.ac
	* GNUmakefile: Remove "make clean" kludge.
	* lib/m4sugar/Makefile.am (version.m4): Depend on Makefile, not
	configure.ac.
	Don't redirect directly to target.
	Use $@, not literal "version.m4".

2007-11-12  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* doc/autoconf.texi (Making testsuite Scripts): Document
	":;{" shorthand as in previous patch.

2007-11-12  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/autoconf.texi (Limitations of Builtins): Document problem
	with { ... } a bit more clearly.  Suggest ":;{" as a shorthand
	for the workaround.
	* lib/m4sugar/Makefile.am (version.m4): Detect 'echo' failure.
	Use ":;{" shorthand.
	* tests/Makefile.am ($(srcdir)/package.m4): Likewise.

2007-11-12  Jim Meyering  <meyering@redhat.com>

	Add more non-srcdir build support.
	* GNUmakefile (dummy): Split a long line.
	Add -v option to autoreconf invocation.

	Remove the autoreconf-provided INSTALL, so that we regenerate it.
	* GNUmakefile (dummy): Remove INSTALL.

	Remove racy commands to build scripts in bin/ and tests/.
	* man/Makefile.am (.x.1): Now that scripts in bin/ and tests/
	are guaranteed to be built, remove the rules that tried to build
	them.  Before, with a parallel build, these rules could lead to
	two processes writing tests/wrapper.in concurrently.

	Build in man/ only *after* building in bin/ and tests/.
	* Makefile.am (SUBDIRS): The man-page-creation process runs $(MAKE)
	in both bin/ and tests/.

	Accommodate non-srcdir build-from-checkout.
	* build-aux/git-version-gen: Require an additional parameter: $srcdir.
	Use git's --git-dir=$srcdir/.git option.
	Add quotes, in case tarball_version_file contains shell meta-characters.
	* GNUmakefile (_curr-ver): Pass $(srcdir) to git-version-gen.
	* configure.ac: Pass "." to git-version-gen.

	Avoid spurious test failures due to version skew.
	* GNUmakefile (dummy): Run $(MAKE) clean after autoreconf -i.

2007-11-12  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Avoid warnings about conftest.dSYM directories on Mac OS X Leopard.
	* lib/autoconf/general.m4 (_AC_LINK_IFELSE, _AC_RUN_IFELSE):
	Remove conftest.dSYM directory.
	* lib/autoconf/fortran.m4 (_AC_PROG_FC_V_OUTPUT)
	(_AC_LANG_PROGRAM_C_, _AC_FC_MAIN, __AC_FC_NAME_MANGLING):
	Remove `conftest.*' recursively.
	* lib/autoconf/lang.m4 (AC_LINK_IFELSE): Likewise.
	* lib/autoconf/specific.m4 (_AC_SYS_LARGEFILE_MACRO_VALUE):
	Likewise.
	(_AC_COMPILER_OBJEXT_REJECT): Reject *.dSYM.
	* THANKS: Update.
	Report and analysis by Jeff Squyres and Peter O'Gorman.

2007-11-12  Benoit Sigoure  <tsuna@lrde.epita.fr>

	Fix typos in variable names.
	* tests/semantics.at (test for AC_CHECK_LIB): s/at_m/ac_m/.

2007-11-11  Benoit Sigoure  <tsuna@lrde.epita.fr>

	Document that $((expression)) is not portable.
	* doc/autoconf.texi (Shell Substitutions): Here.

2007-11-10  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Ignore configure --help* errors due to LINENO-impaired shells.
	* tests/torture.at (Configuring subdirectories, Deep Package):
	In the --help* tests in read-only trees, make `.' temporarily
	writable again for the `stderr' file, and ignore errors due to
	the attempt to write configure.lineno.
	Report by Patrick Welche.

2007-11-10  Jim Meyering  <meyering@redhat.com>

	Generate package.m4 in build-dir, not srcdir.
	* tests/Makefile.am (package.m4): Adjust target.
	Don't redirect directly to $@.
	(CLEANFILES): Add package.m4.
	($(TESTSUITE)): Depend on just-built package.m4, not the one
	in $(srcdir).
	When running $(AUTOTEST), search "." before searching $(srcdir).

	Avoid a race condition that would make parallel "distclean" fail.
	* tests/Makefile.am (distclean-generic): Replace the default,
	automake-provided rule with an identical one, but with an additional
	dependency on distclean-local.  Simply adding the dependency would
	cause automake not to emit the rule at all.
	* BUGS: Building with -jN works, now.

	Distribute git-version-gen.
	* Makefile.am (EXTRA_DIST): Add build-aux/git-version-gen,
	since GNUmakefile is distributed, and requires it for dist* rules.

	Remove two more generated files from version control.
	* INSTALL: Remove generated file.
	* lib/autoscan/autoscan.list: Remove generated file.

2007-11-09  Paul Eggert  <eggert@cs.ucla.edu>

	* GNUmakefile (PATH): Remove stray apostrophes; they become
	part of PATH, which isn't wanted here.

2007-11-09  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	New config files output variable `top_build_prefix'.
	* lib/autoconf/status.m4 (_AC_OUTPUT_FILE): Substitute
	`top_build_prefix'.
	* doc/autoconf.texi (Preset Output Variables): Document it.
	* NEWS: Update.
	Report by Bob Friesenhahn.

	Avoid expr for arithmetic evaluation if the shell accepts $((...)).
	* lib/autotest/general.m4 (AT_INIT) <at_func_arith>: New
	function, to parametrize arithmetic with expr vs. the shell.
	Use it where possible.
	Suggestion by Benoit Sigoure.

2007-11-03  Benoit Sigoure  <tsuna@lrde.epita.fr>

	Adjust the documentation of autotest WRT atlocal.
	* doc/autoconf.texi (Making testsuite Scripts): It is not necessary,
	when using Automake, to write a rule to produce atlocal, since it's
	an AC_CONFIG_FILES.  Mention that atlocal.in needs to be
	distributed, not atconfig.in.

2007-11-04  Eric Blake  <ebb9@byu.net>

	Update list information.
	* README: Mention new autoconf-commit list.
	* doc/autoconf.texi (Introduction): Mention autoconf-commit list.

2007-11-04  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autoconf/functions.m4 (_AC_FUNC_MALLOC_IF): Fix comment typo.

	* lib/m4sugar/Makefile.am (version.m4): Another bash bug workaround.

	* build-aux/.gitignore: Ignore mkinstalldirs.

	* doc/autoconf.texi (autoreconf Invocation): Fix an underfull line.

2007-11-03  Jim Meyering  <meyering@redhat.com>

	s/-/./ in snapshot version string: 2.61a-256-8b556 -> 2.61a.256-8b556
	* build-aux/git-version-gen: This syncs from coreutils.

	Adjust the build procedure so "make check" works reliably.
	* README-hacking: Include an extra step between "make" and
	"make check" to ensure that the latter passes.

	Use just-built tools, when possible.
	* GNUmakefile (PATH): Set and export here, ...
	(dummy): ... rather than here.

2007-11-03  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>
	and Andreas Schwab  <schwab@suse.de>

	* tests/Makefile.am ($(srcdir)/package.m4): Work around bash
	exit status bug.

2007-11-03  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* configure.ac (AC_PREREQ): Require version 2.60, for
	AC_PROG_SED, AC_PROG_GREP.

2007-11-02  Benoit Sigoure  <tsuna@lrde.epita.fr>
	and Jim Meyering  <meyering@redhat.com>
	and Andreas Schwab <schwab@suse.de>
	and Eric Blake  <ebb9@byu.net>

	Document a bug in GNU Bash with compound commands and redirections.
	* doc/autoconf.texi (Limitations of Builtins): Mention that GNU
	Bash doesn't properly set $? when `{ ... } >/bad' fails, and give
	workaround.

2007-11-03  Eric Blake  <ebb9@byu.net>

	Support m4 1.4.5 in testsuite.
	* tests/torture.at (Define a newline): Exclude line numbers in
	error message.
	Reported by Ralf Wildenhues.

2007-11-03  Jim Meyering  <meyering@redhat.com>

	Remove automake-provided files from version control.
	* build-aux/elisp-comp: Remove file.
	* build-aux/install-sh: Remove file.
	* build-aux/missing: Remove file.
	* build-aux/mdate-sh: Remove file.
	* build-aux/.gitignore: New file.
	Suggestion from Ralf Wildenhues.

2007-11-03  Eric Blake  <ebb9@byu.net>

	Adjust version comparison to account for git snapshot numbers.
	* lib/m4sugar/m4sugar.m4 (_m4_version_unletter): Also treat - as a
	component separator.
	* doc/autoconf.texi (Number processing Macros)
	<m4_version_compare>: Document this change.
	* tests/m4sugar.at (m4@&t@_version_compare): Test it.

2007-10-30  Bruno Haible  <bruno@clisp.org>

	* lib/autoconf/types.m4 (_AC_TYPE_LONG_LONG_SNIPPET): New macro,
	extracted from AC_TYPE_LONG_LONG_INT and AC_TYPE_UNSIGNED_LONG_LONG_INT.
	(AC_TYPE_LONG_LONG_INT, AC_TYPE_UNSIGNED_LONG_LONG_INT): Use it.
	Fixes problem with Sun C 5.[0-8] in 32-bit mode, reported in
	<http://lists.gnu.org/archive/html/autoconf-patches/2007-10/msg00210.html>
	Suggested by Paul Eggert.

2007-10-28  Jim Meyering  <meyering@redhat.com>

	* README-hacking: Autoconf, Automake, and Perl are required to build.
	List Gzip and Tar separately.  Suggested by Ralf Wildenhues.

2007-10-28  Jim Meyering  <meyering@redhat.com>

	README-hacking: Recommend running autoreconf -vi.
	* GNUmakefile (dummy): Use autoreconf -i, with appropriate PATH,
	so that we use just-built tools when they're available.
	Suggestions from Ralf Wildenhues.

2007-10-28  Jim Meyering  <meyering@redhat.com>

	Make inter-release --version output more useful.

	Now, each unofficial build has a version "number" like 2.61a-19-58dd,
	which indicates that it is built using the 19th change set
	(in _some_ repository) following the "v2.61a" tag, and that 58dd
	is a prefix of the commit SHA1.
	* build-aux/git-version-gen: New file.
	* configure.ac: Run it to set the version.
	(AM_INIT_AUTOMAKE): Don't check NEWS here.
	* Makefile.am (dist-hook): Arrange so that .version appears only
	in distribution tarballs, never in a checked-out repository.
	* .gitignore: Add .version here, too.  Just in case.
	* tests/Makefile.am ($(srcdir)/package.m4): Depend on Makefile,
	not configure.ac, now that the version number changes automatically.

	Ensure that $(VERSION) is up to date for dist-related targets.
	* GNUmakefile: Arrange to rerun autoconf, if the version reported by
	git-version-gen doesn't match $(VERSION), but only for dist targets.

2007-10-27  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix `Deep Package' failure with a configure script early in PATH
	* tests/torture.at (Deep Package): Add `.' early in PATH.
	Report by Jim Meyering.

2007-10-27  Jim Meyering  <meyering@redhat.com>

	Remove all generated files from version control.
	* aclocal.m4: Remove.
	* configure: Remove.
	* Makefile.in: Remove, along with all other Makefile.in in subdirs.
	* .gitignore: Add aclocal.m4, configure and Makefile.in.  Sort.
	* README-hacking: New file: how to build from just-checked-out sources.

2007-10-23  Eric Blake  <ebb9@byu.net>

	Improve corner case of m4_expand.
	* lib/m4sugar/m4sugar.m4 (m4_expand, _m4_expand): Rewrite more
	efficiently.
	* tests/m4sh.at (AS@&t@_HELP_STRING): Test overquoted comma.
	* doc/autoconf.texi (Evaluation Macros) <m4_expand>: Update
	documentation.

2007-10-23  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/make-stds.texi: Update from gnulib.

2007-10-22  Paul Eggert  <eggert@cs.ucla.edu>
	and Eric Blake  <ebb9@byu.net>

	* lib/autoconf/c.m4 (AC_C_RESTRICT): Work around Sun C++ compatibility
	problem reported by Bruno Haible in
	<http://lists.gnu.org/archive/html/bug-autoconf/2007-10/msg00027.html>.

2007-10-22  Eric Blake  <ebb9@byu.net>

	* doc/autoconf.texi (Particular Types): Mention bug in HP-UX 11.00
	preprocessor.

2007-10-22  Paul Eggert  <eggert@cs.ucla.edu>

	Don't check for bug in HP-UX 11.00 cpp.
	* lib/autoconf/types.m4 (AC_TYPE_UNSIGNED_LONG_LONG_INT):
	Use -1ull rather than -1u, since that causes problems with gnulib; see
	<http://lists.gnu.org/archive/html/bug-gnulib/2007-10/msg00329.html>.

2007-10-22  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* tests/autotest.at (Backquote command substitution)
	(Multiline backquote command substitution)
	(Parenthetical command substitution)
	(Multiline parenthetical command substitution): Fix typos in
	test names.

2007-10-21  Eric Blake  <ebb9@byu.net>

	* configure: Regenerate.

2007-10-21  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix config status generation with Tru64 ksh.
	* lib/autoconf/status.m4 (_AC_OUTPUT_FILES_PREPARE): Fix
	escaping of backslash in here-documents.

	Fix `Deep Package' test failure on FreeBSD.
	* tests/torture.at (Deep Package): Do not add `.' to $PATH
	unnecessarily.  Do not try running `/bin/sh configure' with a
	configure script to be found in $PATH, if the shell does not do
	this resolution.  Fixes test failure on FreeBSD.

	Fix config header generation with AIX awk.
	* lib/autoconf/status.m4 (_AC_OUTPUT_HEADERS_PREPARE): In awk
	script, use helper array D_is_set, as `" 0"' does not evaluate
	to true for AIX awk.

2007-10-21  Eric Blake  <ebb9@byu.net>

	* tests/autotest.at (Banners): Reinstate test, with typo
	corrected.

2007-10-20  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autotest/general.m4 (Defaults): Validate input ranges ...
	<at_func_validate_ranges>: ... using this new function.
	* tests/autotest.at (Keywords and ranges): Test invalid ranges.
	Test --list with ranges and keywords.
	(Banners): Remove one now-failing test.

2007-10-20  Eric Blake  <ebb9@byu.net>

	Fix testsuite --list subset.
	* lib/autotest/general.m4 (AT_INIT) <at_list_p>: Swap newlines
	back to spaces, before listing subset of tests.
	Reported by Ralf Wildenhues.

2007-10-19  Eric Blake  <ebb9@byu.net>

	s/parenthesis/parentheses/ where appropriate.
	* doc/autoconf.texi: Fix typos.
	* lib/m4sugar/m4sugar.m4: Likewise.
	Reported by Ralf Wildenhues.

	Document m4_expand limitation.
	* lib/m4sugar/m4sugar.m4 (m4_expand): Mention problem with
	unbalanced parse.
	* doc/autoconf.texi (Pretty Help Strings, Evaluation Macros)
	(Writing Testsuites): Mention limitations inherited from
	m4_expand.

	Improve AT_BANNER handling.
	* lib/autotest/general.m4 (BANNERS): New named diversion.
	(TESTS_END): Diversion no longer used.
	(AT_INIT) <at_func_banner, BANNERS>: Factor all banners into a
	shell function, which prints only as needed, using an associative
	array of banner text from a special diversion.
	<PARSE_ARGS_END>: No longer need awk to find banners.
	<TESTS>: Banners are no longer processed by main driver loop, so
	we no longer need case statement.
	(AT_BANNER): Rewrite to populate new diversion.
	(AT_SETUP): Each test invokes its own banner.  No output is needed
	to the TESTS diversion.
	* doc/autoconf.texi (Writing Testsuites): Document slight
	semantics change.
	* tests/autotest.at (AT_BANNERS): Enhance test.
	* NEWS: Document AT_BANNER.

	Document and test AT_BANNER.
	* doc/autoconf.texi (Writing Testsuites): Document AT_BANNER.
	* tests/autotest.at (AT_CHECK_EGREP): Share between tests.
	(AT_CHECK_BANNERS): New test.

	Doc touchups.
	* doc/autoconf.texi (Text processing Macros) <m4_strip>
	<m4_text_wrap>: Clarify and fix typos.

2007-10-18  Eric Blake  <ebb9@byu.net>

	Ignore `make dist' changelogs in testsuite.log.
	* lib/autotest/general.m4 (AT_INIT) <ChangeLogs>: Prune
	directories matching AT_PACKAGE_TARNAME-*.

	Fix AT_TESTED, AT_KEYWORDS.
	* lib/m4sugar/m4sugar.m4 (m4_append_uniq): Warn if separator
	occurs in string, as duplicates may be added.
	(_m4_append_uniq): New helper macro.
	(m4_append_uniq_w): New macro.
	* lib/autotest/general.m4 (AT_TESTED, AT_KEYWORDS): Fix
	duplication bug by using new macro.
	(AT_INIT) <at_tested>: Restore newline separators.  Invoke tested
	programs with stdin redirected, so programs that don't
	understand --version won't try to behave interactively.
	* tests/autotest.at (Tested programs): Catch this bug.
	* tests/m4sugar.at (m4@&t@_append): Test new macro.
	* tests/local.at (AT_TESTED): Add m4, perl.
	* doc/autoconf.texi (Text processing Macros): Document
	m4_append_uniq_w, and update text on m4_append.
	* NEWS: Document the addition.

2007-10-17  Eric Blake  <ebb9@byu.net>

	Function cleanup.
	* lib/autotest/general.m4 (_AT_CREATE_DEBUGGING_SCRIPT): Convert
	from m4 macro...
	(AT_INIT) <at_func_create_debugging_script>: ...to shell
	function.
	(AT_INIT): Defer function declarations until after --help,
	--version.  Format functions consistently, trying to fit in 80
	columns.
	(TEST_FUNCTIONS): Based on recent changes, rename...
	(TEST_GROUPS): ...to this.

	Reject FreeBSD m4.
	* m4/m4.m4 (AC_PROG_GNU_M4): Also check for frozen file support.
	* configure: Regenerate.
	Reported by Bob Friesenhahn.

	Test recent additions.
	* tests/m4sugar.at (m4@&t@_map, m4@&t@_combine)
	(m4@&t_max and m4@&t_min): New tests.
	* doc/autoconf.texi (Evaluation Macros) <m4_apply>: Enhance
	description.

2007-10-17  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* TODO: multiline args in config files and headers work now.

	Autotest: do not use shell functions for individual tests.
	* lib/autotest/general.m4 (AT_INIT) <at_func_test>: Merely
	extract the source test source, do not invoke it.
	(AT_SETUP, AT_CLEANUP): Source test code outside shell function.
	* tests/autotest.at (Fallacy): Actually let the inner suite fail,
	expect exit status of 1.
	* tests/autotest.at (Skip): New test, for bogus zsh exit status.

	* lib/autotest/general.m4 (at_func_test): Fix test extraction
	script.

2007-10-17  Eric Blake  <ebb9@byu.net>

	Fix m4_combine for empty suffix list.
	* lib/m4sugar/m4sugar.m4 (m4_combine): Check for suffix list.
	* doc/autoconf.texi (Text processing Macros): Document this.

	Add m4_combine, based on Libtool's lt_combine.
	* lib/m4sugar/m4sugar.m4 (m4_combine): New macro.
	* doc/autoconf.texi (Text processing Macros): Document it.
	* NEWS: Likewise.

2007-10-16  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix `configure --help=recursive' in unconfigured/read-only trees.
	* lib/m4sugar/m4sh.m4 (_AS_LN_S_PREPARE): Avoid errors when `.'
	is not writable, use 'cp -p' in this case, in the hope that it
	will not actually be needed.  Still try removing files, in case
	of other write errors.
	* lib/autoconf/general.m4 (_AC_INIT_SRCDIR): For ac_confdir,
	use $as_myself, not $0.
	(_AC_INIT_HELP): For --help=recursive, if the subdir does not
	exist, try again in the the source tree.  This change assumes
	that the subpackage configure script is capable of running
	--help=recursive in the source tree.
	* tests/torture.at (Configuring subdirectories, Deep Package):
	Adjust tests to expose both issues, also try invocation as
	`sh configure ...' and plain `configure ...' with PATH adjusted.
	* NEWS, THANKS: Update.
	Report by Hans Ulrich Niedermann.

2007-10-16  Paul Eggert  <eggert@cs.ucla.edu>

	Check for 64-bit int errors in HP-UX 10.20 preprocessor.
	Problem reported by H.Merijn Brand in
	<http://lists.gnu.org/archive/html/bug-tar/2007-10/msg00018.html>.
	* lib/autoconf/types.m4 (AC_TYPE_LONG_LONG_INT):
	(AC_TYPE_UNSIGNED_LONG_LONG_INT):
	Check that preprocessor handles 64-bit ints, too.

2007-10-16  Eric Blake  <ebb9@byu.net>

	m4_map is a looping construct.
	* lib/m4sugar/m4sugar.m4 (m4_map, _m4_map, m4_map_sep): Move.

	Fix m4_map, and add some more utility macros.
	* lib/m4sugar/m4sugar.m4 (m4_apply, m4_count, m4_dquote_elt)
	(m4_echo, m4_make_list): New documented macros.
	(_m4_quote, _m4_shift2): New helper macros.
	(m4_map): Change semantics to allow calling macro without
	arguments.
	(m4_map_sep): Likewise.  Also change semantics to quote separator,
	to match m4_join and m4_append.
	(m4_version_unletter): Fix use of m4_map.
	* doc/autoconf.texi (Evaluation Macros): Document m4_apply,
	m4_count, m4_dquote_elt, m4_echo, m4_make_list.
	(Text processing Macros): Mention m4_dquote as a faster
	alternative to joining with commas.
	(Looping constructs): Document m4_map, m4_map_sep.
	* NEWS: Mention new macros.

	A few more m4sugar improvements, to benefit libtool.
	* lib/m4sugar/m4sugar.m4 (m4_bpatsubsts, _m4_shiftn): Reduce size
	of expansion by avoiding extra uses of $@.
	(m4_shiftn): Avoid extra dnl, and forbid shifting by 0.
	(_m4_cdr): New helper macro.
	(_m4_map, m4_map_sep): Use it to reduce size of expansion.
	(_m4_shift3): New helper macro.
	(_m4_foreach): Swap argument order, and use new macro to reduce
	size of expansion.
	* doc/autoconf.texi (Looping constructs) <m4_shiftn>: Mention that
	count must be positive.

	* doc/autoconf.texi (Evaluation Macros) <m4_expand>: Fix typo.
	Reported by Ralf Wildenhues.

2007-10-15  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* doc/autoconf.texi (Portable Shell): Improve description of zsh
	4.x function subshell bug with exit and trap.

2007-10-15  Eric Blake  <ebb9@byu.net>

	Enhance AS_HELP_STRING.
	* lib/m4sugar/m4sugar.m4 (m4_text_wrap): Don't expand arguments,
	and reduce number of expansions.
	* lib/m4sugar/m4sh.m4 (AS_HELP_STRING): Rework to use m4_expand,
	and to take indent and wrap column numbers.
	* tests/m4sh.at (AS@&t@_HELP_STRING): Update the test.
	* doc/autoconf.texi (Pretty Help Strings): Document details about
	arguments.
	(Text processing Macros): Minor tweaks.
	* NEWS: Document this change.

	Fix 2007-10-03 regression with AT_SETUP([a, b]).
	* lib/m4sugar/m4sugar.m4 (m4_expand): New macro.
	(m4_text_box): Use it.
	* lib/autotest/general.m4 (AT_SETUP): Use it.
	* lib/m4sugar/m4sh.m4 (_AS_RUN): Use it.
	* tests/autotest.at (AT_CHECK_AT_TITLE_CHAR): Test this.
	* NEWS: Revert caveat about semantics change on comma.
	* doc/autoconf.texi (Evaluation Macros): Document m4_expand.

2007-10-13  Eric Blake  <ebb9@byu.net>

	Change m4_join to match libtool's ltsugar semantics.
	* lib/m4sugar/m4sugar.m4 (m4_join): Just define this, not defun.
	Ignore empty arguments, using...
	(_m4_join): ...this new helper.
	* tests/m4sugar.at (m4@&t@_join): New test.
	* doc/autoconf.texi (Text processing Macros): Document new
	semantics of m4_join.

	Make AC_PREREQ faster and more robust.
	* lib/m4sugar/m4sugar.m4 (m4_ignore, m4_unquote): New macros.
	(m4_version_prereq): Inline constant expansions.
	(m4_list_cmp): Reduce number of expansions, by avoiding m4_case.
	Rewrite in terms of [] list, not () list.
	(_m4_list_cmp, _m4_version_unletter): New helper macros.
	(m4_version_unletter): Write wrapper around new implementation to
	preserve old semantics.
	(m4_version_compare): Pass correct type of list, and avoid
	overhead of flattening expressions too early.
	(m4_do): Move to be near other quoting macros.
	(m4_max, m4_min): Always result in decimal output.
	* doc/autoconf.texi (Looping constructs): Add m4_car, m4_cdr.
	Move m4_do...
	(Evaluation Macros): ...here.  Add m4_ignore, m4_unquote.
	(Text processing Macros): Move m4_version_compare...
	(Number processing Macros): ...to this new node; document m4_cmp,
	m4_list_cmp, m4_sign, m4_max, m4_min.
	* tests/m4sugar.at (m4@&t@_version_compare): Enhance test, to pick
	up on bugs fixed by this patch.
	* NEWS: Document new macros.

2007-10-12  Eric Blake  <ebb9@byu.net>

	* doc/autoconf.texi (Text processing Macros): Fix bad merge.
	(Reporting Messages): Fix underfull hbox.

	Some more m4sugar documentation.
	* lib/m4sugar/m4sugar.m4: Clean up macro order.
	* doc/autoconf.texi (Programming in M4): Lighten the warning on
	using m4sugar; it is stabilizing and useful.
	(Redefined M4 Macros): Touch up wording on M4 builtins; sort.  Add
	m4_divert, m4_undivert, __file__, __line__, __oline__.
	(Diagnostics): New node, documenting m4_assert, m4_errprintn,
	m4_fatal, m4_location, m4_warn.
	(Diversion support): New node, documenting m4_divert_push,
	m4_divert_pop, m4_divert_text, m4_divert_once.
	(Text processing Macros): Sort.  Add m4_flatten, m4_join,
	m4_newline, m4_strip, m4_text_box, m4_text_wrap.
	(Reporting Messages): Mark AC_DIAGNOSE, AC_WARNING, and AC_FATAL
	as obsolescent.
	(Printing Messages): Change cross-reference.

	Document interaction of recent m4_append change with Libtool HEAD.
	* lib/m4sugar/m4sugar.m4 (m4_append): Document semantics change.
	(m4_append_uniq): Add new parameters, based on lt_append_uniq.
	* tests/m4sugar.at (m4@&t@_append): New test.
	* NEWS: Document semantics change.
	* doc/autoconf.texi (Text processing Macros): Likewise.

	s/AC_VERSION/AC_AUTOCONF_VERSION/.
	* doc/autoconf.texi (Versioning): Change the name.
	* NEWS: Likewise.
	* lib/autoconf/general.m4 (AC_AUTOCONF_VERSION): Likewise.
	* tests/tools.at (autoconf: AC_AUTOCONF_VERSION): Likewise.
	Suggested by Ralf Wildenhues.

	Namespace cleanup.
	* lib/autoconf/status.m4 (_AC_OUTPUT_FILES_PREPARE)
	(_AC_OUTPUT_HEADERS_PREPARE): Convert here-doc delimiters into
	autoconf namespace.
	* doc/autoconf.texi (Programming in M4sugar, Forbidden Patterns)
	(Programming in M4sh, Macro Names): Beef up description of
	namespaces reserved for autoconf.
	* configure: Regenerate.

2007-10-12  Eric Blake  <ebb9@byu.net>
	and Paolo Bonzini  <bonzini@gnu.org>

	Speed up execution of subset of testsuite.
	* lib/autotest/general.m4 (TEST_FUNCTIONS): New diversion.
	(AT_INIT) <at_func_test>: New shell function.
	(AT_INIT) <at_myself>: New variable, set to absolute $as_myself.
	(AT_INIT) <at_test_source> New variable, names file that holds
	current test function definition.
	(AT_SETUP): Start the shell function at_func_test_#, into the
	TEST_FUNCTIONS diversion.
	(AT_CLEANUP): End the shell function.  Simplify the TESTS
	diversion to invoke the function.

2007-10-11  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* .gitignore: Ignore tags and TAGS files.

2007-10-11  Eric Blake  <ebb9@byu.net>

	Config header generation followup.
	* lib/autoconf/general.m4 (_AC_DEFINE_Q): Check for raw newlines,
	which won't work with the preprocessor nor with the awk
	implementation.
	* tests/torture.at (Define a newline): Test raw newline detection,
	removing the XFAIL.
	* doc/autoconf.texi (Defining Symbols): Document recent change to
	allow backslash-newline.
	* THANKS: Update.

2007-10-11  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* lib/autotest/general.m4: Put function braces in separate line.

2007-10-10  Eric Blake  <ebb9@byu.net>

	Avoid some overhead from m4_defn and m4_popdef.
	* lib/m4sugar/m4sugar.m4 (m4_defn, m4_popdef, m4_undefine): Only
	pass on first argument, since we are documented that way.
	(m4_for, m4_append_uniq, m4_text_wrap): Optimize out defined-ness
	check where it is safe to do so.
	(m4_append): Likewise, and quote the separator.
	(m4_text_box): Likewise, and avoid regex, also be robust to
	expansion and quadrigraphs.

	Another AC_DEFINE speedup.
	* lib/autoconf/general.m4 (AC_DEFINE_TRACE): Move parameter
	elision...
	(_AC_DEFINE_Q): ...here, and only do it once.
	* lib/autoconf/functions.m4 (AC_CHECK_FUNCS): Avoid overquoting.
	* lib/m4sugar/m4sh.m4 (AS_LITERAL_IF): Fix m4_defn overquoting
	introduced 2007-10-05.

	Whitespace cleanup.
	* lib/autoconf/general.m4: Use consistent indentation.
	* configure: Regenerate.

	* NEWS: Announce recent round of speed optimizations.

2007-10-10  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* NEWS: Announce shell function usage in Autotest.

2007-10-10  Eric Blake  <ebb9@byu.net>
	and Paul Eggert  <eggert@cs.ucla.edu>

	Reduce number of forks at startup.
	* lib/m4sugar/m4sh.m4 (AS_SHELL_SANITIZE): Speed up NLS
	sanitization.
	* configure: Regenerate.

2007-10-10  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>
	and Paul Eggert  <eggert@cs.ucla.edu>

	Use awk for config header generation.
	* lib/autoconf/status.m4 (_AC_OUTPUT_FILES_PREPARE): Fix comments.
	(_AC_OUTPUT_HEADERS_PREPARE): New macro.  Rewrite of the config
	header machinery for use with awk and placement outside the main
	config.status instantiation loop.  Retain multi-line defines
	through backslash-newline combinations, do not split the script
	any more.
	(_AC_OUTPUT_HEADER): Simplify accordingly, use $AWK.
	(_AC_OUTPUT_MAIN_LOOP): Call _AC_OUTPUT_HEADERS_PREPARE if
	needed.
	(AC_OUTPUT_MAKE_DEFS): Remove backslash-newline combinations
	from define values.
	* NEWS: Update.
	* tests/torture.at (#define header templates): Extend test by
	several more cases: white space before and after `#', macros
	with parameters in config.hin and as defines, multi-line macro
	values.
	(Torturing config.status): Use a define value twice the length
	in order to exercise the awk literal string limit.
	(Substitute and define special characters): Also try special
	delimiter, to exercise the special-case code.
	Suggestion by Eric Lemings.

2007-10-10  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* tests/local.at (AT_COPYRIGHT): Bump copyright years.

2007-10-09  Eric Blake  <ebb9@byu.net>

	Improve header of bin/autoconf.
	* lib/m4sugar/m4sh.m4 (AS_INIT): Add a 'generated from' notice.
	* lib/autoconf/general.m4 (_AC_INIT_NOTICE): Override new notice
	from M4sh.
	* bin/autoconf.as: Put copyright up front in generated file.

	* bin/autoconf.as (exit_missing_arg): Font-lock tweak.

2007-10-09  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* doc/install.texi (Basic Installation): Document `uninstall'.
	* INSTALL: Regenerate.
	Suggestion by Roberto Bagnara.

2007-10-08  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/autoconf.texi (Limitations of Usual Tools): V7 awk had 'index'.

	Adjust doc. to match latest gnulib.
	* build-aux/texinfo.tex: Sync from gnulib.
	* doc/standards.texi: Likewise.
	* doc/autoconf.texi (Copying This Manual): Rename to "GNU Free
	Documentation License" and remove the subsection.  This simplifies
	the manual a bit and is more like what other GNU projects do
	nowadays.

2007-10-08  Eric Blake  <ebb9@byu.net>

	Use recent changes.
	* configure: Regenerate.

	Fix regression in m4_text_wrap from 2007-10-05.
	* lib/m4sugar/m4sugar.m4 (m4_max, m4_min): New macros.
	(m4_sign): Sort.
	(m4_text_wrap): Fix off-by-one error in rewrite from m4_for to
	m4_format.
	* lib/autotest/general.m4 (AT_SETUP): Avoid negative width.
	* tests/autotest.at (Long test title, Longer test title): Test
	this fix, beyond what AS_HELP_STRING already tests.

	Avoid m4 warnings on bad m4_format usage.
	* lib/m4sugar/m4sugar.m4 (m4_text_wrap): Use %*s, in case width
	evaulates to 0.
	* lib/autotest/general.m4 (AT_SETUP): Likewise; also ensure that
	enough arguments are provided.

2007-10-06  Paolo Bonzini  <bonzini@gnu.org>

	* doc/autoconf.texi (Shell portability): Document shell function
	portability.

2007-10-06  Paolo Bonzini  <bonzini@gnu.org>

	* lib/autotest/general.m4 (AT_INIT): Add at_func_diff_devnull,
	at_func_check_skip, at_func_check_status, at_func_filter_trace,
	at_func_log_failure shell functions.  Use test -s to avoid
	useless diff invocations.
	(at_func_check_newline): Renamed from at_check_newline.
	(AT_SETUP): Define AT_captured_files to empty.
	(AT_DIFF_STDERR(*), AT_DIFF_STDOUT(*)): New, extracted from _AT_CHECK.
	(_AT_CHECK): Replace m4_case with m4_ifdef/m4_indir.  Use all
	the shell functions.

2007-10-05  Paul Eggert  <eggert@cs.ucla.edu>

	Don't assume "." is writeable, for commands like "autoconf --version".
	* lib/m4sugar/m4sh.m4 (_AS_PATH_SEPARATOR_PREPARE): Use a
	different heuristic instead, one that doesn't rely on creating
	files.

	* lib/autoconf/general.m4 (_AC_INIT_PARSE_ARGS): Handle "///"
	correctly.

2007-10-05  Jim Meyering  <meyering@redhat.com>

	Avoid makeinfo warnings.
	* doc/autoconf.texi (Redefined M4 Macros): Add a `,' after @xref.
	(Looping constructs): Add ` ' after @defmac'd name, m4_do.

2007-10-05  Eric Blake  <ebb9@byu.net>

	Resolve Python issue 1676135 regarding configure directory args.
	* lib/autoconf/general.m4 (_AC_INIT_PARSE_ARGS): Strip trailing
	slashes from directory arguments.
	* tests/base.at (configure directories): New test.
	* doc/autoconf.texi (Installation Directory Variables): Document
	the change.
	* NEWS: Likewise.
	* THANKS: Update.
	Reported by Björn Lindqvist.

	Provide better short-circuiting operation.
	* lib/m4sugar/m4sugar.m4 (m4_cond, m4_newline): New macros.
	(m4_text_wrap): Use it.  Also avoid useless m4_for.
	* lib/m4sugar/m4sh.m4 (_AS_QUOTE_IFELSE, AS_LITERAL_IF): Use
	new macro.
	(_AS_IDENTIFIER_IF): Likewise, and fix bug when $1 is [,].
	* lib/autotest/general.m4 (_AT_DECIDE_TRACEABLE): Use new macros
	to avoid regexps.
	* doc/autoconf.texi (Redefined M4 Macros): Expand m4_if
	documentation.  Sort m4_mkstemp, m4_undefine.  Move m4_ifndef...
	(Conditional constructs): ...here, to new section.  Also document
	m4_cond, m4_ifval, m4_n, m4_ifvaln, m4_ifset, m4_case, m4_bmatch,
	m4_bpatsubsts, and m4_default.
	(Looping constructs): Document m4_shiftn, m4_shift2, m4_shift3,
	m4_do.

2007-10-04  Eric Blake  <ebb9@byu.net>

	Fix recent testsuite failures.
	* lib/autotest/general.m4 (AT_INIT, AT_SETUP): Double-quote text
	that must not be re-expanded after AS_ESCAPE.
	* lib/m4sugar/m4sh.m4 (_AS_IDENTIFIER_IF): Don't expand $1 when
	checking if it is an identifier.

	Whitespace cleanup.
	* lib/autotest/general.m4 (_AT_CREATE_DEBUGGING_SCRIPT): Avoid
	leading whitespace, as it caused space-tab in testsuite.
	(AT_INIT): Avoid trailing newlines in testsuite.

	One more round of m4_foreach_w speedups.
	* lib/m4sugar/m4sugar.m4 (m4_flatten): Only use regex if newline
	is present.
	(_m4_split): Avoid useless expansions inside definition.  Move
	argument defaulting...
	(m4_split): ...here.  Change alternate quote to something less
	likely to appear in $1.  Also, special case space as regexp...
	(m4_foreach_w): ...to avoid regexp on single-term list.
	(m4_default, m4_defn, m4_popdef, m4_undefine, _m4_foreach): Avoid
	useless expansions inside definition.
	* tests/m4sugar.at (m4@&t@_split): Add tests.

2007-10-04  Paolo Bonzini  <bonzini@gnu.org>

	* general.m4 (AT_INIT): Add at_check_newline function.
	(_AT_DECIDE_TRACEABLE): Include at_traceon test, use shell function.
	(_AT_CHECK): Don't use at_trace_this.

2007-10-04  Paolo Bonzini  <bonzini@gnu.org>

	Fix previous commit.
	* lib/autotest/general.m4 (AT_LINE): Fix regex.

2007-10-04  Eric Blake  <ebb9@byu.net>

	Speed up building testsuites.
	* lib/autotest/general.m4 (AT_LINE): Only use regex when file
	changed since last time.  Use simpler regex.

2007-10-03  Eric Blake  <ebb9@byu.net>

	Optimize checking for identifiers.
	* lib/m4sugar/m4sh.m4 (AS_IDENTIFIER_IF, _AS_IDENTIFIER_IF): New
	macros, more efficient than regex on m4_re_word.
	* lib/autoconf/general.m4 (AC_SUBST, AC_DEFINE_TRACE_LITERAL):
	Rewrite in terms of new macro.  As a side-effect, AC_DEFINE can
	now use @&t@.
	* configure: Regenerate.

	Remove some XFAILs, and make AT_SETUP output line up.
	* lib/autotest/general.m4 (AT_SETUP): Only expand description
	once; thereafter, use its expansion, properly quoted.
	* tests/autotest.at (AT_CHECK_AT_TITLE): Also check macro
	expansion with arguments, and check for aligned output.
	(AT_CHECK_AT_TITLE_CHAR): Remove XFAILs for tests that now pass.
	Add a test for macros with parameters.
	* NEWS: Document the semantics change.
	* tests/base.at: Fix test titles containing commas.
	* tests/compile.at: Likewise.
	* tests/tools.at: Likewise.
	* tests/torture.at: Likewise.

	Another round of regex avoidance.
	* lib/m4sugar/m4sugar.m4 (m4_cr_alnum, m4_cr_all)
	(_m4_define_cr_not, m4_cr_not_letters, m4_cr_not_LETTERS)
	(m4_cr_not_Letters, m4_cr_not_digits, m4_cr_not_alnum)
	(m4_cr_not_symbols1, m4_cr_not_symbols2): New macros, implementing
	character ranges useful in m4_translit.
	(m4_toupper, m4_tolower): Optimize the constant portion of
	definition.
	* lib/m4sugar/m4sh.m4 (AS_LITERAL_IF): Also reject @S|@ because it
	creates $, and reject [] thanks to AS_TR_SH rewrite.
	(AS_TR_SH, AS_TR_CPP): Use just translit, not bpatsubst.
	(AS_ESCAPE): Factor...
	(_AS_ESCAPE): ...into new macro, with second argument required.
	Avoid regex in common case.
	(_AS_QUOTE): Use new macro.

	Whitespace cleanup.
	* lib/autoconf/types.m4: Avoid space-tab.
	* lib/m4sugar/m4sh.m4: Use tab consistently.

2007-10-03  Paul Eggert  <eggert@cs.ucla.edu>

	* lib/m4sugar/m4sugar.m4 (m4_shift2, m4_shift3): New macros.
	(m4_shiftn): Remove no-longer-needed optimization.  Perhaps we
	should remove m4_shiftn entirely?
	(m4_case, b4_bmatch, m4_map_sep, m4_bpatsubsts, m4_join):
	Prefer m4_shift2 and m4_shift3 to m4_shiftn.
	* lib/autoconf/lang.m4 (_AC_LANG_DISPATCH): Likewise.
	* lib/m4sugar/m4sh.m4 (AS_CASE, AS_IF): Likewise.
	* tests/autotest.at (AT_CHECK_AT_TEST): Likewise.

2007-10-03  Eric Blake  <ebb9@byu.net>

	Comment touchups.
	* lib/m4sugar/m4sugar.m4: Grammar fixes in comments.

2007-10-02  Eric Blake  <ebb9@byu.net>

	Optimize appending text.
	* lib/m4sugar/m4sugar.m4 (m4_append_uniq): Use index, not regular
	expressions.

	Optimize recursion.
	* lib/m4sugar/m4sugar.m4 (m4_shiftn): This macro is called in a
	lot of hot spots; optimize it for 2 and 3 shifts.

	Optimize AC_PREREQ and other m4sugar numerics.
	* lib/m4sugar/m4sugar.m4 (m4_sign): Write with m4_eval.
	(m4_cmp): Compare arbitrary expressions, without overflow.
	(m4_version_unletter): Also recognize capital letters.
	(m4_version_compare): Avoid regex when splitting version number
	string.

2007-10-01  Eric Blake  <ebb9@byu.net>

	Once again, reject IRIX m4.
	* m4/m4.m4 (AC_PROG_GNU_M4): Use indir builtin to root out non-GNU
	implementations that ignore --trace.
	* configure: Regenerate.
	Reported by Ralf Wildenhues.

	Fix regression in AC_DEFINE([macro(with_arg)]).
	* lib/autoconf/general.m4 (AC_DEFINE_TRACE): Don't chop off close
	quotes with a careless m4_substr.

2007-09-30  Eric Blake  <ebb9@byu.net>

	Allow nameless iteration.
	* lib/m4sugar/m4sugar.m4 (m4_for, _m4_for): Access variable
	indirectly.
	* tests/m4sugar.at (myvar): Test this.

2007-09-29  Eric Blake  <ebb9@byu.net>

	Speed optimization: avoid m4 regex when other algorithms work.
	* lib/m4sugar/m4sh.m4 (AS_LITERAL_IF): Rewrite without regex.
	(_AS_QUOTE_IFELSE): Likewise.
	* lib/m4sugar/m4sugar.m4 (m4_strip): Reduce from 3 to 2 regex.
	(m4_bpatsubsts): Split...
	(_m4_bpatsubsts): ...so that recursion can avoid patsubst on empty
	regex.
	(_m4_divert()): Define, to avoid m4 warning on `m4_divert'.
	(m4_qlen): Optimize on short strings, to avoid regex.
	(m4_sign): Avoid regex, and fix bug with `01' and `-0'.
	* lib/autoconf/general.m4 (AC_CACHE_VAL): Rewrite without regex.
	(AC_DEFINE_TRACE): Likewise.

2007-09-28  Eric Blake  <ebb9@byu.net>

	Oops - my earlier 'optimization' caused a regression.
	* tests/local.at (AT_CHECK_M4): Fix typo.

2007-09-27  Eric Blake  <ebb9@byu.net>
	and Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Catch even more common AC_CACHE_VAL mistakes.
	* lib/autoconf/general.m4 (AC_CACHE_VAL): Warn if cache variable
	lacks '_cv_', or if AC_SUBST appears in body.
	* tests/base.at (AC_CACHE_CHECK): Test this change.

2007-09-27  Stepan Kasal  <kasal@ucw.cz>
	and Eric Blake  <ebb9@byu.net>

	Autotest no longer caters to Ultrix redirection limitation.
	* doc/autoconf.texi (Writing testsuite.at): Remove the
	limitation that the first parameter of AT_CHECK cannot
	contain redirection.
	(File Descriptors): Mention that Ultrix limitation is no longer a
	show-stopper in modern code.
	* tests/local.at (AT_CHECK_M4): Fix for cases when the fourth
	parameter is `stderr' or `experr'.  Optimize if it was `ignore'.
	* lib/autotest/general.m4 (AT_CHECK): Update comment.

2007-09-27  Eric Blake  <ebb9@byu.net>

	Squelch changeword in m4sugar.
	* lib/m4sugar/m4sugar.m4 (changeword): Disable this experimental
	feature of m4 1.4.x.

	Configure whitespace touchups.
	* lib/autoconf/general.m4 (_AC_INIT_HELP): Fix alignment of
	installation directories, and avoid TAB, in configure --help
	output.
	* configure.ac: Avoid extra trailing newline.
